cmz   22/10/2000    by penghp
        SUBROUTINE TOFPID(I,IFLAG,Ipero)
********************************************************
*   This subroution is used to identify pi/k/p using   *
* TOF information, for Tqual for certain values will   *
* be used.                                             *
*   The TOF time offset is corrected by TOFFSIG for    *
* different particle hoporperses. and TOFFSIG also get *
* time resolution for all particles.                   *
*   The detector performance may change according      *
* to time and the reconstruction version. so the       *
* ROUTINE for correcting TOF is use for J/psi data     *
* collected  at 99-00 and reconstruction Version 102.  *
*    The subroutines TOFFSIGMC018, TOFFSIGMC019 and    *
* TOFFSIGMC020  are used to do correction  the TOF     *
* time and get resolution for the MC data of all kinds *
* of particles, they are correspond to the first run   *
* set of 24M j/psi data, the second run set of 27M     *
* j/psi data and all 50M j/psi data respectively       *
*                                                      *
* Input  : I     : the track #                         *
*          Ipero : the flag of MC data for different   *
*                  run  set                            *
*                  1---the first run set of 24M j/psi  *
*                  2---the second run set of 27M j/psi *
*                  3---the totly 50M j/psi             *
*                 if the MC. data is simulate the first*
*                 run set of 24M j/psi data ipero=1    *
*                                                      *
* Output : IFLAG ,the identify result                  *
*             1-for kaon,2-for pion,3-for proton       *
*             0-out the 3 sigma                        *
*          /COMMON/TOFWGT, all kind of particles wgt   *
*          XPIK WTK/(WTPI+WTK),varible recommmended    *
*          to cut on pi/k seperation                   *
*                                                      *
*  Author:  Peng Haiping  (USTC)                       *
*           Li Haibo      (IHEP)                       *
*******************************************************
      INCLUDE 'tofwgt.inc'
      INCLUDE 'trklst.inc'
      INCLUDE 'evlst.inc'
         INTEGER I,IFLAG
         REAL emass(3),TOFW(3)
         REAL TOFCUT1,TOFQUALA(5)
         INTEGER IDGDTOF
         DATA TOFCUT1/900.0/
         DATA emass/0.4937,0.1396,0.938/
         DATA TOFQUALA/1.0,2.0,7.0,8.0,10.0/
         DO 10 J=1,3
          TOFW(J)=0
 10      CONTINUE
         IFLAG=0
C................................TOFID
C....FOR WILL USE THE INFORMATIN OF MON,PATH,TIME,CHARG,
C....THEN DENAND ISUB1,ISUB3,ISUB4 MUST HAVE INFORMATION.
        ISUB1=TRKSUB(1,I)
        ISUB4=TRKSUB(4,I)
        ISUB3=TRKSUB(3,I)
        IF(ISUB1.LE.0)GOTO 50
        IF(ISUB4.LE.0)GOTO 50
        IF(ISUB3.LE.0)GOTO 50
        TQUAB=TRK(ISUB4+8)
        IDGDTOF=0
c......tof quality require..........
        DO ICHE=1,5
          IF(TQUAB.EQ.TOFQUALA(ICHE))IDGDTOF=1
        ENDDO
        if(IDGDTOF.eq.0)goto 50
        PMON=TRK(ISUB3+7)
        PZ=TRK(ISUB3+6)
        COSZ=PZ/PMON
        TQQ=TRK(ISUB4+7)
        ITT=ITRK(ISUB4+3)
        ICHARG=ITRK(ISUB1+4)
C.....ONLY THE BARREL TOF INFORMATION CAN BE USED
        IF(ITT.EQ.0.OR.ITT.GT.48)GOTO 50
        DO J=1,3
          TIME=TRK(ISUB4+4)
C.....FOR THE REAL DATA..............
          IF(IRUN.Ge.13690.AND.IRUN.LE.16836)THEN
           CALL TOFFSIG(1,J,PMON,COSZ,TQQ,ITT,ICHARG,TOFF,TSIG)
          ENDIF
          IF(IRUN.Ge.17009.and.IRUN.LE.19149)THEN
           CALL TOFFSIG(2,J,PMON,COSZ,TQQ,ITT,ICHARG,TOFF,TSIG)
          ENDIF
C.....FOR THE MC. DATA...........
          IF(IRUN.LE.0)THEN
           IF(IPERO.EQ.1)THEN
            CALL TOFFSIGMC018(J,PMON,COSZ,TQQ,ITT,ICHARG,TOFF,TSIG)
           ELSE IF(IPERO.EQ.2)THEN
            CALL TOFFSIGMC019(J,PMON,COSZ,TQQ,ITT,ICHARG,TOFF,TSIG)
           ELSE IF(IPERO.EQ.3)THEN
            CALL TOFFSIGMC020(J,PMON,COSZ,TQQ,ITT,ICHARG,TOFF,TSIG)
           ELSE
            PRINT *,'***TOFPID HAVE SOME PROBLEM, THE INPUT PARA HAVE
     &              SOME PROBLEM**'
            STOP
           endif
          ENDIF
        if(icharg.eq.1) then
          xtime(j) = TIME
          xtimeoff(j) = TOFF
          TIME=TIME-TOFF
          PMON=TRK(ISUB3+7)
          BETAA=PMON/SQRT(PMON**2+eMASS(J)**2)
          PATH=TRK(ISUB4+14)
          TEXP=PATH/BETAA/0.3
          xtimee(j) = TEXP
          xtimesig(j) = TSIG
          DTAT=TIME-TEXP
          TOFW(J)=(DTAT/TSIG)**2
        else
          ytime(j) = TIME   
          ytimeoff(j) = TOFF  
          TIME=TIME-TOFF
          PMON=TRK(ISUB3+7)
          BETAA=PMON/SQRT(PMON**2+eMASS(J)**2)
          PATH=TRK(ISUB4+14)
          TEXP=PATH/BETAA/0.3
          ytimee(j) = TEXP   
          ytimesig(j) = TSIG 
          DTAT=TIME-TEXP
          TOFW(J)=(DTAT/TSIG)**2
        endif
        ENDDO
        IF(TOFW(1).LE.TOFW(2).AND.TOFW(1).LE.TOFW(3).AND.
     &                               TOFW(1).LE.TOFCUT1)IFLAG=1
        IF(TOFW(2).LE.TOFW(1).AND.TOFW(2).LE.TOFW(3).AND.
     &                               TOFW(2).LE.TOFCUT1)IFLAG=2
        IF(TOFW(3).LE.TOFW(2).AND.TOFW(3).LE.TOFW(1).and.
     &                               TOFW(3).LE.TOFCUT1)IFLAG=3

        TOFWTK=EXP(-0.5*TOFW(1)**2)
        TOFWTPI=EXP(-0.5*TOFW(2)**2)
        TOFWTP=EXP(-0.5*TOFW(3)**2)
        PROBK=PROB(TOFW(1),1)
        PROBPI=PROB(TOFW(2),1)
        PROBP=PROB(TOFW(3),1)
c        XPIK=TOFWTK/(TOFWTK+TOFWTPI)
 50    CONTINUE
        RETURN
        END

c**************************************************
      subroutine besior(iirun,iorarg)    
c**************************************************
      integer iorarg(10),usearg(10)
      common/usearg/usearg  
      do i=1,10
        usearg(i) = iorarg(i)
      end do
c   
c   iorarg(1-10) are transferred to besevn   
c
      call beshis
      return    
      end   
c**************************************************
      subroutine besevn(iirec,evnarg)
c****************************************************
* iorarg                                            *
*        (3-10) = cuts used in besel*               *
c****************************************************
c
      include 'rawdat.inc'
      include 'trklst.inc'  
      include 'evlst.inc'   
      include 'trk5pt.inc'  
      include 'nsquid.inc'  
      include 'ppp.inc'
      integer evnarg(10),need(10)
      common/usearg/usearg  
      integer usearg(10)
c
czj      if( usearg(1).eq.0.and.usearg(2).eq.0.and.
czj     &    usearg(3).eq.0 ) return
c
c        do the following things only for 'not bad' event
      if( nchrgx.ne.0.or.tottks.le.1 ) return
      if( irun.le.15200 ) return
c
*
*        event selection and statistics
*   
      do in=1,10
        need(in)=0
      end do
      call besel4(iirec,need(4))
*
*        physics analysis
*
c   note! the following is only used in one kind of readily selected 
c   events (not mixed selection), otherwise do analysis in besel* !
c
c----------------------------------------------------------------
c        log out event
      if ( usearg(1).eq.1 ) then
        if( need(1).gt.0.or.need(4).gt.0 ) then
          call evlog(istat)
        endif
      endif
c
      return    
      end   
c
c**************************************************
      subroutine beseor(iirun,eorarg)    
c**************************************************
c
      include 'rawdat.inc'
      include 'trklst.inc'  
      include 'evlst.inc'   
      include 'trk5pt.inc'  
      include 'nsquid.inc'  
      include 'ppp.inc'
      include 'pawc.inc'
      include 'tofwgt.inc'
      include 'partid.inc'
      integer eorarg(10)
      common/usearg/usearg(10)  
      integer usearg
c
      call hisout
c
      return    
      end   
c
c**************************************************
      subroutine besel4(iirec,ndsel)
c*******************************************************************
c   
c     bes evt. selection 4 ( J/Psi --> K+,K-,gamma )
c                                                               
c                                                S. Jin  93-03-12
c                               Modified by  Guo Zijin   99-07-19    
c*******************************************************************
c     
      include 'rawdat.inc'
      include 'trklst.inc'  
      include 'evlst.inc'   
      include 'ectof.inc'   
      include 'runprm.inc'   
      include 'trk5pt.inc'  
      include 'nsquid.inc'  
      include 'ppp.inc'
      include 'pawc.inc'
      include 'tofwgt.inc' 
      include 'partid.inc'
c
      common/usearg/usearg  
      integer usearg(10)
c
      logical newsquid
      logical oksq
      external newsquid
      external vmax,vmin,lvmin,theta12,phi12,phi
      integer*4 ivs
      integer*4 rc,npart,nres,pspec(4,20),pmem(20),mem(20)
      real*4 pfit(4,20),mass(20),mres(20)
      dimension var_cut(69)
      dimension escn(20),scfx(20),scfy(20),scfz(20),
     *          scosx(20),scosy(20),scosz(20),rscf(20),rscd(20),
     *          thdf(20),thmf(20),thmd(20),idg(20),
     *          thpf1(20),thpd1(20),thpf2(20),thpd2(20),
     *          phih(20),phif(20),phid(20),phdh(20),phdf(20),
     *          phhf(20),phmh(20),phmf(20),phph1(20),phph2(20),
     *          phpf1(20),phpf2(20),phpd1(20),phpd2(20),thvf(20),
     *          nscl(20),nfscl(20),ntht(20),wmax(20),width(6)
      dimension escn_g(20),
     *          scfx_g(20),scfy_g(20),scfz_g(20),
     *          scosx_g(20),scosy_g(20),scosz_g(20),
     *          rscf_g(20),rscd_g(20),cos_g(10),
     *          thdf_g(20),thmf_g(20),thmd_g(20),idg_g(20),
     *          thpf1_g(20),thpd1_g(20),thpf2_g(20),thpd2_g(20),
     *          phif_g(20),phdh_g(20),phdf_g(20),
     *          phmh_g(20),phmf_g(20),phph1_g(20),phph2_g(20),
     *          phpf1_g(20),phpf2_g(20),phpd1_g(20),phpd2_g(20),
     *          thvf_g(20),thvfcm_g(20),thvfcm1_g(20),
     *          nscl_g(20),nfscl_g(20)
      dimension chi2_g(20),pfg_g(20),phmg_f(20),thmg_f(20),
     *          thvg_f(20),fmkk(20),rq2mg_f(20),cosg_f(20),
     *          epms_f(20),cospf1_cm(20),cospf2_cm(20),
     *          fmgk1(20),fmgk2(20)
      dimension scfx_sg(20),scfy_sg(20),scfz_sg(20),rscf_sg(20),
     *          escn_sg(20),idg_sg(20),nscl_sg(20),nfscl_sg(20)
      dimension rq2mf(20),rq2md(20),rq2mf_g(20),rq2md_g(20)
      dimension chi2_p(200),api0_p(200),rmgg_p(200),rmdif_p(200),
     *          api0_cm(200),thgg_p(200),egdif_p(200),
     *          chi2_p1(200),chi2_p2(200),chi2_p3(200),
     *          chi2_p4(200),chi2_p5(200),chi2_p6(200),
     *          chi2_p7(200),chi2_p8(200),chi2_p9(200),
     *          rmpi01(200),rmpi02(200),rmpi03(200),
     *          rmpi04(200),rmpi05(200),rmpi06(200),
     *          rmpi07(200),rmpi08(200),rmpi09(200),
     *          rmkk07(200),rmkk08(200),rmkk09(200),
     *          rmks107(200),rmks108(200),rmks109(200),
     *          rmks207(200),rmks208(200),rmks209(200)
c
      real rmpi0,ppi0(4),plab1(4),plab2(4),pcm1(4),pcm2(4)
      real plabpp1(4),plabpp2(4),pcmpp1(4),pcmpp2(4),pp_cm(4),
     *     p_cmpp1(4),p_cmpp2(4)
      real plabjsi(4),pcmjsi(4)
      real plabg(4),pcmg(4),thmfcm_g(20),thpf1cm_g(20),thpf2cm_g(20),
     *     phmfcm_g(20)
      integer pid1,pid2
c
      real thetv1(20),thetv2(20),thetam(20),phim(20)
      real ppx1(20),ppy1(20),ppz1(20),ee1(20),amass1(20)
      real ppx2(20),ppy2(20),ppz2(20),ee2(20),amass2(20)
      real ppx3(20),ppy3(20),ppz3(20),ee3(20),amass3(20)
c
      rmprton=0.93827
      rmkoan=0.4936
      rmpi=0.1396
      rmpi0=0.13497
c   initialize imod,imod_g
      do i=1,20
        idg(i)=0
        idg_g(i)=0
      end do
c   initialize var_cut,escn,scfx,scfy,scfz,...
c
c   initialize cos_g
      do i=1,10
        cos_g(i)=2.0
      end do
      do j=1,20
        chi2_g(j)=200000.0
        cosg_f(j)=2.0
        cospf1_cm(j)=2.0
        cospf2_cm(j)=2.0
        nscl(j)=0
        ntht(j)=0
        wmax(j)=0.0
        nfscl(j)=100
        nscl_g(j)=0
        nfscl_g(j)=100
        nscl_sg(j)=0
        nfscl_sg(j)=100
      end do
      do k=1,200
        chi2_p(k) =2000000.0
        chi2_p1(k)=2000000.0
        chi2_p2(k)=2000000.0
        chi2_p3(k)=2000000.0
        chi2_p4(k)=2000000.0
        chi2_p5(k)=2000000.0
        chi2_p6(k)=2000000.0
        chi2_p7(k)=2000000.0
        chi2_p8(k)=2000000.0
        chi2_p9(k)=2000000.0
        rmpi01(k) =2000000.0
        rmpi02(k) =2000000.0
        rmpi03(k) =2000000.0
        rmpi04(k) =2000000.0
        rmpi05(k) =2000000.0
        rmpi06(k) =2000000.0
        rmpi07(k) =2000000.0
        rmpi08(k) =2000000.0
        rmpi09(k) =2000000.0 
        rmkk07(k) =2000000.0                   
        rmkk08(k) =2000000.0                   
        rmkk09(k) =2000000.0         
        rmks107(k) =2000000.0                   
        rmks108(k) =2000000.0                   
        rmks109(k) =2000000.0         
        rmks207(k) =2000000.0                   
        rmks208(k) =2000000.0                   
        rmks209(k) =2000000.0         
        api0_p(k) =2000000.0
        api0_cm(k)=2000000.0
        rmdif_p(k)=2000000.0
        thgg_p(k)=200.0
        egdif_p(k)=0.0
      end do
      chi2minp=2000000.0
      chi2minp1=2000000.0
      chi2minp2=2000000.0
      chi2minp3=2000000.0
      chi2minp4=2000000.0
      chi2minp5=2000000.0
      chi2minp6=2000000.0
      chi2minp7=2000000.0   
      chi2minp8=2000000.0   
      chi2minp9=2000000.0   
      rmpi01m = 999.
      rmpi02m = 999.
      rmpi03m = 999.
      rmpi04m = 999.
      rmpi05m = 999.
      rmpi06m = 999.
      rmpi07m = 999.        
      rmpi08m = 999. 
      rmpi09m = 999.
      rmkk07m = 999.     
      rmkk08m = 999. 
      rmkk09m = 999.
      rmks107m = 999.     
      rmks108m = 999. 
      rmks109m = 999.
      rmks207m = 999.     
      rmks208m = 999. 
      rmks209m = 999.
      chi2ming=200000.0
      thedif1=20000.0
      thedif2=2000.0
c
      x1time1 = 99999.
      x1time2 = 99999.
      x1time3 = 99999.
      x1timee1 = 99999.
      x1timee2 = 99999.
      x1timee3 = 99999.
      x1timeoff1 = 99999.
      x1timeoff2 = 99999.
      x1timeoff3 = 99999.
      x1timesig1 = 99999.
      x1timesig2 = 99999.
      x1timesig3 = 99999.
      x2time1 = 99999.
      x2time2 = 99999.
      x2time3 = 99999.
      x2timee1 = 99999.
      x2timee2 = 99999.
      x2timee3 = 99999.
      x2timeoff1 = 99999.
      x2timeoff2 = 99999.
      x2timeoff3 = 99999.
      x2timesig1 = 99999.
      x2timesig2 = 99999.
      x2timesig3 = 99999.
      x1xsp1 = 99999.
      x1xsp2 = 99999.
      x1xsp3 = 99999.
      x1dedxoff1 = 99999.
      x1dedxoff2 = 99999.
      x1dedxoff3 = 99999.
      x1dedxsig1 = 99999.
      x1dedxsig2 = 99999.
      x1dedxsig3 = 99999.
      x2xsp1 = 99999.
      x2xsp2 = 99999.
      x2xsp3 = 99999.
      x2dedxoff1 = 99999.
      x2dedxoff2 = 99999.
      x2dedxoff3 = 99999.
      x2dedxsig1 = 99999.
      x2dedxsig2 = 99999.
      x2dedxsig3 = 99999.
      IDFLAG1 = 99999.
      IDFLAG2 = 99999.
      IDdFLAG1 = 99999.
      IDdFLAG2 = 99999.
      IDGDTOF1 = 99999.
      IDGDDEDX1 = 99999.
      IDGDCOM1 = 99999.
      IDGDTOF2 = 99999.   
      IDGDDEDX2 = 99999.  
      IDGDCOM2 = 99999.   
c
      ndsel=0    ! ndsel has been initialized by need(*) besevn
c
      if(irun.le.0)                     ivs=103
      if(irun.ge.462.and.irun.le.961)   ivs=5
      if(irun.ge.1248.and.irun.le.1616) ivs=6
      if(irun.ge.1750.and.irun.le.2045) ivs=8
      if(irun.ge.3579.and.irun.le.3739) ivs=7
      if(irun.ge.13000)                 ivs=103
c
      call jpsi_run_status(irun,istatus)
      if(istatus.eq.3)return
c
      call ncor
c
c   total charge of this event
      itotch=0
      if( tottks.gt.20.or.tottks.lt.3 ) return
c
      nmdc = 0  
      do 50 i1 = 1, nchrg
        isub1=trksub(1,i1)
        if(isub1.le.0) goto 50
        itype = itrk(isub1+5)
        idc = ibits(itype,0,1)
        if(idc.eq.0) goto 50
        itotch=itotch+itrk(trksub(1,i1)+4)
        nmdc = nmdc +1
   50 continue  
c
      if( itotch.ne.0.or.nmdc.ne.2 ) return
c
      rx1=0.0
      ry1=0.0
      rz1=0.0
      r1=0.0
      rx2=0.0
      ry2=0.0
      rz2=0.0
      r2=0.0
      px1=0.0
      py1=0.0
      pz1=0.0
      pp1=0.0
      phi1=0.0
      px2=0.0
      py2=0.0
      pz2=0.0
      pp2=0.0
      phi2=0.0
c
      tscf=0.0
      tscos=0.0
      rextbsc=999.0
      rextbtf=999.0
      rextesc=999.0
      rextetf=999.0
c
      scfpx1=999.0
      scfpy1=999.0
      scfpz1=999.0
      rscfp1=999.0
      scfpx2=999.0
      scfpy2=999.0
      scfpz2=999.0
      rscfp2=999.0
c
      scospx1=999.0
      scospy1=999.0
      scospz1=999.0
      rscosp1=999.0
      scospx2=999.0
      scospy2=999.0
      scospz2=999.0
      rscosp2=999.0
c
      iscflgp1=-5
      iscflgp2=-5
c
      pid1=0
      pid2=0
      nnp1=0
      nnp2=0
      nnnp1=0
      nnnp2=0
      wtk1=99.
      wtk2=99.
c
c ! charged tracks
      ngtrk=0
c
      do 100 i2=1,nchrg
        i2sub1=trksub(1,i2)
        if(i2sub1.le.0) goto 100
        i2type = itrk(i2sub1+5)
        i2dc = ibits(i2type,0,1)
        if(i2dc.eq.0) goto 100
c
	ind3=trksub(3,i2)
	ind4=trksub(4,i2)
	ind5=trksub(5,i2)
	ind6=trksub(6,i2)
	ind7=trksub(7,i2)
	ind11=trksub(11,i2)
        if( ind3.eq.0.and.ind4.eq.0.and.ind5.eq.0
     &      .and.ind6.eq.0 ) return
c
	if( ind3.ne.0 ) then
c   
c   good track selection
c
          rch2=trk(ind3+17)
          nmfit=itrk(ind3+14)
          if( nmfit.ne.2 ) goto 100
c
c   track from primary vertex (only for 2_prong events)
c
          rx=trk(ind3+10)
          ry=trk(ind3+11)
          rz=trk(ind3+12)
          rxy=sqrt(rx*rx+ry*ry)
          arz=abs(rz)
c
          if( rxy.gt.0.02.or.abs(rz).gt.0.20) goto 100
c   total # of good charged tracks from oringal in this event
          ngtrk=ngtrk+1
c   for charge "+" track
	  if( itrk(ind3+2).eq.1 ) then
            ipid1=i2
	    px1=trk(ind3+4)
	    py1=trk(ind3+5)
	    pz1=trk(ind3+6)
	    pp1=trk(ind3+7)
            pxy1=sqrt(px1**2+py1**2)
            phi1=trk(ind3+9)
            rx1=trk(ind3+10)
            ry1=trk(ind3+11)
            rz1=trk(ind3+12)
c        de/dx
            if( ind7.ne.0 ) then
              rnhit1=float(itrk(ind7+3))
              rsfe1=trk(ind7+15)
              rsfmu1=trk(ind7+16)
              rsfpi1=trk(ind7+17)
              rsfk1=trk(ind7+18)
              rsfp1=trk(ind7+19)
            else
              rnhit1=0.0
              rsfpi1=-10.0
              rsfp1=-100.0
            endif
c   tof & dE/dx
c---Particle ID
            call tofpid(i2,IFLAG,1)
            IDFLAG1 = IFLAG
      if(IDFLAG1.ne.0) then
      x1time1  = xtime(1)
      x1time2  = xtime(2)
      x1time3  = xtime(3)
      x1timee1 = xtimee(1)
      x1timee2 = xtimee(2)
      x1timee3 = xtimee(3)
      x1timeoff1  = xtimeoff(1)
      x1timeoff2  = xtimeoff(2)
      x1timeoff3  = xtimeoff(3)
      x1timesig1  = xtimesig(1)
      x1timesig2  = xtimesig(2)
      x1timesig3  = xtimesig(3)
      endif
c
           call partid(i2,IFLAG,1)
            IDdFLAG1 = IFLAG
            IDGDTOF1 = IDGDTOF
            IDGDDEDX1 = IDGDDEDX
            IDGDCOM1 = IDGDCOM
      if(IDGDDEDX1.ne.0) then
      x1xsp1  = xxsp(1)  
      x1xsp2  = xxsp(2)  
      x1xsp3  = xxsp(3)  
      x1dedxoff1  = xdedxoff(1)
      x1dedxoff2  = xdedxoff(2)
      x1dedxoff3  = xdedxoff(3)
      x1dedxsig1  = xdedxsig(1)
      x1dedxsig2  = xdedxsig(2)
      x1dedxsig3  = xdedxsig(3)
      endif
c 
            if( ind4.ne.0 ) then
              icnt11=itrk(ind4+3)
              icnt12=itrk(ind4+20)
              if( icnt11.ne.0 ) then
                icnt1=icnt11
                tof1=trk(ind4+4)  
                beta1=trk(ind4+5)
                tq1=trk(ind4+8)
                wtpi1=trk(ind4+9)
                wtk1=trk(ind4+10)
                wtp1=trk(ind4+11)
                wte1=trk(ind4+12)
                amsq1=trk(ind4+13)
                path1=trk(ind4+14)
                terr1=trk(ind4+15)  
              else if( icnt12.ne.0 ) then
                icnt1=icnt12
                tof1=trk(ind4+21)
                beta1=trk(ind4+22)
                tq1=trk(ind4+25)
                wtpi1=trk(ind4+26)
                wtk1=trk(ind4+27)
                wtp1=trk(ind4+28)
                wte1=trk(ind4+29)
                amsq1=trk(ind4+30)
                path1=trk(ind4+31)
                terr1=trk(ind4+32)
              else
                icnt1=0
                tof1=999.0
                beta1=9.99
                tq1=-2.
                wtpi1=0.
                wtk1=99.
                wtp1=0.
                wte1=0.
                amsq1=999.0
                path1=999.0
                terr1=999.0
              endif
            else
              icnt1=0
              tof1=999.
              beta1=9.99
              tq1=-2.
              wtpi1=0.
              wtk1=99.0
              wtp1=0.
              wte1=0.
              amsq1=999.0
              path1=999.0
              terr1=999.0
            endif
            if( ind4.gt.0.and.tq1.le.8.and.path1.lt.999.0.and.
     *          tof1.gt.0.and.beta1.lt.9.0.and.beta1.gt.0.0.and.
     *          (icnt11.gt.0.and.icnt11.le.48 ) ) then
              if (wtk1.gt.wte1.and.wtk1.gt.wtpi1.and.wtk1.gt.wtp1) 
     *          then
                pid1=5
              else if (wtk1.gt.wte1.and.wtk1.gt.wtpi1 )
     *          then
                pid1=51
              else if ( wtpi1.ge.wtk1.or.wte1.ge.wtk1 )
     *          then
                pid1=4
              endif
            else if( rsfk1.gt.-3.0.and.rnhit1.gt.20.0.
     *               and.abs(rsfk1).lt.abs(rsfe1).
     *               and.abs(rsfk1).lt.abs(rsfmu1).
     *               and.abs(rsfk1).lt.abs(rsfpi1).
     *               and.abs(rsfk1).lt.abs(rsfp1) )
     *        then
              pid1=52
            else if( rsfpi1.le.3.0.and.rnhit1.gt.20.0.
     *               and.abs(rsfpi1).lt.abs(rsfk1))
     *        then
              pid1=42
            endif
c        shower counter 
            if( ind5.gt.0.and.itrk(ind5+20).eq.1 ) then
              tscf=sqrt(trk(ind5+4)**2+trk(ind5+6)**2+
     *                  trk(ind5+8)**2)
              tscos=sqrt(trk(ind5+27)**2+trk(ind5+28)**2)
            else
              tscf=0.0
              tscos=0.0
            endif
            if( ind11.gt.0 ) then
              rextbsc=sqrt(trk(ind11+8)**2+trk(ind11+9)**2+
     *                     trk(ind11+10)**2)
              rextbtf=sqrt(trk(ind11+2)**2+trk(ind11+3)**2+
     *                     trk(ind11+4)**2)
              rextesc=sqrt(trk(ind11+20)**2+trk(ind11+21)**2+
     *                     trk(ind11+22)**2)
              rextetf=sqrt(trk(ind11+14)**2+trk(ind11+15)**2+
     *                     trk(ind11+16)**2)
            else
              rextbsc=999.0
              rextbtf=999.0
              rextesc=999.0
              rextetf=999.0
            endif
            if( ind5.gt.0.and.itrk(ind5+20).eq.1.and.
     *          tscf.gt.0.0.and.tscf.lt.10.0.and.
     *          tscos.gt.0.0.and.tscos.le.1.0 ) then
              nmod1=itrk(ind5+20)
              rmod1=float(nmod1)
              esc1=trk(ind5+14)
              scfpx1=trk(ind5+4)
              scfpy1=trk(ind5+6)
              scfpz1=trk(ind5+8)
              rscfp1=sqrt(scfpx1**2+scfpy1**2+scfpz1**2)
              phip1=phi(scfpx1,scfpy1)
              scospx1=trk(ind5+27)
              scospy1=trk(ind5+28)
              scospz1=trk(ind5+29)
              rscosp1=sqrt(scospx1**2+scospy1**2+scospz1**2)
              phiscp1=phi(scospx1,scospy1)
              iscflgp1=0
            else
              nmod1=5
              rmod1=5.0
              esc1=0.0
              if( ind11.gt.0 ) then
                if( rextbsc.gt.0.0.and.rextbsc.lt.900.0 ) then
                  scfpx1=trk(ind11+8)
                  scfpy1=trk(ind11+9)
                  scfpz1=trk(ind11+10)
                  rscfp1=sqrt(scfpx1**2+scfpy1**2+scfpz1**2)
                  phip1=phi(scfpx1,scfpy1)
                  thextrp=trk(ind11+11)
                  phextrp=trk(ind11+12)
                  scospx1=sin(thextrp)*cos(phextrp)
                  scospy1=sin(thextrp)*sin(phextrp)
                  scospz1=cos(thextrp)
                  rscosp1=sqrt(scospx1**2+scospy1**2+scospz1**2)
                  phiscp1=phextrp
                  iscflgp1=1
                else if( rextbtf.gt.0.0.and.rextbtf.lt.900.0 ) then
                  scfpx1=trk(ind11+2)
                  scfpy1=trk(ind11+3)
                  scfpz1=trk(ind11+4)
                  rscfp1=sqrt(scfpx1**2+scfpy1**2+scfpz1**2)
                  phip1=phi(scfpx1,scfpy1)
                  thextrp=trk(ind11+5)
                  phextrp=trk(ind11+6)
                  scospx1=sin(thextrp)*cos(phextrp)
                  scospy1=sin(thextrp)*sin(phextrp)
                  scospz1=cos(thextrp)
                  rscosp1=sqrt(scospx1**2+scospy1**2+scospz1**2)
                  phiscp1=phextrp
                  iscflgp1=2
                else if( rextesc.gt.0.0.and.rextesc.lt.900.0 ) then
                  scfpx1=trk(ind11+20)
                  scfpy1=trk(ind11+21)
                  scfpz1=trk(ind11+22)
                  rscfp1=sqrt(scfpx1**2+scfpy1**2+scfpz1**2)
                  phip1=phi(scfpx1,scfpy1)
                  thextrp=trk(ind11+23)
                  phextrp=trk(ind11+24)
                  scospx1=sin(thextrp)*cos(phextrp)
                  scospy1=sin(thextrp)*sin(phextrp)
                  scospz1=cos(thextrp)
                  rscosp1=sqrt(scospx1**2+scospy1**2+scospz1**2)
                  phiscp1=phextrp
                  iscflgp1=3
                else if( rextetf.gt.0.0.and.rextetf.lt.900.0 ) then
                  scfpx1=trk(ind11+14)
                  scfpy1=trk(ind11+15)
                  scfpz1=trk(ind11+16)
                  rscfp1=sqrt(scfpx1**2+scfpy1**2+scfpz1**2)
                  phip1=phi(scfpx1,scfpy1)
                  thextrp=trk(ind11+17)
                  phextrp=trk(ind11+18)
                  scospx1=sin(thextrp)*cos(phextrp)
                  scospy1=sin(thextrp)*sin(phextrp)
                  scospz1=cos(thextrp)
                  rscosp1=sqrt(scospx1**2+scospy1**2+scospz1**2)
                  phiscp1=phextrp
                  iscflgp1=4
                else
                  scfpx1=999.0
                  scfpy1=999.0
                  scfpz1=999.0
                  rscfp1=999.0
                  scospx1=999.0
                  scospy1=999.0
                  scospz1=999.0
                  rscosp1=999.0
                  phiscp1=999.0
                  iscflgp1=-1
                endif
              else
                scfpx1=999.0
                scfpy1=999.0
                scfpz1=999.0
                rscfp1=999.0
                scospx1=999.0
                scospy1=999.0
                scospz1=999.0
                rscosp1=999.0
                phiscp1=999.0
                iscflgp1=-2
              endif
            endif
c        muon chamber 
            if( ind6.ne.0 ) then
              idmu1=itrk(ind6+2)
              rdmu1=float(idmu1)
              imst1=itrk(ind6+3)
              imht1=ibits(imst1,0,1)+ibits(imst1,1,1)
     &             +ibits(imst1,2,1)
              rmht1=float(imht1)
            else
              idmu1=4
              rdmu1=4.0
              rmht1=-2.0
            endif
c   for charge "-" track
          else if( itrk(ind3+2).eq.-1 ) then
            ipid2=i2
	    px2=trk(ind3+4)
	    py2=trk(ind3+5)
	    pz2=trk(ind3+6)
	    pp2=trk(ind3+7)
            pxy2=sqrt(px2**2+py2**2)
            phi2=trk(ind3+9)
            rx2=trk(ind3+10)
            ry2=trk(ind3+11)
            rz2=trk(ind3+12)
c        de/dx
            if( ind7.ne.0 ) then
              rnhit2=float(itrk(ind7+3))
              rsfe2=trk(ind7+15)
              rsfmu2=trk(ind7+16)
              rsfpi2=trk(ind7+17)
              rsfk2=trk(ind7+18)
              rsfp2=trk(ind7+19)
            else
              rnhit2=0.0
              rsfpi2=-10.0
              rsfp2=-100.0
            endif
c   tof & dE/dX 
c---Particle ID
            call tofpid(i2,IFLAG,1)
            IDFLAG2 = IFLAG
      if(IDFLAG2.ne.0) then
      x2time1  = ytime(1)
      x2time2  = ytime(2)
      x2time3  = ytime(3)
      x2timee1 = ytimee(1)
      x2timee2 = ytimee(2)
      x2timee3 = ytimee(3)
      x2timeoff1  = ytimeoff(1)
      x2timeoff2  = ytimeoff(2)
      x2timeoff3  = ytimeoff(3)
      x2timesig1  = ytimesig(1)
      x2timesig2  = ytimesig(2)
      x2timesig3  = ytimesig(3)
      endif
c
           call partid(i2,IFLAG,1)
            IDdFLAG2 = IFLAG
            IDGDTOF2 = IDGDTOF
            IDGDDEDX2 = IDGDDEDX
            IDGDCOM2 = IDGDCOM
      if(IDGDDEDX2.ne.0) then
      x2xsp1  = yxsp(1)  
      x2xsp2  = yxsp(2)  
      x2xsp3  = yxsp(3)  
      x2dedxoff1  = ydedxoff(1)
      x2dedxoff2  = ydedxoff(2)
      x2dedxoff3  = ydedxoff(3)
      x2dedxsig1  = ydedxsig(1)
      x2dedxsig2  = ydedxsig(2)
      x2dedxsig3  = ydedxsig(3)
      endif
c
            if( ind4.ne.0 ) then
              icnt21=itrk(ind4+3)
              icnt22=itrk(ind4+20)
              if( icnt21.ne.0 ) then
                icnt2=icnt21
                tof2=trk(ind4+4)  
                beta2=trk(ind4+5)
                tq2=trk(ind4+8)
                wtpi2=trk(ind4+9)
                wtk2=trk(ind4+10)
                wtp2=trk(ind4+11)
                wte2=trk(ind4+12)
                amsq2=trk(ind4+13)
                path2=trk(ind4+14)
                terr2=trk(ind4+15)  
              else if( icnt22.ne.0 ) then
                icnt2=icnt22
                tof2=trk(ind4+21)
                beta2=trk(ind4+22)
                tq2=trk(ind4+25)
                wtpi2=trk(ind4+26)
                wtk2=trk(ind4+27)
                wtp2=trk(ind4+28)
                wte2=trk(ind4+29)
                amsq2=trk(ind4+30)
                path2=trk(ind4+31)
                terr2=trk(ind4+32)
              else
                icnt2=0
                tof2=999.0
                beta2=9.99
                tq2=-2.
                wtpi2=0.
                wtk2=99.
                wtp2=0.
                wte2=0.
                amsq2=999.0
                path2=999.0
                terr2=999.0
              endif
            else
              icnt2=0
              tof2=999.
              beta2=9.99
              tq2=-2.
              wtpi2=0.
              wtk2=99.
              wtp2=0.
              wte2=0.
              amsq2=999.0
              path2=999.0
              terr2=999.0
            endif
            if( ind4.gt.0.and.tq2.le.8.and.path2.lt.999.0.and.
     *          tof2.gt.0.and.beta2.lt.9.0.and.beta2.gt.0.0.and.
     *          (icnt21.gt.0.and.icnt21.le.48 ) ) then
              if (wtk2.gt.wte2.and.wtk2.gt.wtpi2.and.wtk2.gt.wtp2) 
     *          then
                pid2=5
              else if (wtk2.gt.wte2.and.wtk2.gt.wtpi2) 
     *          then
                pid2=51
              else if (wtpi2.ge.wtk2.or.wte2.ge.wtk2) 
     *          then
                pid2=4
              endif
            else if( rsfk2.gt.-3.0.and.rnhit2.gt.20.0.
     *               and.abs(rsfk2).lt.abs(rsfe2).
     *               and.abs(rsfk2).lt.abs(rsfmu2).
     *               and.abs(rsfk2).lt.abs(rsfpi2).
     *               and.abs(rsfk2).lt.abs(rsfp2) )
     *        then
              pid2=52
            else if( rsfpi2.le.3.0.and.rnhit2.gt.20.0.
     *               and.abs(rsfpi2).lt.abs(rsfk2))
     *        then
              pid2=42
            endif
c        shower counter
            if( ind5.gt.0.and.itrk(ind5+20).eq.1 ) then
              tscf=sqrt(trk(ind5+4)**2+trk(ind5+6)**2+
     *                  trk(ind5+8)**2)
              tscos=sqrt(trk(ind5+27)**2+trk(ind5+28)**2)
            else
              tscf=0.0
              tscos=0.0
            endif
c
            if( ind11.gt.0 ) then
              rextbsc=sqrt(trk(ind11+8)**2+trk(ind11+9)**2+
     *                     trk(ind11+10)**2)
              rextbtf=sqrt(trk(ind11+2)**2+trk(ind11+3)**2+
     *                     trk(ind11+4)**2)
              rextesc=sqrt(trk(ind11+20)**2+trk(ind11+21)**2+
     *                     trk(ind11+22)**2)
              rextetf=sqrt(trk(ind11+14)**2+trk(ind11+15)**2+
     *                     trk(ind11+16)**2)
            else
              rextbsc=999.0
              rextbtf=999.0
              rextesc=999.0
              rextetf=999.0
            endif
            if( ind5.gt.0.and.itrk(ind5+20).eq.1.and.
     *          tscf.gt.0.0.and.tscf.lt.10.0.and.
     *          tscos.gt.0.0.and.tscos.le.1.0 ) then
              nmod2=itrk(ind5+20)
              rmod2=float(nmod2)
              esc2=trk(ind5+14)
              scfpx2=trk(ind5+4)
              scfpy2=trk(ind5+6)
              scfpz2=trk(ind5+8)
              rscfp2=sqrt(scfpx2**2+scfpy2**2+scfpz2**2)
              phip2=phi(scfpx2,scfpy2)
              scospx2=trk(ind5+27)
              scospy2=trk(ind5+28)
              scospz2=trk(ind5+29)
              rscosp2=sqrt(scospx2**2+scospy2**2+scospz2**2)
              phiscp2=phi(scospx2,scospy2)
              iscflgp2=0
            else
              nmod2=5
              rmod2=5.0
              esc2=0.0
              if( ind11.gt.0 ) then
                if( rextbsc.gt.0.0.and.rextbsc.lt.900.0 ) then
                  scfpx2=trk(ind11+8)
                  scfpy2=trk(ind11+9)
                  scfpz2=trk(ind11+10)
                  rscfp2=sqrt(scfpx2**2+scfpy2**2+scfpz2**2)
                  phip2=phi(scfpx2,scfpy2)
                  thextrp=trk(ind11+11)
                  phextrp=trk(ind11+12)
                  scospx2=sin(thextrp)*cos(phextrp)
                  scospy2=sin(thextrp)*sin(phextrp)
                  scospz2=cos(thextrp)
                  rscosp2=sqrt(scospx2**2+scospy2**2+scospz2**2)
                  phiscp2=phextrp
                  iscflgp2=1
                else if( rextbtf.gt.0.0.and.rextbtf.lt.900.0 ) then
                  scfpx2=trk(ind11+2)
                  scfpy2=trk(ind11+3)
                  scfpz2=trk(ind11+4)
                  rscfp2=sqrt(scfpx2**2+scfpy2**2+scfpz2**2)
                  phip2=phi(scfpx2,scfpy2)
                  thextrp=trk(ind11+5)
                  phextrp=trk(ind11+6)
                  scospx2=sin(thextrp)*cos(phextrp)
                  scospy2=sin(thextrp)*sin(phextrp)
                  scospz2=cos(thextrp)
                  rscosp2=sqrt(scospx2**2+scospy2**2+scospz2**2)
                  phiscp2=phextrp
                  iscflgp2=2
                else if( rextesc.gt.0.0.and.rextesc.lt.900.0 ) then
                  scfpx2=trk(ind11+20)
                  scfpy2=trk(ind11+21)
                  scfpz2=trk(ind11+22)
                  rscfp2=sqrt(scfpx2**2+scfpy2**2+scfpz2**2)
                  phip2=phi(scfpx2,scfpy2)
                  thextrp=trk(ind11+23)
                  phextrp=trk(ind11+24)
                  scospx2=sin(thextrp)*cos(phextrp)
                  scospy2=sin(thextrp)*sin(phextrp)
                  scospz2=cos(thextrp)
                  rscosp2=sqrt(scospx2**2+scospy2**2+scospz2**2)
                  phiscp2=phextrp
                  iscflgp2=3
                else if( rextetf.gt.0.0.and.rextetf.lt.900.0 ) then
                  scfpx2=trk(ind11+14)
                  scfpy2=trk(ind11+15)
                  scfpz2=trk(ind11+16)
                  rscfp2=sqrt(scfpx2**2+scfpy2**2+scfpz2**2)
                  phip2=phi(scfpx2,scfpy2)
                  thextrp=trk(ind11+17)
                  phextrp=trk(ind11+18)
                  scospx2=sin(thextrp)*cos(phextrp)
                  scospy2=sin(thextrp)*sin(phextrp)
                  scospz2=cos(thextrp)
                  rscosp2=sqrt(scospx2**2+scospy2**2+scospz2**2)
                  phiscp2=phextrp
                  iscflgp2=4
                else
                  scfpx2=999.0
                  scfpy2=999.0
                  scfpz2=999.0
                  rscfp2=999.0
                  scospx2=999.0
                  scospy2=999.0
                  scospz2=999.0
                  rscosp2=999.0
                  phiscp2=999.0
                  iscflgp2=-1
                endif
              else
                scfpx2=999.0
                scfpy2=999.0
                scfpz2=999.0
                rscfp2=999.0
                scospx2=999.0
                scospy2=999.0
                scospz2=999.0
                rscosp2=999.0
                phiscp2=999.0
                iscflgp2=-2
              endif
            endif
c        muon chamber
            if( ind6.ne.0 ) then
              idmu2=itrk(ind6+2)
              rdmu2=float(idmu2)
              imst2=itrk(ind6+3)
              imht2=ibits(imst2,0,1)+ibits(imst2,1,1)
     &             +ibits(imst2,2,1)
              rmht2=float(imht2)
            else
              idmu2=4
              rdmu2=4.0
              rmht2=-2.0
            endif
          endif
        endif
100   continue
c
      if( ngtrk.ne.nmdc ) return
c
      if( esc1.ge.1.0.or.esc2.ge.1.0 ) return
c
      if ( pp1.le.0.or.pp2.le.0.or.pp1.ge.2.or.pp2.ge.2. ) return 
c
      tofk1=path1*sqrt(rmkoan**2+pp1**2)*10/(pp1*3)
      tofk2=path2*sqrt(rmkoan**2+pp2**2)*10/(pp2*3)
      tofpi1=path1*sqrt(rmpi**2+pp1**2)*10/(pp1*3)
      tofpi2=path2*sqrt(rmpi**2+pp2**2)*10/(pp2*3)
      if( tof1.lt.999.0.and.tof2.le.999.0.and.
     *    tof1.gt.0.0.and.tof2.gt.0.0.and.
     *    path1.lt.999.0.and.path2.lt.999.0 ) then
        rdelt=tof1+tof2-0.5*(tofk1+tofk2+tofpi1+tofpi2)
      else
        rdelt=10000.0
      endif
      tdpi1=tof1-path1*sqrt(0.1396**2+pp1**2)*10/(pp1*3)
      tdpi2=tof2-path2*sqrt(0.1396**2+pp2**2)*10/(pp2*3)
      tdk1=tof1-path1*sqrt(0.4936**2+pp1**2)*10/(pp1*3)
      tdk2=tof2-path2*sqrt(0.4936**2+pp2**2)*10/(pp2*3)
      tdp1=tof1-path1*sqrt(0.9383**2+pp1**2)*10/(pp1*3)
      tdp2=tof2-path2*sqrt(0.9383**2+pp2**2)*10/(pp2*3)
c
      if( wtk1.le.0.0.or.wtk1.ge.1.0 ) then
        tsk1=999.0
      else
        tsk1=abs(tk1)/sqrt(-2.0*log(wtk1))
      endif
      if( wtk2.le.0.0.or.wtk2.ge.1.0 ) then
        tsk2=999.0
      else
        tsk2=abs(tk2)/sqrt(-2.0*log(wtk2))
      endif
c
      pp1_sav=pp1
      pp2_sav=pp2
      pp1_old=pp1
      pp2_old=pp2
c
c     rmp=0.93827
      e1_old=sqrt(pp1_old**2+rmkoan**2)
      e2_old=sqrt(pp2_old**2+rmkoan**2)
      ett_old=e1_old+e2_old
      ems_old=3.0969-ett_old
c
      e1_pi=sqrt(pp1_old**2+0.1396**2)
      e2_pi=sqrt(pp2_old**2+0.1396**2)
      ett_pi=e1_pi+e2_pi
      ems_pi=3.0969-ett_pi
c
      pxms_old=-px1-px2
      pyms_old=-py1-py2
      pzms_old=-pz1-pz2
      pms_old=sqrt(pxms_old**2+pyms_old**2+pzms_old**2)
      if( pms_old.le.0.0 ) return
c  for rho-pi    
      sqmrho1=(e1_pi+sqrt(pms_old**2+0.135**2))**2-(px1+pxms_old)**2-
     *           (py1+pyms_old)**2-(pz1+pzms_old)**2
      if( sqmrho1.lt.0.0 ) return
      rmrho1=sqrt(sqmrho1)
      sqmrho2=(e2_pi+sqrt(pms_old**2+0.135**2))**2-(px2+pxms_old)**2-
     *           (py2+pyms_old)**2-(pz2+pzms_old)**2
      if( sqmrho2.lt.0.0 ) return
      rmrho2=sqrt(sqmrho2)
c
      epms_old=ems_old-pms_old
c   find 1st vertex
      call vxkwik(stat,0)
      rx0=trk(vrtsub(2,1)+5)
      ry0=trk(vrtsub(2,1)+6)
      rz0=trk(vrtsub(2,1)+7)
ccc      rx0 = 0.
ccc      ry0 = 0.
ccc      rz0 = 0.
c
      scfpx1=scfpx1-rx0
      scfpy1=scfpy1-ry0
      scfpz1=scfpz1-rz0
      scfpx2=scfpx2-rx0
      scfpy2=scfpy2-ry0
      scfpz2=scfpz2-rz0
ccmidsl4 --- 'find' information quickly for too long subroutine
      rcth1=pz1/pp1
      rcth2=pz2/pp2
      thp1=acos(rcth1)
      thp2=acos(rcth2)
c!!!!!
c  1) use beam_pipe (de/dx) correction ( function bpcorr ) ---- 93-10-16
c  2) change trklst after correction ---- 93-10-18
c  3) make a constant correction for each run circle --- 93-10-20
      cnstcorr=1.00
      if( irun.le.1000.and.irun.ge.0 ) then
        cnstcorr=1.00
      else
        cnstcorr=1.00
      endif
c
      pp1=cnstcorr*pp1_sav
      iptp1=trksub(3,ipid1)
      trk(iptp1+3)=trk(iptp1+3)*pp1/trk(iptp1+7)
      trk(iptp1+4)=trk(iptp1+4)*pp1/trk(iptp1+7)
      trk(iptp1+5)=trk(iptp1+5)*pp1/trk(iptp1+7)
      trk(iptp1+6)=trk(iptp1+6)*pp1/trk(iptp1+7)
      trk(iptp1+7)=trk(iptp1+7)*pp1/trk(iptp1+7)
      pp1=trk(iptp1+7)
      px1=trk(iptp1+4)
      py1=trk(iptp1+5)
      pz1=trk(iptp1+6)
c
      pp2=cnstcorr*pp2_sav
      iptp2=trksub(3,ipid2)
      trk(iptp2+3)=trk(iptp2+3)*pp2/trk(iptp2+7)
      trk(iptp2+4)=trk(iptp2+4)*pp2/trk(iptp2+7)
      trk(iptp2+5)=trk(iptp2+5)*pp2/trk(iptp2+7)
      trk(iptp2+6)=trk(iptp2+6)*pp2/trk(iptp2+7)
      trk(iptp2+7)=trk(iptp2+7)*pp2/trk(iptp2+7)
      pp2=trk(iptp2+7)
      px2=trk(iptp2+4)
      py2=trk(iptp2+5)
      pz2=trk(iptp2+6)
c
      e1=sqrt(pp1*pp1+rmkoan**2)
      e2=sqrt(pp2*pp2+rmkoan**2)
      ett=e1+e2
      ems=3.0969-ett
c
c   collinear angle 
      thkk=theta12(px1,py1,pz1,px2,py2,pz2)
c   direction of ... ppbar plane
      vndx = py1*pz2-pz1*py2
      vndy = pz1*px2-px1*pz2
      vndz = px1*py2-py1*px2
c   missing p
      pxms=-px1-px2
      pyms=-py1-py2
      pzms=-pz1-pz2
      pms=sqrt(pxms*pxms+pyms*pyms+pzms*pzms)
      if( pms.le.0.0 ) return
      phms=phi(pxms,pyms)
      epms=ems-pms
      cospms=pzms/pms
      thpm1=theta12(px1,py1,pz1,pxms,pyms,pzms)
      thpm2=theta12(px2,py2,pz2,pxms,pyms,pzms)
      phpm1=phi12(phi1,phms)
      phpm2=phi12(phi2,phms)
c   inv. mass of kk
      sqmkk=ett**2-pxms**2-pyms**2-pzms**2
      if( sqmkk.lt.0.0 ) return
      rmkk=sqrt(sqmkk)
c   for kstar-k
      sqmkstar1=(e1+sqrt(pms**2+0.135**2))**2-(px1+pxms)**2-
     *           (py1+pyms)**2-(pz1+pzms)**2
      if( sqmkstar1.lt.0.0 ) return
      rmkstar1=sqrt(sqmkstar1)
      sqmkstar2=(e2+sqrt(pms**2+0.135**2))**2-(px2+pxms)**2-
     *           (py2+pyms)**2-(pz2+pzms)**2
      if( sqmkstar2.lt.0.0 ) return
      rmkstar2=sqrt(sqmkstar2)
c
      rmj=3.097
      pexp1=0.0
      pexp2=0.0
      sqp1=(rmj**2-(rmkstar2+rmkoan)**2)*(rmj**2-(rmkstar2-rmkoan)**2)
      if( sqp1.ge.0.0 ) then
        pexp1=sqrt(sqp1)/(2*rmj)
      endif
      sqp2=(rmj**2-(rmkstar1+rmkoan)**2)*(rmj**2-(rmkstar1-rmkoan)**2)
      if( sqp2.ge.0.0 ) then
        pexp2=sqrt(sqp2)/(2*rmj)
      endif
c
c!!!!! for 2pn evts.-- for the consistancy between mc and data
czj   if( thkk.ge.175.0 ) return
c
      if( rmkk.ge.3.1 ) return
c
c   remove multi-pion evts
      if( (epms.ge.0.5.or.epms.le.-0.5).and.irun.ge.0 ) return
c
      plabpp1(1)=px1
      plabpp1(2)=py1
      plabpp1(3)=pz1
      plabpp1(4)=sqrt(rmkoan**2+pp1**2)
      plabpp2(1)=px2
      plabpp2(2)=py2
      plabpp2(3)=pz2
      plabpp2(4)=sqrt(rmkoan**2+pp2**2)
      pp_cm(1)=-pxms
      pp_cm(2)=-pyms
      pp_cm(3)=-pzms
      pp_cm(4)=ett
      call lab_cm(rmkk,pp_cm,plabpp1,p_cmpp1)
      thp1_cm=theta12(p_cmpp1(1),p_cmpp1(2),p_cmpp1(3),
     *                pp_cm(1),pp_cm(2),pp_cm(3))
      cosp1_cm=cos(thp1_cm*3.1415927/180.0)
      call lab_cm(rmkk,pp_cm,plabpp2,p_cmpp2)
      thp2_cm=theta12(p_cmpp2(1),p_cmpp2(2),p_cmpp2(3),
     *                pp_cm(1),pp_cm(2),pp_cm(3))
      cosp2_cm=cos(thp2_cm*3.1415927/180.0)
c
      pgx=pxms
      pgy=pyms
      pgz=pzms
      pg=pms
      rmkg1=sqrt((e1+pms)**2-(px1+pgx)**2-(py1+pgy)**2
     *          -(pz1+pgz)**2)
      rmkg2=sqrt((e2+pms)**2-(px2+pgx)**2-(py2+pgy)**2
     *          -(pz2+pgz)**2)
c
      ppi0(1)=pxms
      ppi0(2)=pyms
      ppi0(3)=pzms
      ppi0(4)=sqrt(pms**2+rmpi0**2)
c
c   proton direction in assumed pi0_cm frame
c
      call lab_cm(rmpi0,ppi0,plabpp1,pcmpp1)
      pcmx1=pcmpp1(1)
      pcmy1=pcmpp1(2)
      pcmz1=pcmpp1(3)
c
      call lab_cm(rmpi0,ppi0,plabpp2,pcmpp2)
      pcmx2=pcmpp2(1)
      pcmy2=pcmpp2(2)
      pcmz2=pcmpp2(3)
c
c   missing pmscm, emscm in 'pi0_frame'
      plabjsi(1)=0.0
      plabjsi(2)=0.0
      plabjsi(3)=0.0
      plabjsi(4)=3.0969
      call lab_cm(rmpi0,ppi0,plabjsi,pcmjsi)
c
      pmscmx=pcmjsi(1)-(pcmx1+pcmx2)
      pmscmy=pcmjsi(2)-(pcmy1+pcmy2)
      pmscmz=pcmjsi(3)-(pcmz1+pcmz2)
      pmscm=sqrt(pmscmx**2+pmscmy**2+pmscmz**2)
      emscm=pcmjsi(4)-(pcmpp1(4)+pcmpp2(4))
c
      thkkcm = theta12(pcmx1,pcmy1,pcmz1,pcmx2,pcmy2,pcmz2)
      if( thkkcm.lt.0.0 ) return
c
c   direction of ... ppbar plane in pi0_cm frame
      vndcmx = pcmy1*pcmz2-pcmz1*pcmy2
      vndcmy = pcmz1*pcmx2-pcmx1*pcmz2
      vndcmz = pcmx1*pcmy2-pcmy1*pcmx2
c
c !  neutral tracks
      ige=0
      imodflg=0
      ig=0
      ig1=0
      ig2=0
      ig3=0
      ig4=0
      ngg=0
      nngg=0
c   thecut1 ( good gamma theta cut ) .................... (besior--usearg(10) )
c   thecut2 ( good gamma theta cut ) ...............................usearg(9) )
c   eggcut1 ( energy cut on good gamma )............................usearg(8) )
c   tdfcut1 ( thdf pre_cut on good gamma )..........................usearg(7) )
c   nsclcut ( number of sc hit layers)..............................usearg(6) )
c   nfsclcut ( # of first sc hit layer )............................usearg(5) )
c   nfsclcut1 ( # of first sc hit layer )...........................usearg(4) )
c   eggcut2 ( energy cut on good gamma )............................usearg(3) )
      thecut1   = float(usearg(10))/10000.
      thecut2   = float(usearg(9))/10000.
      phicut1   = 20.
      phicut2   = 20.
      eggcut1   = float(usearg(8))/1000.
      tdfcut1   = float(usearg(7))
      nsclcut   = usearg(6)
      nfsclcut  = usearg(5)
      nfsclcut1 = usearg(4)
      eggcut2   = float(usearg(3))/1000.      
      do 200 i3=nchrg+1,nchrg+nneu
        if( trksub(1,i3).ne.0 ) then
          if( itrk(trksub(1,i3)+4).eq.0 ) then
c   shower counter
            if( trksub(5,i3).ne.0 ) then
c   mod.#, energy, first layer coordination & direction cosines
c   of neutral track     
c   ! ig is index for gamma and its last value is also tot.# of gamma 
              indg=trksub(5,i3)
              imod=itrk(trksub(5,i3)+20)
c
              if( imod.ne.1 ) then
                imodflg=-10
                ige=ige+1
                if( ige.gt.20 ) return
                goto 200
              endif
c
              ig=ig+1
              idg(ig)=i3
c
              escn(ig)=trk(trksub(5,i3)+14)
              nscl(ig)=itrk(trksub(5,i3)+31)
              nfscl(ig)=itrk(trksub(5,i3)+32)
              nsth=0
              do il=1,nscl(ig)
                indg_l=indg+31+(il-1)*7
                nsth = nsth+itrk(indg_l+2)
                width(il)=float(itrk(indg_l+2))
              end do
              ntht(ig)=nsth
              wmax(ig)=vmax(width,nscl(ig))
c
              call hfill(501,escn(ig),0.,1.)
              call hfill(502,float(nscl(ig)),0.,1.)
	      call hfill(503,float(nfscl(ig)),0.,1.)
c
              scfx(ig)=trk(trksub(5,i3)+4)-rx0
              scfy(ig)=trk(trksub(5,i3)+6)-ry0
              scfz(ig)=trk(trksub(5,i3)+8)-rz0
              scr=sqrt(trk(trksub(5,i3)+4)**2+trk(trksub(5,i3)+6)**2)
              scosx(ig)=trk(trksub(5,i3)+27)
              scosy(ig)=trk(trksub(5,i3)+28)
              scosz(ig)=trk(trksub(5,i3)+29)
              rscf(ig)=sqrt(scfx(ig)**2+scfy(ig)**2+scfz(ig)**2)
              rscd(ig)=sqrt(scosx(ig)**2+scosy(ig)**2+scosz(ig)**2)
              if( rscf(ig).le.0.0.or.rscd(ig).le.0.0 ) goto 200
              rcosg=scfz(ig)/rscf(ig)
              call hfill(504,rcosg,0.,1.)
c
              phif(ig)=trk(trksub(5,i3)+12)
              phih(ig)=trk(trksub(5,i3)+35)
              phid(ig)=phi(scosx(ig),scosy(ig))
c         
              phdh(ig)=phi12(phid(ig),phih(ig))
              phdf(ig)=phi12(phid(ig),phif(ig))
              phhf(ig)=phi12(phih(ig),phif(ig))
              phmh(ig)=phi12(phih(ig),phms)
              phmf(ig)=phi12(phif(ig),phms)
              phph1(ig)=phi12(phih(ig),phip1)
              phph2(ig)=phi12(phih(ig),phip2)
c              phpf1(ig)=phi12(phif(ig),phip1)
c              phpf2(ig)=phi12(phif(ig),phip2)
              phpd1(ig)=phi12(phid(ig),phiscp1)
              phpd2(ig)=phi12(phid(ig),phiscp2)
c          angle between 'origin' & 'track' direction
              thdf(ig)=theta12(scfx(ig),scfy(ig),scfz(ig),
     *                         scosx(ig),scosy(ig),scosz(ig))
              call hfill(505,thdf(ig),0.,1.)
c          angle between missing_p (charged) & 'origin' direction
              thmf(ig)=theta12(pxms,pyms,pzms,
     *                         scfx(ig),scfy(ig),scfz(ig))
              rq2mf(ig)=4*pms**2*(sin(thmf(ig)*3.1415927/360.0))**2
c          angle between pp1 & 'origin' direction
              if( iscflgp1.ge.0.0 ) then
                thpf1(ig)=theta12(scfpx1,scfpy1,scfpz1,
     *                            scfx(ig),scfy(ig),scfz(ig))
                cospg1=cos(thpf1(ig)*3.1415927/180.0)
                phpf1(ig)=phi12(phif(ig),phip1)
                call hfill(506,thpf1(ig),0.,1.)
	        call hfill(508,thpf1(ig),escn(ig),1.)
                call hfill(511,phpf1(ig),0.,1.)
              else
                thpf1(ig)=200.0
                phpf1(ig)=200.0
              endif
c          angle between pp2 & 'origin' direction
              if( iscflgp2.ge.0.0 ) then
                thpf2(ig)=theta12(scfpx2,scfpy2,scfpz2,
     *                            scfx(ig),scfy(ig),scfz(ig))
                cospg2=cos(thpf2(ig)*3.1415927/180.0)
                phpf2(ig)=phi12(phif(ig),phip2)
                call hfill(507,thpf2(ig),0.,1.)
	        call hfill(508,thpf2(ig),escn(ig),1.)
                call hfill(512,phpf2(ig),0.,1.)
              else
                thpf2(ig)=200.0
                phpf2(ig)=200.0
              endif
c          angle between pp1 & 'track' direction
              thpd1(ig)=theta12(scospx1,scospy1,scospz1,
     *                          scosx(ig),scosy(ig),scosz(ig))
c          angle between pp2 & 'track' direction
              thpd2(ig)=theta12(scospx2,scospy2,scospz2,
     *                          scosx(ig),scosy(ig),scosz(ig))
c          angle between vn & 'origin' direction
              thvf(ig)=theta12(vndx,vndy,vndz,
     *                         scfx(ig),scfy(ig),scfz(ig))-90.0
c          pre-select good gamma 
              cospg1=cos(thpf1(ig)*3.1415927/180)
              cospg2=cos(thpf2(ig)*3.1415927/180)
c              if( cospg1.lt.thecut2.and.cospg2.lt.thecut2 )
              if(phicut1.lt.phpf1(ig).and.phicut2.lt.phpf2(ig)) 
     *          then
                ig1=ig1+1
                if( thdf(ig).ge.tdfcut1 ) goto 200
                ig2=ig2+1
                if( nscl(ig).lt.nsclcut.and.nfscl(ig).gt.nfsclcut.and.
     *              escn(ig).lt.eggcut2 ) goto 200
                ig3=ig3+1
                if( nfscl(ig).gt.nfsclcut1 ) goto 200
                ig4=ig4+1
                nngg=nngg+1
czj                call hfill(508,thpf1(ig),escn(ig),1.)
czj                call hfill(508,thpf2(ig),escn(ig),1.)
                idg_sg(nngg)=i3
                escn_sg(nngg)=escn(ig)
                nscl_sg(nngg)=nscl(ig)
                nfscl_sg(nngg)=nfscl(ig)
                scfx_sg(nngg)=scfx(ig)
                scfy_sg(nngg)=scfy(ig)
                scfz_sg(nngg)=scfz(ig)
                rscf_sg(nngg)=rscf(ig)
              endif
            endif
          endif
	endif
200   continue
      if( nngg.le.0.0 ) return
c
c   select good gamma
c
      do 300 iig=1,ig
        cospg1=cos(thpf1(iig)*3.1415927/180)
        cospg2=cos(thpf2(iig)*3.1415927/180)
c        if( cospg1.ge.thecut1.or.cospg2.ge.thecut1 )
        if(phicut1.gt.phpf1(iig).or.phicut2.gt.phpf2(iig)) 
     *    goto 300
        if( thdf(iig).ge.tdfcut1 ) goto 300
        if( nscl(iig).lt.nsclcut.and.nfscl(iig).gt.nfsclcut.and.
     *      escn(iig).lt.eggcut2 ) goto 300
        if( nfscl(iig).gt.nfsclcut1 ) goto 300
        if( escn(iig).le.eggcut1 ) goto 300
        ngg=ngg+1
        idg_g(ngg)=idg(iig)
        escn_g(ngg)=escn(iig)
        nscl_g(ngg)=nscl(iig)
        nfscl_g(ngg)=nfscl(iig)
        scfx_g(ngg)=scfx(iig)
        scfy_g(ngg)=scfy(iig)
        scfz_g(ngg)=scfz(iig)
        scosx_g(ngg)=scosx(iig)
        scosy_g(ngg)=scosy(iig)
        scosz_g(ngg)=scosz(iig)
        rscf_g(ngg)=rscf(iig)
        rscd_g(ngg)=rscd(iig)
        rcosgg=scfz_g(ngg)/rscf_g(ngg)
        thdf_g(ngg)=thdf(iig)
        thmf_g(ngg)=thmf(iig)
        thmd_g(ngg)=thmd(iig)
        thpf1_g(ngg)=thpf1(iig)
        thpd1_g(ngg)=thpd1(iig)
        thpf2_g(ngg)=thpf2(iig)
        thpd2_g(ngg)=thpd2(iig)
        thvf_g(ngg)=thvf(iig)
        phdh_g(ngg)=phdh(iig)
        phdf_g(ngg)=phdf(iig)
        phif_g(ngg)=phif(iig)
        phmh_g(ngg)=phmh(iig)
        phmf_g(ngg)=phmf(iig)
        phph1_g(ngg)=phph1(iig)
        phph2_g(ngg)=phph2(iig)
        phpf1_g(ngg)=phpf1(iig)
        phpf2_g(ngg)=phpf2(iig)
        phpd1_g(ngg)=phpd1(iig)
        phpd2_g(ngg)=phpd2(iig)
        rq2mf_g(ngg)=rq2mf(iig)
        rq2md_g(ngg)=rq2md(iig)
        plabg(1)=scfx(iig)
        plabg(2)=scfy(iig)
        plabg(3)=scfz(iig)
        plabg(4)=rscf(iig)
        call lab_cm(rmpi0,ppi0,plabg,pcmg)
        thmfcm_g(ngg)=theta12(ppi0(1),ppi0(2),ppi0(3),
     *                        pcmg(1),pcmg(2),pcmg(3))
        phcm_g=phi(pcmg(1),pcmg(2))
        phmfcm_g(ngg)=phi12(phcm_g,phms)
        thpf1cm_g(ngg)=theta12(pcmx1,pcmy1,pcmz1,
     *                         pcmg(1),pcmg(2),pcmg(3))
        thpf2cm_g(ngg)=theta12(pcmx2,pcmy2,pcmz2,
     *                         pcmg(1),pcmg(2),pcmg(3))
        thvfcm_g(ngg)=theta12(vndcmx,vndcmy,vndcmz,
     *                        pcmg(1),pcmg(2),pcmg(3))-90.0
        thvfcm1_g(ngg)=theta12(vndx,vndy,vndz,
     *                        pcmg(1),pcmg(2),pcmg(3))-90.0
300   continue
c
      if( ngg.le.0 ) return
c
c   squid for pi0
c
      chi2=2000000.0
      nnpi0=0
      rmgg=-10.0
      rmdif=-10.0
      energy=3.097
c
      if( nngg.ge.2 ) then
        do inp1=2,nngg
          do inp2=1,inp1-1
            nnpi0=nnpi0+1
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(inp2),npart,mass,pspec,rc,ivs)
      call psres2(rmpi0,3,4,nres,mres,pmem,mem,rc)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(inp2),npart,mass,pspec,rc,ivs)
      call psres2(rmpi0,3,4,nres,mres,pmem,mem,rc)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)

      chi2_p(nnpi0)=chi2
c
      thgg_p(nnpi0)=theta12(scfx_sg(inp1),scfy_sg(inp1),scfz_sg(inp1),
     *                      scfx_sg(inp2),scfy_sg(inp2),scfz_sg(inp2))
            egdif_p(nnpi0)=(escn_sg(inp1)-escn_sg(inp2))/
     *                     (escn_sg(inp1)+escn_sg(inp2))
           plab1(1)=scfx_sg(inp1)
           plab1(2)=scfy_sg(inp1)
           plab1(3)=scfz_sg(inp1)
           plab1(4)=rscf_sg(inp1)
           call lab_cm(rmpi0,ppi0,plab1,pcm1)
           plab2(1)=scfx_sg(inp2)
           plab2(2)=scfy_sg(inp2)
           plab2(3)=scfz_sg(inp2)
           plab2(4)=rscf_sg(inp2)
           call lab_cm(rmpi0,ppi0,plab2,pcm2)
c
           api0_cm(nnpi0)=theta12(pcm1(1),pcm1(2),pcm1(3),
     *                            -pcm2(1),-pcm2(2),-pcm2(3))
           plab1(1)=scfx_sg(inp2)
           plab1(2)=scfy_sg(inp2)
           plab1(3)=scfz_sg(inp2)
           plab1(4)=rscf_sg(inp2)
           call lab_cm(rmpi0,ppi0,plab1,pcm1)
           pcm2(1)=-pcm1(1)
           pcm2(2)=-pcm1(2)
           pcm2(3)=-pcm1(3)
           pcm2(4)=pcm1(4)
           call cm_lab(rmpi0,ppi0,pcm2,plab2)
c
           api0_1=theta12(scfx_sg(inp1),scfy_sg(inp1),scfz_sg(inp1),
     *                    plab2(1),plab2(2),plab2(3))
           plab1(1)=scfx_sg(inp1)
           plab1(2)=scfy_sg(inp1)
           plab1(3)=scfz_sg(inp1)
           plab1(4)=rscf_sg(inp1)
           call lab_cm(rmpi0,ppi0,plab1,pcm1)
           pcm2(1)=-pcm1(1)
           pcm2(2)=-pcm1(2)
           pcm2(3)=-pcm1(3)
           pcm2(4)=pcm1(4)
           call cm_lab(rmpi0,ppi0,pcm2,plab2)
           api0_2=theta12(scfx_sg(inp2),scfy_sg(inp2),
     *                           scfz_sg(inp2),
     *                           plab2(1),plab2(2),plab2(3))
c
           if( api0_1.le.api0_2 ) api0_p(nnpi0)=api0_1
           if( api0_2.lt.api0_1 ) api0_p(nnpi0)=api0_2
c
           pgx1=escn_sg(inp1)*scfx_sg(inp1)/rscf_sg(inp1)
           pgy1=escn_sg(inp1)*scfy_sg(inp1)/rscf_sg(inp1)
           pgz1=escn_sg(inp1)*scfz_sg(inp1)/rscf_sg(inp1)
           eg1=escn_sg(inp1)
           pgx2=escn_sg(inp2)*scfx_sg(inp2)/rscf_sg(inp2)
           pgy2=escn_sg(inp2)*scfy_sg(inp2)/rscf_sg(inp2)
           pgz2=escn_sg(inp2)*scfz_sg(inp2)/rscf_sg(inp2)
           eg2=escn_sg(inp2)
           rmgg_p(nnpi0)=sqrt((eg1+eg2)**2-(pgx1+pgx2)**2
     *                       -(pgy1+pgy2)**2-(pgz1+pgz2)**2)
c
           rmdif_p(nnpi0)=abs(rmgg_p(nnpi0)-rmpi0)
          end do
        end do
        chi2minp = vmin(chi2_p,nnpi0)
        idfp = lvmin(api0_p,nnpi0)
        thedif1=api0_p(idfp)
        rmgg=rmgg_p(idfp)
        thgg=thgg_p(idfp)
        egdif=egdif_p(idfp)
        thedif1_cm = vmin(api0_cm,nnpi0)
        rmdif=vmin(rmdif_p,nnpi0)
        idfpi0 = lvmin(rmdif_p,nnpi0)
        rmggpi0=rmgg_p(idfpi0)
      endif
c
c---squid for ggK+K-  (free combination of photon pairs)
c
      chi2=2000000.0
      nnpi01=0
      energy=3.097
c
      if( nngg.ge.2 ) then
        do inp1=2,nngg
          do inp2=1,inp1-1
            nnpi01=nnpi01+1
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(inp2),npart,mass,pspec,rc,ivs)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(inp2),npart,mass,pspec,rc,ivs)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)
      chi2_p1(nnpi01)=chi2
      pg1x1 = pfit(1,3)
      pg1y1 = pfit(2,3)
      pg1z1 = pfit(3,3)
      pg1e1 = pfit(4,3)
      pg1x2 = pfit(1,4)
      pg1y2 = pfit(2,4)
      pg1z2 = pfit(3,4)
      pg1e2 = pfit(4,4)
      rmpi01(nnpi01) = sqrt((pg1e1+pg1e2)**2-
     >     (pg1x1+pg1x2)**2-(pg1y1+pg1y2)**2-(pg1z1+pg1z2)**2)
c
          end do
        end do
c
        idfp1 = lvmin(chi2_p1,nnpi01)
        chi2minp1 = chi2_p1(idfp1)
        rmpi01m = rmpi01(idfp1)
      endif
c
c---squid for ggpi+pi-  (free combination of photon pairs)
c
      chi2=2000000.0
      nnpi02=0
      energy=3.097
c
      if( nngg.ge.2 ) then
        do inp1=2,nngg
          do inp2=1,inp1-1
            nnpi02=nnpi02+1
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmpi,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmpi,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(inp2),npart,mass,pspec,rc,ivs)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmpi,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmpi,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(inp2),npart,mass,pspec,rc,ivs)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)
      chi2_p2(nnpi02)=chi2
      pg2x1 = pfit(1,3)
      pg2y1 = pfit(2,3)
      pg2z1 = pfit(3,3)
      pg2e1 = pfit(4,3)
      pg2x2 = pfit(1,4)
      pg2y2 = pfit(2,4)
      pg2z2 = pfit(3,4)
      pg2e2 = pfit(4,4)
      rmpi02(nnpi02) = sqrt((pg2e1+pg2e2)**2-
     >     (pg2x1+pg2x2)**2-(pg2y1+pg2y2)**2-(pg2z1+pg2z2)**2)
c
          end do
        end do
c
        idfp2 = lvmin(chi2_p2,nnpi02)
        chi2minp2 = chi2_p2(idfp2)
        rmpi02m = rmpi02(idfp2)
      endif
c
c   squid for gkk
c
      chi2=200000.0
      do 400 ing=1,ngg
        epms_f(ing)=20.0
        rq2mg_f(ing)=20.0
        if( thmf_g(ing).ge.18.0 ) goto 400
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_g(ing),
     *                                  npart,mass,pspec,rc,ivs)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_g(ing),
     *                                   npart,mass,pspec,rc,ivs)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *               mres,pmem,mem,rc,chi2,pfit)
c
      chi2_g(ing)=chi2
c
        pf1 = sqrt(pfit(1,1)**2+pfit(2,1)**2+pfit(3,1)**2)
        pf2 = sqrt(pfit(1,2)**2+pfit(2,2)**2+pfit(3,2)**2)
        pfx1=pfit(1,1)
        pfy1=pfit(2,1)
        pfz1=pfit(3,1)
        pfx2=pfit(1,2)
        pfy2=pfit(2,2)
        pfz2=pfit(3,2)
        pfxg=pfit(1,3)
        pfyg=pfit(2,3)
        pfzg=pfit(3,3)
        vndfx = pfy1*pfz2-pfz1*pfy2
        vndfy = pfz1*pfx2-pfx1*pfz2
        vndfz = pfx1*pfy2-pfy1*pfx2
c
c  the 4-momentum of K+, K- & Gamma
c
        ppx1(ing) = pfit(1,1)
        ppy1(ing) = pfit(2,1)
        ppz1(ing) = pfit(3,1)
	ee1(ing) = pfit(4,1)
        amass1(ing) = mass(1)
        ppx2(ing) = pfit(1,2)
        ppy2(ing) = pfit(2,2)
        ppz2(ing) = pfit(3,2)
        ee2(ing) = pfit(4,2)
        amass2(ing) = mass(2)
        ppx3(ing) = pfit(1,3)
        ppy3(ing) = pfit(2,3)
        ppz3(ing) = pfit(3,3)
        ee3(ing) = pfit(4,3)
        amass3(ing) = mass(3)
c
        pfg_g(ing) = sqrt(pfit(1,3)**2+pfit(2,3)**2+pfit(3,3)**2)
        eftot = pfit(4,1)+pfit(4,2)
        efms=3.0969-eftot
        pfxms=-pfx1-pfx2
        pfyms=-pfy1-pfy2
        pfzms=-pfz1-pfz2
        phfms=phi(pfxms,pfyms)
        pfms=sqrt(pfxms*pfxms+pfyms*pfyms+pfzms*pfzms)
        cosg_f(ing)=pfzms/pfms
        if( pfms.le.0.0 ) return
        epms_f(ing)=efms-pfms
c
        phmg_f(ing)=phi12(phif_g(ing),phfms)
        thvg_f(ing)=abs(theta12(vndfx,vndfy,vndfz,
     *                scfx_g(ing),scfy_g(ing),scfz_g(ing))-90.0)
        thmg_f(ing)=theta12(pfxms,pfyms,pfzms,
     *                   scfx_g(ing),scfy_g(ing),scfz_g(ing))
        rq2mg_f(ing)=4*pfms**2*(sin(thmg_f(ing)*3.1415927/360.0))**2
c
        fmkk(ing)=sqrt(eftot**2-(pfit(1,1)+pfit(1,2))**2
     *          -(pfit(2,1)+pfit(2,2))**2-(pfit(3,1)+pfit(3,2))**2)
c
        fmgk1(ing)=sqrt((pfit(4,3)+pfit(4,1))**2
     *                  -(pfit(1,3)+pfit(1,1))**2
     *                  -(pfit(2,3)+pfit(2,1))**2
     *                  -(pfit(3,3)+pfit(3,1))**2)
        fmgk2(ing)=sqrt((pfit(4,3)+pfit(4,2))**2
     *                  -(pfit(1,3)+pfit(1,2))**2
     *                  -(pfit(2,3)+pfit(2,2))**2
     *                  -(pfit(3,3)+pfit(3,2))**2)
c
c--------  to calculate the 3 angles  --------
c
        do j=1,4
          do i=1,3
            p(j,i+80)=pfit(j,i)
          end do
        end do
        p(5,81)=mass(1)
        p(5,82)=mass(2)
        p(5,83)=mass(3)
c
        call punit$(80,3)
        call angle(80,81,82,0,83,cgammea,cresmea,ckmea,phikmea,0)
        thetv1(ing)=cgammea
        thetv2(ing)=cresmea
        thetam(ing)=ckmea  
        phim(ing)=phikmea 
c
c---------
c
        plabpp1(1)=pfx1
        plabpp1(2)=pfy1
        plabpp1(3)=pfz1
        plabpp1(4)=sqrt(rmkoan**2+pf1**2)
        plabpp2(1)=pfx2
        plabpp2(2)=pfy2
        plabpp2(3)=pfz2
        plabpp2(4)=sqrt(rmkoan**2+pf2**2)
        pp_cm(1)=-pfxms
        pp_cm(2)=-pfyms
        pp_cm(3)=-pfzms
        pp_cm(4)=eftot
        call lab_cm(fmkk(ing),pp_cm,plabpp1,p_cmpp1)
        thpf1_cm=theta12(p_cmpp1(1),p_cmpp1(2),p_cmpp1(3),
     *                   pp_cm(1),pp_cm(2),pp_cm(3))
        cospf1_cm(ing)=cos(thpf1_cm*3.1415927/180.0)
        call lab_cm(fmkk(ing),pp_cm,plabpp2,p_cmpp2)
        thpf2_cm=theta12(p_cmpp2(1),p_cmpp2(2),p_cmpp2(3),
     *                   pp_cm(1),pp_cm(2),pp_cm(3))
        cospf2_cm(ing)=cos(thpf2_cm*3.1415927/180.0)
400   continue
c
      idfg = lvmin(chi2_g,ngg)
      chi2ming = chi2_g(idfg)
c
c   squid for gpipi
c
      chi2=200000.0
      do 500 ing=1,ngg
        chi2_g(ing)=200000.0
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmpi,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmpi,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_g(ing),
     *                                npart,mass,pspec,rc,ivs)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmpi,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmpi,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_g(ing),
     *                                 npart,mass,pspec,rc,ivs)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)
c
      chi2_g(ing)=chi2
c
500   continue
c
      idfpi = lvmin(chi2_g,ngg)
      chi2minpi = chi2_g(idfpi)
c
      chi2p=chi2minp
      chi2g=chi2ming
c
      idhi = 999
      idsq = 999
      encom = -999.
      do i=1,nngg
        if(escn_sg(i).gt.encom) then
          encom=escn_sg(i)
          idhi = i
        endif
        if(escn_sg(i).eq.escn_g(idfg)) then
          idsq = i
        endif
      enddo
c
c---squid for ggK+K-  (one photon with highest energy )
c
      chi2=2000000.0
      nnpi03=0
      energy=3.097
c
      if( nngg.ge.2 ) then
        do inp1=1,nngg
           if(inp1.ne.idhi) then
             nnpi03=nnpi03+1
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(idhi),npart,mass,pspec,rc,ivs)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(idhi),npart,mass,pspec,rc,ivs)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)
      chi2_p3(nnpi03)=chi2
      pg3x1 = pfit(1,3)
      pg3y1 = pfit(2,3)
      pg3z1 = pfit(3,3)
      pg3e1 = pfit(4,3)
      pg3x2 = pfit(1,4)
      pg3y2 = pfit(2,4)
      pg3z2 = pfit(3,4)
      pg3e2 = pfit(4,4)
      rmpi03(nnpi03) = sqrt((pg3e1+pg3e2)**2-
     >     (pg3x1+pg3x2)**2-(pg3y1+pg3y2)**2-(pg3z1+pg3z2)**2)
c
           endif
c
        end do
c
        idfp3 = lvmin(chi2_p3,nnpi03)
        chi2minp3 = chi2_p3(idfp3)
        rmpi03m = rmpi03(idfp3)
      endif
c
c---squid for ggpi+pi-  (one photon with highest energy)
c
      chi2=2000000.0
      nnpi04=0
      energy=3.097
c
      if( nngg.ge.2 ) then
        do inp1=1,nngg
           if(inp1.ne.idhi) then
             nnpi04=nnpi04+1
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmpi,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmpi,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(idhi),npart,mass,pspec,rc,ivs)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmpi,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmpi,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(idhi),npart,mass,pspec,rc,ivs)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)
      chi2_p4(nnpi04)=chi2
      pg4x1 = pfit(1,3)
      pg4y1 = pfit(2,3)
      pg4z1 = pfit(3,3)
      pg4e1 = pfit(4,3)
      pg4x2 = pfit(1,4)
      pg4y2 = pfit(2,4)
      pg4z2 = pfit(3,4)
      pg4e2 = pfit(4,4)
      rmpi04(nnpi04) = sqrt((pg4e1+pg4e2)**2-
     >     (pg4x1+pg4x2)**2-(pg4y1+pg4y2)**2-(pg4z1+pg4z2)**2)
c
           endif
c
        end do
c
        idfp4 = lvmin(chi2_p4,nnpi04)
        chi2minp4 = chi2_p4(idfp4)
        rmpi04m = rmpi04(idfp4)
      endif
c
c---squid for ggK+K-  (one photon with ID = idfg )
c
      chi2=2000000.0
      nnpi05=0
      energy=3.097
c
      if( nngg.ge.2 ) then
        do inp1=1,nngg
           if(inp1.ne.idsq) then
             nnpi05=nnpi05+1
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(idsq),npart,mass,pspec,rc,ivs)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(idsq),npart,mass,pspec,rc,ivs)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)
      chi2_p5(nnpi05)=chi2
      pg5x1 = pfit(1,3)
      pg5y1 = pfit(2,3)
      pg5z1 = pfit(3,3)
      pg5e1 = pfit(4,3)
      pg5x2 = pfit(1,4)
      pg5y2 = pfit(2,4)
      pg5z2 = pfit(3,4)
      pg5e2 = pfit(4,4)
      rmpi05(nnpi05) = sqrt((pg5e1+pg5e2)**2-
     >     (pg5x1+pg5x2)**2-(pg5y1+pg5y2)**2-(pg5z1+pg5z2)**2)
c
           endif
c
        end do
c
        idfp5 = lvmin(chi2_p5,nnpi05)
        chi2minp5 = chi2_p5(idfp5)
        rmpi05m = rmpi05(idfp5)
      endif
c
c---squid for ggpi+pi-  (one photon with ID = idfg)
c
      chi2=2000000.0
      nnpi06=0
      energy=3.097
c
      if( nngg.ge.2 ) then
        do inp1=1,nngg
           if(inp1.ne.idsq) then
             nnpi06=nnpi06+1
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmpi,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmpi,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(idsq),npart,mass,pspec,rc,ivs)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmpi,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmpi,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,1,1,1,idg_sg(idsq),npart,mass,pspec,rc,ivs)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)
      chi2_p6(nnpi06)=chi2
      pg6x1 = pfit(1,3)
      pg6y1 = pfit(2,3)
      pg6z1 = pfit(3,3)
      pg6e1 = pfit(4,3)
      pg6x2 = pfit(1,4)
      pg6y2 = pfit(2,4)
      pg6z2 = pfit(3,4)
      pg6e2 = pfit(4,4)
      rmpi06(nnpi06) = sqrt((pg6e1+pg6e2)**2-
     >     (pg6x1+pg6x2)**2-(pg6y1+pg6y2)**2-(pg6z1+pg6z2)**2)
c
           endif
c
        end do
c
        idfp6 = lvmin(chi2_p6,nnpi06)
        chi2minp6 = chi2_p6(idfp6)
        rmpi06m = rmpi06(idfp6)
      endif
c
      chi2pi1 = chi2minp1
      chi2pi2 = chi2minp2
      chi2pi3 = chi2minp3
      chi2pi4 = chi2minp4
      chi2pi5 = chi2minp5
      chi2pi6 = chi2minp6
c
      if( chi2ming.ge.50.and.irun.gt.0 ) return       
c
c---squid for gg_{missing}K+K-  (loose photon selection)
c
      chi2=2000000.0
      nnpi07=0
      energy=3.097
c
      do inp1=1,nngg
        nnpi07 = nnpi07+1
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,0,0,0,0,npart,mass,pspec,rc,ivs)
      call psres2(rmpi0,3,4,nres,mres,pmem,mem,rc)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,0,0,0,0,npart,mass,pspec,rc,ivs)
      call psres2(rmpi0,3,4,nres,mres,pmem,mem,rc)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)
      chi2_p7(nnpi07)=chi2
c
         pk7x1 = pfit(1,1)
         pk7y1 = pfit(2,1)
         pk7z1 = pfit(3,1)
         pk7e1 = pfit(4,1)
         pk7x2 = pfit(1,2)
         pk7y2 = pfit(2,2)
         pk7z2 = pfit(3,2)
         pk7e2 = pfit(4,2)
         pg7x1 = pfit(1,3)
         pg7y1 = pfit(2,3)
         pg7z1 = pfit(3,3)
         pg7e1 = pfit(4,3)
         pg7x2 = pfit(1,4)
         pg7y2 = pfit(2,4)
         pg7z2 = pfit(3,4)
         pg7e2 = pfit(4,4)
         rmpi07(nnpi07) = sqrt((pg7e1+pg7e2)**2-
     >        (pg7x1+pg7x2)**2-(pg7y1+pg7y2)**2-(pg7z1+pg7z2)**2)
         rmkk07(nnpi07) = sqrt((pk7e1+pk7e2)**2-
     >        (pk7x1+pk7x2)**2-(pk7y1+pk7y2)**2-(pk7z1+pk7z2)**2)
         rmks107(nnpi07) = sqrt((3.097-pk7e2)**2
     >                               -pk7x2**2-pk7y2**2-pk7z2**2)
         rmks207(nnpi07) = sqrt((3.097-pk7e1)**2
     >                               -pk7x1**2-pk7y1**2-pk7z1**2)
c
      end do
c
        idfp7 = lvmin(chi2_p7,nnpi07)
        chi2minp7 = chi2_p7(idfp7)
        rmpi07m = rmpi07(idfp7)
        rmkk07m = rmkk07(idfp7)      
        rmks107m = rmks107(idfp7)      
        rmks207m = rmks207(idfp7)      
c
c---squid for gg_{missing}K+K-  (tight photon selection)
c
      chi2=2000000.0
      nnpi08=0
      energy=3.097
c
      do inp1=1,ngg
        nnpi08 = nnpi08+1
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_g(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,0,0,0,0,npart,mass,pspec,rc,ivs)
      call psres2(rmpi0,3,4,nres,mres,pmem,mem,rc)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_g(inp1),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,0,0,0,0,npart,mass,pspec,rc,ivs)
      call psres2(rmpi0,3,4,nres,mres,pmem,mem,rc)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)
      chi2_p8(nnpi08)=chi2
c
         pk8x1 = pfit(1,1)
         pk8y1 = pfit(2,1)
         pk8z1 = pfit(3,1)
         pk8e1 = pfit(4,1)
         pk8x2 = pfit(1,2)
         pk8y2 = pfit(2,2)
         pk8z2 = pfit(3,2)
         pk8e2 = pfit(4,2)
         pg8x1 = pfit(1,3)
         pg8y1 = pfit(2,3)
         pg8z1 = pfit(3,3)
         pg8e1 = pfit(4,3)
         pg8x2 = pfit(1,4)
         pg8y2 = pfit(2,4)
         pg8z2 = pfit(3,4)
         pg8e2 = pfit(4,4)
         rmpi08(nnpi08) = sqrt((pg8e1+pg8e2)**2-
     >        (pg8x1+pg8x2)**2-(pg8y1+pg8y2)**2-(pg8z1+pg8z2)**2)
         rmkk08(nnpi08) = sqrt((pk8e1+pk8e2)**2-
     >        (pk8x1+pk8x2)**2-(pk8y1+pk8y2)**2-(pk8z1+pk8z2)**2)
         rmks108(nnpi08) = sqrt((3.097-pk8e2)**2
     >                               -pk8x2**2-pk8y2**2-pk8z2**2)
         rmks208(nnpi08) = sqrt((3.097-pk8e1)**2
     >                               -pk8x1**2-pk8y1**2-pk8z1**2)
c
      end do
c
        idfp8 = lvmin(chi2_p8,nnpi08)
        chi2minp8 = chi2_p8(idfp8)
        rmpi08m = rmpi08(idfp8)
        rmkk08m = rmkk08(idfp8)      
        rmks108m = rmks108(idfp8)      
        rmks208m = rmks208(idfp8)      
c
c---squid for gg_{missing}K+K-  (photon through 4-C)
c
      chi2=2000000.0
      nnpi09=0
      energy=3.097
c
      call psinit(energy,npart,nres,rc)
      if(ivs.ne.8.and.ivs.ne.103)then
      call pstrkcp(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call pstrkcp(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(idsq),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,0,0,0,0,npart,mass,pspec,rc,ivs)
      call psres2(rmpi0,3,4,nres,mres,pmem,mem,rc)
      elseif(ivs.eq.8.or.ivs.eq.103)then
      call psdotrkc(1,rmkoan,1,1,1,ipid1,npart,mass,pspec,rc,ivs)
      call psdotrkc(2,rmkoan,1,1,1,ipid2,npart,mass,pspec,rc,ivs)
      call pstrkcp(3,0.,1,1,1,idg_sg(idsq),npart,mass,pspec,rc,ivs)
      call pstrkcp(4,0.,0,0,0,0,npart,mass,pspec,rc,ivs)
      call psres2(rmpi0,3,4,nres,mres,pmem,mem,rc)
      endif  
c
      oksq=newsquid(npart,mass,pspec,nres,
     *              mres,pmem,mem,rc,chi2,pfit)
      nnpi09 = nnpi09+1
      chi2_p9(nnpi09)=chi2
c
         pk9x1 = pfit(1,1)
         pk9y1 = pfit(2,1)
         pk9z1 = pfit(3,1)
         pk9e1 = pfit(4,1)
         pk9x2 = pfit(1,2)
         pk9y2 = pfit(2,2)
         pk9z2 = pfit(3,2)
         pk9e2 = pfit(4,2)
         pg9x1 = pfit(1,3)
         pg9y1 = pfit(2,3)
         pg9z1 = pfit(3,3)
         pg9e1 = pfit(4,3)
         pg9x2 = pfit(1,4)
         pg9y2 = pfit(2,4)
         pg9z2 = pfit(3,4)
         pg9e2 = pfit(4,4)
         rmpi09(nnpi09) = sqrt((pg9e1+pg9e2)**2-
     >        (pg9x1+pg9x2)**2-(pg9y1+pg9y2)**2-(pg9z1+pg9z2)**2)
         rmkk09(nnpi09) = sqrt((pk9e1+pk9e2)**2-
     >        (pk9x1+pk9x2)**2-(pk9y1+pk9y2)**2-(pk9z1+pk9z2)**2)
         rmks109(nnpi09) = sqrt((3.097-pk9e2)**2
     >                               -pk9x2**2-pk9y2**2-pk9z2**2)
         rmks209(nnpi09) = sqrt((3.097-pk9e1)**2
     >                               -pk9x1**2-pk9y1**2-pk9z1**2)
c
        idfp9 = lvmin(chi2_p9,nnpi09)
        chi2minp9 = chi2_p9(idfp9)
        rmpi09m = rmpi09(idfp9)
        rmkk09m = rmkk09(idfp9)      
        rmks109m = rmks109(idfp9)      
        rmks209m = rmks209(idfp9)      
c
      chi2pi7 = chi2minp7
      chi2pi8 = chi2minp8
      chi2pi9 = chi2minp9
c
      rq2_100 = rq2mf_g(idfg)*100.0
      totth = 360.0-(thkk+thpf1_g(idfg)+thpf2_g(idfg))
      totthcm = 360.0-(thkkcm+thpf1cm_g(idfg)+thpf2cm_g(idfg))
      athvf=abs(thvf_g(idfg))
      athvfcm=abs(thvfcm_g(idfg))
c
czj      if( (pid1.ne.5.and.pid1.ne.51.and.pid1.ne.52).and.
czj     *    (pid2.ne.5.and.pid2.ne.51.and.pid2.ne.52) ) return
c
      xirun = float(irun)
      xirec = float(irec)
      xtottks = float(tottks)
      xnmdc = float(nmdc)
      xnneu = float(nneu)
      xpid1 = float(pid1)
      xpid2 = float(pid2)
      xrx1    = rx1
      xry1    = ry1
      xrz1    = rz1 
      xrx2    = rx2
      xry2    = ry2
      xrz2    = rz2
      xcosk1  = rcth1 
      xcosk2  = rcth2
      xpxyk1   = pxy1
      xpxyk2   = pxy2
      xpp1    = pp1
      xpp2    = pp2
      xtof1   = tof1
      xtof2   = tof2  
      xtq1 = tq1
      xtq2 = tq2
      xdeltat = rdelt
      iiscf1 = iscflgp1
      iiscf2 = iscflgp2
      xesc1     = esc1
      xesc2     = esc2
      xrmkk     = rmkk
      xrmks1 = rmkstar1
      xrmks2 = rmkstar2
      xrmkg1    = rmkg1
      xrmkg2    = rmkg2
      xumiss    = epms
      xapi0  = thedif1    
      xq2    = rq2mf_g(idfg)    
      xchi2g = chi2ming    
      xchi2pi= chi2minpi    
      xfmkk = fmkk(idfg)    
      xfmgk1 = fmgk1(idfg)    
      xfmgk2 = fmgk2(idfg)   
      xcthetv = thetv1(idfg)    
      xcthetx = thetv2(idfg)    
      xcthetm = thetam(idfg)    
      xphim = phim(idfg)    
      xescn = escn_g(idfg)    
      inscl = nscl_g(idfg)    
      infscl = nfscl_g(idfg)    
      xcosg = scfz_g(idfg)/rscf_g(idfg)    
      xthdf = thdf_g(idfg)    
      xthpf1 = thpf1_g(idfg)    
      xthpf2 = thpf2_g(idfg)
      xphpf1 = phpf1_g(idfg)    
      xphpf2 = phpf2_g(idfg)      
      inngg = nngg    
      ingg = ngg    
      xppx1 = ppx1(idfg)     
      xppy1 = ppy1(idfg)     
      xppz1 = ppz1(idfg)     
      xee1  = ee1(idfg)     
      xamass1 = amass1(idfg)    
      xppx2 = ppx2(idfg)     
      xppy2 = ppy2(idfg)     
      xppz2 = ppz2(idfg)     
      xee2  = ee2(idfg)     
      xamass2 = amass2(idfg)    
      xppx3 = ppx3(idfg)     
      xppy3 = ppy3(idfg)     
      xppz3 = ppz3(idfg)     
      xee3  = ee3(idfg)     
      xamass3 = amass3(idfg)    
      xrmht1 = rmht1
      xrmht2 = rmht2
      xchi2pi1 = chi2pi1
      xchi2pi2 = chi2pi2
      xchi2pi3 = chi2pi3
      xchi2pi4 = chi2pi4
      xchi2pi5 = chi2pi5
      xchi2pi6 = chi2pi6
      xchi2pi7 = chi2pi7 
      xchi2pi8 = chi2pi8
      xchi2pi9 = chi2pi9
      xrmpi01m = rmpi01m
      xrmpi02m = rmpi02m 
      xrmpi03m = rmpi03m 
      xrmpi04m = rmpi04m 
      xrmpi05m = rmpi05m 
      xrmpi06m = rmpi06m
      xrmpi07m = rmpi07m
      xrmpi08m = rmpi08m 
      xrmpi09m = rmpi09m
      xrmkk07m = rmkk07m
      xrmkk08m = rmkk08m 
      xrmkk09m = rmkk09m 
      xrmks107m = rmks107m
      xrmks108m = rmks108m 
      xrmks109m = rmks109m 
      xrmks207m = rmks207m
      xrmks208m = rmks208m 
      xrmks209m = rmks209m 
      xidflag1  = float(idflag1)
      xidflag2  = float(idflag2)
      xiddflag1  = float(iddflag1)
      xiddflag2  = float(iddflag2)
      XIDGDTOF1 = FLOAT(IDGDTOF1)
      XIDGDDEDX1 = FLOAT(IDGDDEDX1)
      XIDGDCOM1 = FLOAT(IDGDCOM1)
      XIDGDTOF2 = FLOAT(IDGDTOF2)
      XIDGDDEDX2 = FLOAT(IDGDDEDX2)
      XIDGDCOM2 = FLOAT(IDGDCOM2)
      Xthkk = thkk
      Xrx0 = rx0
      Xry0 = ry0 
      Xrz0 = rz0 
c
      call hfnt(2000)  
c
cc  endsl4
      return
      end
c
c**************************************************
      subroutine bespa1
c**************************************************
      return
      end
c**************************************************
      subroutine beshis
c***************************************************************c
c                                                               c
c   hbook id is defined as following:                           c
c    (1) *--- , here * represented selected evtype, i.e., for   c
c        besel*.                                                c
c    (2) -*--,  here * represented trklst subtype ( *=0 also    c
c        means from subtype_3, usually for track geometrical    c
c        properties ).                                          c
c    (3) --*- , here * means 'do *th kind of statistics '.      c
c                                                               c
c***************************************************************c
c
       include 'pawc.inc'
       call hlimit(npawc)
c
c   hbook id for besel4
c
      call hbook1(501,'energy deposited in BSC',150,0.,1.5,0.)
      call hbook1(502,'number of sc hit layers',8,-0.5,7.5,0.)
      call hbook1(503,'# of first sc hit layer',8,-0.5,7.5,0.)
      call hbook1(504,'cos(gamma) ag$',50,-1.0,1.0,0.)
      call hbook1(505,'angle (origin--track)$',60,0.0,180.,0.)
      call hbook1(506,'angle (pp1--origin)$',60,0.0,180.,0.)
      call hbook1(507,'angle (pp2--origin)$',60,0.0,180.,0.)
      call hbook2(508,'energy vs angle',180,0.0,180.,150,0.,1.5,0.)
      call hbook1(511,'phi angle (pp1--origin)$',60,0.0,180.,0.)
      call hbook1(512,'phi angle (pp2--origin)$',60,0.0,180.,0.)
      call hropen(41,'gkkn','gkknn.rz','n',1024,istat)
      call hbnt(2000,'gammakk','d')
      call hbname(2000, 'vblk1', xirun, 'irun:r' )
      call hbname(2000, 'vblk1', xirec, 'irec:r' )
      call hbname(2000, 'vblk1', xtottks, 'tottks:r' )
      call hbname(2000, 'vblk1', xnmdc, 'nmdc:r' )
      call hbname(2000, 'vblk1', xnneu, 'nneu:r' )
      call hbname(2000, 'vblk1', xrx1, 'rx1:r' )
      call hbname(2000, 'vblk1', xry1, 'ry1:r' )
      call hbname(2000, 'vblk1', xrz1, 'rz1:r' )
      call hbname(2000, 'vblk1', xrx2, 'rx2:r' )
      call hbname(2000, 'vblk1', xry2, 'ry2:r' )
      call hbname(2000, 'vblk1', xrz2, 'rz2:r' )
      call hbname(2000, 'vblk1', xcosk1, 'cosk1:r' )
      call hbname(2000, 'vblk1', xcosk2, 'cosk2:r' )
      call hbname(2000, 'vblk1', xpxyk1, 'pxyk1:r' )
      call hbname(2000, 'vblk1', xpxyk2, 'pxyk2:r' )
      call hbname(2000, 'vblk1', xpp1, 'pp1:r' )
      call hbname(2000, 'vblk1', xpp2, 'pp2:r' )
      call hbname(2000, 'vblk1', xtof1, 'tof1:r' )
      call hbname(2000, 'vblk1', xtof2, 'tof2:r' )
      call hbname(2000, 'vblk1', xtq1, 'tq1:r' )
      call hbname(2000, 'vblk1', xtq2, 'tq2:r' )
      call hbname(2000, 'vblk1', xpid1, 'pid1:r' )
      call hbname(2000, 'vblk1', xpid2, 'pid2:r' )
      call hbname(2000, 'vblk1', xdeltat, 'deltat:r' )
      call hbname(2000, 'vblk1', iiscf1, 'iscf1:i' )
      call hbname(2000, 'vblk1', iiscf2, 'iscf2:i' )
      call hbname(2000, 'vblk1', xesc1, 'esc1:r' ) 
      call hbname(2000, 'vblk1', xesc2, 'esc2:r' ) 
      call hbname(2000, 'vblk1', xrmkk, 'rmkk:r' )
      call hbname(2000, 'vblk1', xrmks1, 'rmks1:r' )
      call hbname(2000, 'vblk1', xrmks2, 'rmks2:r' )
      call hbname(2000, 'vblk1', xrmkg1, 'rmkg1:r' )
      call hbname(2000, 'vblk1', xrmkg2, 'rmkg2:r' )
      call hbname(2000, 'vblk1', xumiss, 'umiss:r' )
      call hbname(2000, 'vblk1', xapi0, 'api0:r' )
      call hbname(2000, 'vblk1', xq2, 'q2:r' )
      call hbname(2000, 'vblk1', xchi2g, 'chi2g:r' )
      call hbname(2000, 'vblk1', xchi2pi, 'chi2pi:r' )
      call hbname(2000, 'vblk1', xfmkk, 'fmkk:r' )
      call hbname(2000, 'vblk1', xfmgk1, 'fmgk1:r' ) 
      call hbname(2000, 'vblk1', xfmgk2, 'fmgk2:r' )
      call hbname(2000, 'vblk1', xcthetv, 'cthetv:r' )
      call hbname(2000, 'vblk1', xcthetx, 'cthetx:r' )
      call hbname(2000, 'vblk1', xcthetm, 'cthetm:r' )
      call hbname(2000, 'vblk1', xphim, 'phim:r' )
      call hbname(2000, 'vblk1', xescn, 'escn:r' )
      call hbname(2000, 'vblk1', inscl, 'nscl:i' )
      call hbname(2000, 'vblk1', infscl, 'nfscl:i' )                
      call hbname(2000, 'vblk1', xcosg, 'cosg:r' )
      call hbname(2000, 'vblk1', xthdf, 'thdf:r' )
      call hbname(2000, 'vblk1', xthpf1, 'thpf1:r' )
      call hbname(2000, 'vblk1', xthpf2, 'thpf2:r' )
      call hbname(2000, 'vblk1', xphpf1, 'phpf1:r' )  
      call hbname(2000, 'vblk1', xphpf2, 'phpf2:r' )
      call hbname(2000, 'vblk1', inngg, 'nngg:i' )
      call hbname(2000, 'vblk1', ingg, 'ngg:i' )
      call hbname(2000, 'vblk1', xppx1, 'ppx1:r' )
      call hbname(2000, 'vblk1', xppy1, 'ppy1:r' ) 
      call hbname(2000, 'vblk1', xppz1, 'ppz1:r' ) 
      call hbname(2000, 'vblk1', xee1, 'ee1:r' )
      call hbname(2000, 'vblk1', xamass1, 'amass1:r' )          
      call hbname(2000, 'vblk1', xppx2, 'ppx2:r' )
      call hbname(2000, 'vblk1', xppy2, 'ppy2:r' ) 
      call hbname(2000, 'vblk1', xppz2, 'ppz2:r' ) 
      call hbname(2000, 'vblk1', xee2, 'ee2:r' )
      call hbname(2000, 'vblk1', xamass2, 'amass2:r' )                
      call hbname(2000, 'vblk1', xppx3, 'ppx3:r' )
      call hbname(2000, 'vblk1', xppy3, 'ppy3:r' ) 
      call hbname(2000, 'vblk1', xppz3, 'ppz3:r' ) 
      call hbname(2000, 'vblk1', xee3, 'ee3:r' )
      call hbname(2000, 'vblk1', xamass3, 'amass3:r' )
      call hbname(2000, 'vblk1', xrmht1, 'rmht1:r' ) 
      call hbname(2000, 'vblk1', xrmht2, 'rmht2:r' ) 
      call hbname(2000, 'vblk1', xchi2pi1, 'chi2pi1:r' )
      call hbname(2000, 'vblk1', xchi2pi2, 'chi2pi2:r' )
      call hbname(2000, 'vblk1', xchi2pi3, 'chi2pi3:r' )
      call hbname(2000, 'vblk1', xchi2pi4, 'chi2pi4:r' )
      call hbname(2000, 'vblk1', xchi2pi5, 'chi2pi5:r' )
      call hbname(2000, 'vblk1', xchi2pi6, 'chi2pi6:r' )
      call hbname(2000, 'vblk1', xrmpi01m, 'rmpi01m:r' )
      call hbname(2000, 'vblk1', xrmpi02m, 'rmpi02m:r' )
      call hbname(2000, 'vblk1', xrmpi03m, 'rmpi03m:r' )
      call hbname(2000, 'vblk1', xrmpi04m, 'rmpi04m:r' )
      call hbname(2000, 'vblk1', xrmpi05m, 'rmpi05m:r' )
      call hbname(2000, 'vblk1', xrmpi06m, 'rmpi06m:r' )
      call hbname(2000, 'vblk1', xidflag1, 'idflag1:r' )
      call hbname(2000, 'vblk1', xidflag2, 'idflag2:r' )
      call hbname(2000, 'vblk1', x1time1, 'xx1time1:r' )
      call hbname(2000, 'vblk1', x1time2, 'xx1time2:r' )
      call hbname(2000, 'vblk1', x1time3, 'xx1time3:r' )
      call hbname(2000, 'vblk1', x1timee1, 'xx1timee1:r' )
      call hbname(2000, 'vblk1', x1timee2, 'xx1timee2:r' )
      call hbname(2000, 'vblk1', x1timee3, 'xx1timee3:r' )
      call hbname(2000, 'vblk1', x1timeoff1, 'xx1timeoff1:r' )
      call hbname(2000, 'vblk1', x1timeoff2, 'xx1timeoff2:r' )
      call hbname(2000, 'vblk1', x1timeoff3, 'xx1timeoff3:r' )
      call hbname(2000, 'vblk1', x1timesig1, 'xx1timesig1:r' )
      call hbname(2000, 'vblk1', x1timesig2, 'xx1timesig2:r' )
      call hbname(2000, 'vblk1', x1timesig3, 'xx1timesig3:r' )
      call hbname(2000, 'vblk1', x2time1, 'xx2time1:r' )
      call hbname(2000, 'vblk1', x2time2, 'xx2time2:r' )
      call hbname(2000, 'vblk1', x2time3, 'xx2time3:r' )
      call hbname(2000, 'vblk1', x2timee1, 'xx2timee1:r' )
      call hbname(2000, 'vblk1', x2timee2, 'xx2timee2:r' )
      call hbname(2000, 'vblk1', x2timee3, 'xx2timee3:r' )
      call hbname(2000, 'vblk1', x2timeoff1, 'xx2timeoff1:r' )
      call hbname(2000, 'vblk1', x2timeoff2, 'xx2timeoff2:r' )
      call hbname(2000, 'vblk1', x2timeoff3, 'xx2timeoff3:r' )
      call hbname(2000, 'vblk1', x2timesig1, 'xx2timesig1:r' )
      call hbname(2000, 'vblk1', x2timesig2, 'xx2timesig2:r' )
      call hbname(2000, 'vblk1', x2timesig3, 'xx2timesig3:r' )
      call hbname(2000, 'vblk1', xiddflag1, 'iddflag1:r' )
      call hbname(2000, 'vblk1', xiddflag2, 'iddflag2:r' )
      call hbname(2000, 'vblk1', x1xsp1, 'xx1xsp1:r' )
      call hbname(2000, 'vblk1', x1xsp2, 'xx1xsp2:r' )
      call hbname(2000, 'vblk1', x1xsp3, 'xx1xsp3:r' )
      call hbname(2000, 'vblk1', x1dedxoff1, 'xx1dedxoff1:r' )
      call hbname(2000, 'vblk1', x1dedxoff2, 'xx1dedxoff2:r' )
      call hbname(2000, 'vblk1', x1dedxoff3, 'xx1dedxoff3:r' )
      call hbname(2000, 'vblk1', x1dedxsig1, 'xx1dedxsig1:r' )
      call hbname(2000, 'vblk1', x1dedxsig2, 'xx1dedxsig2:r' )
      call hbname(2000, 'vblk1', x1dedxsig3, 'xx1dedxsig3:r' )
      call hbname(2000, 'vblk1', x2xsp1, 'xx2xsp1:r' )
      call hbname(2000, 'vblk1', x2xsp2, 'xx2xsp2:r' )
      call hbname(2000, 'vblk1', x2xsp3, 'xx2xsp3:r' )
      call hbname(2000, 'vblk1', x2dedxoff1, 'xx2dedxoff1:r' )
      call hbname(2000, 'vblk1', x2dedxoff2, 'xx2dedxoff2:r' )
      call hbname(2000, 'vblk1', x2dedxoff3, 'xx2dedxoff3:r' )
      call hbname(2000, 'vblk1', x2dedxsig1, 'xx2dedxsig1:r' )
      call hbname(2000, 'vblk1', x2dedxsig2, 'xx2dedxsig2:r' )
      call hbname(2000, 'vblk1', x2dedxsig3, 'xx2dedxsig3:r' )
      call hbname(2000, 'vblk1', xIDGDTOF1, 'IDGDTOF1:r' )
      call hbname(2000, 'vblk1', xIDGDDEDX1, 'IDGDDEDX1:r' )    
      call hbname(2000, 'vblk1', xIDGDCOM1, 'IDGDCOM1:r' )    
      call hbname(2000, 'vblk1', xIDGDTOF2, 'IDGDTOF2:r' )    
      call hbname(2000, 'vblk1', xIDGDDEDX2, 'IDGDDEDX2:r' )  
      call hbname(2000, 'vblk1', xIDGDCOM2, 'IDGDCOM2:r' )    
      call hbname(2000, 'vblk1', xthkk, 'thkk:r' )
      call hbname(2000, 'vblk1', xrx0, 'rx0:r' )
      call hbname(2000, 'vblk1', xry0, 'ry0:r' )
      call hbname(2000, 'vblk1', xrz0, 'rz0:r' )   
      call hbname(2000, 'vblk1', xchi2pi7, 'chi2pi7:r' )  
      call hbname(2000, 'vblk1', xchi2pi8, 'chi2pi8:r' )
      call hbname(2000, 'vblk1', xchi2pi9, 'chi2pi9:r' )  
      call hbname(2000, 'vblk1', xrmpi07m, 'rmpi07m:r' )  
      call hbname(2000, 'vblk1', xrmpi08m, 'rmpi08m:r' )  
      call hbname(2000, 'vblk1', xrmpi09m, 'rmpi09m:r' )
      call hbname(2000, 'vblk1', xrmkk07m, 'rmkk07m:r' )  
      call hbname(2000, 'vblk1', xrmkk08m, 'rmkk08m:r' )  
      call hbname(2000, 'vblk1', xrmkk09m, 'rmkk09m:r' )
      call hbname(2000, 'vblk1', xrmks107m, 'rmks107m:r' )  
      call hbname(2000, 'vblk1', xrmks108m, 'rmks108m:r' )  
      call hbname(2000, 'vblk1', xrmks109m, 'rmks109m:r' )
      call hbname(2000, 'vblk1', xrmks207m, 'rmks207m:r' )  
      call hbname(2000, 'vblk1', xrmks208m, 'rmks208m:r' )  
      call hbname(2000, 'vblk1', xrmks209m, 'rmks209m:r' )
c
      call hprnt(2000) 
c
c   hbook id for bespa1
c
      return
      end

c**************************************************
      subroutine hisout
c**************************************************
c
      call hrout(0,icycle,'t')
      call hprint(0)
      call hrend('gkkn')
c      close(ilun)
      return
      end
c************************************************************
      function theta12(x1,y1,z1,x2,y2,z2)
c************************************************************
c                                                           *
c  this is a function to compute the angel between two      *
c  vectors.                                                 *
c                                                           *
c************************************************************
      r1=sqrt(x1*x1+y1*y1+z1*z1)
      r2=sqrt(x2*x2+y2*y2+z2*z2)
      if( r1.le.0.0.or.r2.le.0.0 ) then
czj        write (6,*) '***theta12*** zero  vector'
czj        stop
      endif
      rd=(x1*x2+y1*y2+z1*z2)/(r1*r2)
      if( rd.le.-1.0 ) then
        theta12=180.0
      else if( rd.ge.1.0 ) then
        theta12=0.0
      else if( rd.lt.1.0.and.rd.gt.-1.0 ) then
        theta12=acos(rd)*180./3.1415927
      endif
c
ccendtheta12
      end
c************************************************************
      function phi(x,y)
c************************************************************
c
c   this function gives phi angle of a vector in x-y plane
c   input: x,y----cood.
c   
c************************************************************
c      if( abs(x).le.0.0.and.abs(y).le.0.0 ) then
c        write (6,*) '***phi*** zero x_y vector'
c        stop
c      endif
      if( abs(x).le.0.0.and.y.gt.0.0 ) phi=3.1415927/2.0
      if( abs(x).le.0.0.and.y.lt.0.0 ) phi=3.1415927*3.0/2.0
      if( abs(x).le.0.0 ) return           ! avoid y divided by zero
      r=y/x
      if( x.gt.0.0.and.y.ge.0.0 ) phi=atan(r)
      if( x.gt.0.0.and.y.le.0.0 ) phi=3.1415927*2+atan(r)
      if( x.lt.0.0.and.y.ge.0.0 ) phi=3.1415927+atan(r)
      if( x.lt.0.0.and.y.le.0.0 ) phi=3.1415927+atan(r)
c
cc  endphi
      end
c************************************************************
      function phi12(x,y)
c************************************************************
c                                                           *
c  this is a function to compute the phi ( projection )     *
c  angel ( in degree ) between two vectors.                 *
c                                                           *
c   input : x,y --- phi ( projection ) of each vector       *
c                                                           *
c************************************************************
      r=x-y
100   if( r.le.3.1415927.and.r.ge.-3.1415927 ) then
        phi12=r*180./3.1415927
      else if( r.gt.3.1415927 ) then
        r=r-2*3.1415927
        goto 100
      else if( r.lt.-3.1415927 ) then
        r=r+2*3.1415927
        goto 100
      endif
      phi12=abs(phi12)
c
cc  endphi12
      end
c************************************************************
      subroutine lab_cm(rm,p0,plab,pcm)
c************************************************************
c
c  this subroutine trans. 4_vector from lab to cm frame.
c
c     input: rm ----- rest mass of cm_particle
c            p0 ----- 4_vector of cm_particle in lab frame
c                     (3_p0,e0)
c            plab --- 4_vector in lab  (3_plab,elab)
c     output: pcm --- 4_vector in cm  (3_pcm,ecm)
c     call:   lorenf --- u102 in kernlib
c
c************************************************************
      real rm,p0(4),plab(4),pcm(4)
      call lorenf(rm,p0,plab,pcm)
c
cc  endlab_cm
      return
      end
c************************************************************
      subroutine cm_lab(rm,p0,pcm,plab)
c************************************************************
c
c  this subroutine trans. 4_vector from cm to lab frame.
c
c     input: rm ----- rest mass of cm_particle
c            p0 ----- 4_vector of cm_particle in lab frame
c                     (3_p0,e0)
c            pcm ---- 4_vector in cm  (3_pcm,ecm)
c     output: plab --- 4_vector in lab  (3_plab,elab)
c     call:   lorenb --- u102 in kernlib
c
c************************************************************
      real rm,p0(4),pcm(4),plab(4)
      call lorenb(rm,p0,pcm,plab)
c
cc  endcm_lab
      return
      end

	subroutine jpsi_run_status(irun,istatus)
	implicit none
C*********************************************************************
c
C  USAGE:   This program returns 'istatus' to show the J/psi run status
C	    by inputting the run number.
c 
C  INPUT:   irun,   run number.
c
C  OUTPUT:  istatus, the status of the run:
C           istatus = 1 : good runs.                 
c           istatus = 2 : good runs, with some problems, but
C	                  recommend be used,         
C           istatus = 3 : bad runs, should not be used,
c
c                                         Shen Xiaoyan and Zhao Zhengguo 
c
c                                         May 14, 2000
c
c********************************************************************
c
c  The second run Jpsi data was taken from Nov. 8, 2000 to April 3,
c  2001. The usable run of the second Jpsi data set is from 17209 to 
c  19149.
c
c                                         Shen Xiaoyan and Wang zheng
c
c                                         May 13, 2001
C*********************************************************************
c  Run 13531 - 13690:  taken from Nov. 29, 1999 - Dec. 10, 1999,
c                      totally around 1M hadron events.
c                      MDC threshold: 625, 1025 ...
c                      BSC E_tot_l and E_tot_h not determinded yet
c              (recommend not be used)     
c
c  From run 13691: all the MDC thresholds are set to be 625, 
c                  BSC E_tot_l = 20, E_tot_h = 65
c
c  From run 14029: MDC L6 4 cells' HV turned off
c
c  From run 14963: BSC E_tot_l = 23, E_tot_h = 70
c
c  From run 14890: ESC E_tot changed from 40 to 45,
c                  solved the inteference problem of SC reset signal
c                  to MDC. 
c
c  From run 15197: BSC E_tot_h = 75, add N_vc >= 1
c
c  From run 15443 - 15489: data taken at 3.0 GeV for background study
c
c  From run 15752: MDC L4 4 cells field wire HV changed from 1750 to 1200V.
c
c  From run 16262: MDC L6 4 cells field wire HV changed from 1750 to 1400V.
c
c  From run 16748 - 16777: MDC L4 4 cells dead.
c
c  From run 16836, BES started to do J/psi peak scan, Psi(2S) peak scan and
c                  Psi(2S) data taking.
c
c  The following list starts from Run 13691.
c
c*********************************************************************
c
	integer irun,istatus
c
        istatus = 1
c
        if (irun.lt.13691)                   istatus = 3 ! for tuning
        if (irun.ge.13742.and.irun.le.13748) istatus = 3 ! J/psi peak scan
        if (irun.eq.13847)                   istatus = 3 !
        if (irun.eq.13863)                   istatus = 2 ! Mu hot
        if (irun.ge.13931.and.irun.le.13939) istatus = 3 ! trig. eff. study
        if (irun.eq.13950)                   istatus = 3 ! BSC: many hot channels
        if (irun.eq.13998)                   istatus = 2 ! BSC: some hot channels
        if (irun.eq.14175)                   istatus = 2 ! BSC: some hot channels
        if (irun.eq.14227)                   istatus = 2 ! Mu: many hot channels
        if (irun.eq.14279.or.irun.eq.14280)  istatus = 3 ! MDC: many dead channels
        if (irun.ge.14323.and.irun.le.14324) istatus = 3 ! J/psi peak scan
        if (irun.eq.14445)                   istatus = 3 ! MDC power supply fuse broken
        if (irun.eq.14453)                   istatus = 3 ! empty
        if (irun.eq.14513)                   istatus = 3 ! MDC power supply fuse broken
        if (irun.eq.14514)                   istatus = 3 ! MDC power supply fuse broken
        if (irun.eq.14523)                   istatus = 3 ! MDC power supply fuse broken
        if (irun.eq.14524)                   istatus = 3 ! MDC power supply fuse broken
        if (irun.eq.14532)                   istatus = 3 ! empty
        if (irun.eq.14565)                   istatus = 2 ! BSC L1, L6 some dead channels
        if (irun.eq.14572)                   istatus = 3 ! MDC power supply fuse broken
        if (irun.eq.14631)                   istatus = 3 ! BADC read/write error
        if (irun.eq.14632)                   istatus = 3 ! BADC read/write error
        if (irun.eq.14638)                   istatus = 3 ! TOF dead
        if (irun.eq.14672)                   istatus = 3 ! empty
        if (irun.eq.14723)                   istatus = 3 ! BSC many hot channels, totally 7 mins.
        if (irun.eq.14724)                   istatus = 3 ! BSC hot, MDC power supply fuse broken
        if (irun.eq.14725)                   istatus = 3 ! BSC hot
        if (irun.eq.14726)                   istatus = 3 ! BSC hot, MDC power supply fuse broken
        if (irun.eq.14781.or.irun.eq.14782)  istatus = 2 ! BSC hot, totally 15 mins.
        if (irun.eq.14835)                   istatus = 3 ! TOF one crate dead
        if (irun.ge.14864.and.irun.le.14867) istatus = 2 ! BSC hot
        if (irun.ge.14871.and.irun.le.14874) istatus = 2 ! MDC dE/dX hot
        if (irun.eq.15159)                   istatus = 3 ! VME problem
        if (irun.eq.15418.or.irun.eq.15419)  istatus = 3 ! cosmic ray 
        if (irun.ge.15422.and.irun.le.15431) istatus = 3 ! trig. curve study
        if (irun.ge.15443.and.irun.le.15489) istatus = 3 ! 3.0 GeV data
        if (irun.eq.15622)                   istatus = 2 ! Mu hot
        if (irun.eq.15623)                   istatus = 3 ! empty
        if (irun.ge.15705.and.irun.le.15715) istatus = 3 ! J/psi peak scan
        if (irun.eq.15718)                   istatus = 3 ! empty
        if (irun.ge.16056.and.irun.le.16059) istatus = 3 ! J/psi peak scan
        if (irun.ge.16062.and.irun.le.16063) istatus = 3 ! J/psi peak scan
        if (irun.eq.16086)                   istatus = 3 ! MDC HV trip
        if (irun.eq.16368)                   istatus = 3 ! BSC some dead channels
        if (irun.eq.16517)                   istatus = 3 ! HV problem
        if (irun.eq.16593)                   istatus = 3 ! MDC dE/dX dead channles
        if (irun.ge.16594.and.irun.le.16596) istatus = 2 ! BSC hot
        if (irun.eq.16718.or.irun.eq.16719)  istatus = 2 ! TOF 65# dead
        if (irun.eq.16731)                   istatus = 3 !
        if (irun.ge.16836.and.irun.le.17018) istatus = 3 ! scan and Psi(2S) data 
c
c
c
c
c************************************for second run Jpsi data.
c
c Run 17019-----17208 Taken from Nov.8, 2000 to Nov.17, 2000. Used for
c                    threshold study, trigger effeciency study and 
c                    Jpsi peak scan. And also something is wrong
c                    with the Vertex part. Cann't be used.
c
c From 17073--17078  Threshold study.
c 
c From 17079--17085  Trigger effeciency study.
c
c From 17086         Etot-h=60, Etot-l=18, Radial threshold=12.
c
c From 17163         Etot-h=70, Etot-l=20.
c
c Form run 17209 to 17422, the vertex information doesn't match with 
c MDC information. But these runs are still usable after some 
c treatments.


       if (irun.ge.17019.and.irun.le.17208) istatus = 3 ! not usable            
       if (irun.eq.17238)                   istatus = 2 ! Beam lost
c      From 17244 Etot-h=80, Etot-l=20, radial threshold=25
       if (irun.eq.17244)                   istatus = 2 ! Beam lost
       if (irun.eq.17247)                   istatus = 2 ! Beam lost.
       if (irun.eq.17248)                   istatus = 2 ! MDC hot ch.
       if (irun.eq.17249)                   istatus = 2 ! MDC hot ch.
       if (irun.eq.17281)                   istatus = 3 ! Cosmic ray
c
c      Run 17281: Not set trigger table,from this run Etot-h=75
c      From run 17282, turn off ESC.                                  
       if (irun.ge.17286.and.irun.le.17290) istatus = 2 ! VC HV.err.
c      From 17291 Etot-h=70.
       if (irun.eq.17300)                   istatus = 3 ! no neutral trigger
       if (irun.eq.17305)                   istatus = 3 ! MDC hot 
       if (irun.eq.17307)                   istatus = 2 ! BSC hot ch.
       if (irun.eq.17344)                   istatus = 2 ! MU hot ch.
       if (irun.eq.17389)                   istatus = 3 ! MDC dead ch.
       if (irun.eq.17401)                   istatus = 3 ! VC dead ch.
       if (irun.ge.17402.and.irun.le.17403) istatus = 3 ! trigger err.
       if (irun.ge.17407.and.irun.le.17408) istatus = 3 ! MDC HV. err.
c      From 17409 MDC L1 one wire was broken, the HV of some cells were
c      turned off.
c
c      From 17423 VC is ok.
c      From 17438 Etot-h=65,Etot-l=17
       if (irun.eq.17440)                   istatus = 2 ! MU hot ch.
       if (irun.ge.17443.and.irun.le.17444) istatus = 3 ! MDC:L7 no HV.
       if (irun.eq.17461)                   istatus = 3 ! BTOF dead ch.
       if (irun.eq.17464)                   istatus = 3 ! BSC,MDC hot ch.
c      From 17470 BSC L6 a wire break.
       if (irun.eq.17472)                   istatus = 3 ! BSC HV error.
       if (irun.eq.17474)                   istatus = 2 ! MDC hot ch.
       if (irun.eq.17476)                   istatus = 3 ! BSC hot ch.
       if (irun.eq.17485)                   istatus = 2 ! MDC,BSC,MU hot ch.
       if (irun.eq.17503)                   istatus = 2 ! Beam is not good.
       if (irun.ge.17569.and.irun.le.17573) istatus = 3 ! Jpsi scan
       if (irun.eq.17582)                   istatus = 2 ! BSC dead ch.
       if (irun.eq.17591)                   istatus = 3 !
       if (irun.eq.17590)                   istatus = 2 ! BSC dead ch.
       if (irun.eq.17593)                   istatus = 2 ! MU hot ch.
c      From 17605, turn off ESC BADC.
       if (irun.ge.17643.and.irun.le.17645) istatus = 2 ! BSC hot ch.
       if (irun.ge.17648.and.irun.le.17654) istatus = 2 ! MU dead ch.
       if (irun.eq.17706)                   istatus = 3 ! MU no HV.
       if (irun.eq.17710)                   istatus = 2 ! MU hot ch.
       if (irun.ge.17726.and.irun.le.17736) istatus = 3 ! for trigger study.
       if (irun.eq.17750)                   istatus = 3 ! VC problem.
       if (irun.eq.17874)                   istatus = 2 ! MDC dead ch.
c      From 17867 to 17876, ESC on.
       if (irun.ge.17882.and.irun.le.17888) istatus = 3 ! Jpsi scan.
       if (irun.ge.17945.and.irun.le.17946) istatus = 2 ! MU hot ch.TOF HVerr
       if (irun.ge.17955.and.irun.le.17965) istatus = 2 ! NDC L10 hot ch.
       if (irun.eq.17968)                   istatus = 2 ! TOF hot ch.
       if (irun.ge.18087.and.irun.le.18122) istatus = 3 ! 3.0 GeV
       if (irun.ge.18246.and.irun.le.18250) istatus = 2 ! ETOF HV err.
       if (irun.eq.18281)                   istatus = 2 ! BSC hot ch.
       if (irun.eq.18340)                   istatus = 3 !
       if (irun.eq.18412)                   istatus = 3 ! VME eror.
       if (irun.eq.18420)                   istatus = 3 ! empty run
       if (irun.eq.18497)                   istatus = 3 ! empty run
       if (irun.eq.18560)                   istatus = 3 ! MDC HV err.
       if (irun.eq.18597)                   istatus = 3 ! MU no singal.
       if (irun.eq.18728)                   istatus = 3 ! empty run
       if (irun.eq.18782)                   istatus = 2 ! VC problem.
       if (irun.eq.18802)                   istatus = 2 ! MDC hot ch.
       if (irun.eq.18829)                   istatus = 3 ! empty run
       if (irun.eq.18986)                   istatus = 3 ! MU no HV.
       if (irun.ge.18993.and.irun.le.18994) istatus = 2 ! MDC hot ch.
       if (irun.eq.19050)                   istatus = 3 ! HV is off.
       if (irun.eq.19082)                   istatus = 3 ! MU no signal.
c      From 19150 to 19186 data taking for background study (3.0 GeV).
c      From 19187 to 19533 data taking for Jpsi , psi(2S),Jpsi" peak scan
c      and Jpsi(2s),Jpsi" data.
       if (irun.ge.19150)                   istatus = 3



       return
       end

*     ******************************************************************
*     *                                                                *
*     *        PWA Analysis of J/Psi --> Gamma K+ K- at BES !          *
*     *                                                                *
*     *                  data analysis program v 16.51                 *
*     *                                                                *
*     *                                                                *
*     *                                               Guo Zijin 1999   *
*     *                                                                *
*     ******************************************************************
*
*
*     ******************** parameter list ******************************
*
*     notation:   <spin(x) |l(Jpsi,Gamma), spin(Jpsi.Gamma)combined>
*
*     ******************  0+ partial wave **********************kon1(1)*
*
*     wmode(1)  ='<0+|00>'           !faa(  1-2  )    -   ca0p1
*
*     ******************  2+ partial wave **********************kon1(2)*
*
*     wmode(6)  ='<2+|02>'           !faa(  11-12  )   -   ca2p1
*     wmode(7)  ='<2+|20>'           !faa(  13-14  )
*     wmode(8)  ='<2+|2(1,2)>'       !faa(  15-16  )
*
*     ******************  4+ partial wave **********************kon1(3)*
*
*     wmode(18) ='<4+|22>'           !faa(  35-36  )  -   ca4p1
*     wmode(19) ='<4+|40>'           !faa(  37-38  )
*     wmode(20) ='<4+|4(1,2)>'       !faa(  39-40  )
*
*     ***************** end parameter list *****************************
*
*     ******************************************************************
*     *                                                                *
*     *        PWA Analysis of J/Psi --> Gamma K+ K-  at BES !         *
*     *                   begin of main program                        *
*     *                                                                *
*     ******************************************************************
*
      program gkkzj_r
      parameter (npa=41,nd1=10000,nd2=4,nall=35)
      parameter (nex=nd1*nd2*4)
      implicit complex (c)
*
*     *************** common blocks for fumili ******************
*
      common/a/faa(npa)
      common/pl/fpl(npa)
      common/au/famx(npa)
      common/exda/fex(nex)
      common/sigma/sig0(npa)
      common/al/famn(npa)
      common/ned/nt,ns
      common/uprmon/ijhr
*
*     ***********************************************************
*
      common/metr/eps(4,4,4,4),del(4,4),pn(4)
      common/iscba1/icase,mi1
      common/bar/fud1,fud2,fud3
      common/mass/amj,pk
      common/data/akn(nd1,2,5)
      common/coef/fun(21,21),nmode
      common/pan/pa(20,20)
*
*     ***********************************************************
*
      common/info/sx
      common/check/ak1(4),ak2(4),prob
      common/meth/method, nprojection
      common/norm/wa1,iyw
      common/dvb/ci
      common/parrho/pk2,sj
      common/ncount/ncount,nlimit,fudge
      common/funmode/xinmass,nof
      common/xinfo/xmass(11),xwidth(11)
      common/trans/fu(21,21)
      common/startup/idcs,funall(nd1,nall,nall)
      common/dly1/wazerop,watwop,wafourp,wac,wad
      common/cfnew/cf(20,4,4),kon(20),kon1(3),kon2
      common/x/x(11)
      common/fun_temp/fun_temp(21,21)
      common/cppp/cp(20),waa(npa),was
      common/nnn/Nreal,Nbg1,Nbg2,Nt1
*
      character wmode(20)*16,rmode(11)*10,asele(npa)*5,amode(npa)*16
      common/wrmode/wmode,rmode
      real dreson(11)
*
                                                             go to 20
   10 write(*, *) '****error****  please choose a right parameter ! *'
   20 write(*,*) '    '
*
      write(*,*) '    '
      write(*,*) '    '
      write(*,190)
      write(*,200)
      write(*,210)
      write(*,220)
      write(*,230)
      write(*,240)
      write(*,250)
      write(*,260)
      write(*,270)
      write(*,280)
      write(*,290)
      write(*,300)
      write(*,310)
      write(*,320)
      write(*,330)
      write(*,*) '    '
      write(*,*) '    '
*
      iflagcase = 0
*
*     ************** initial parameters *************************
*
      ci = cmplx( 0.0, 1.0 )
      pk  = 0.4936
      amj = 3.097
      pk2 = pk**2
      sj  = amj**2
*
*     ************** set up eps(i,j,k,l) and delta(i,j)**********
      call metric
*     ************** pn=momentum vector for Jpsi ****************
*
      do 30 i = 1, 3
         pn(i) = 0.0
   30 continue
      pn(4) = amj
*
*     ************** fud 1-3 are centrifugal barrier factors ****
*     ************** the old fud1 value was 0.3562 **************
*
      fud1 = 0.22
      fud2 = fud1**2
      fud3 = fud1/3.0
*
*     ***********************************************************
*
   40 ijhr = 0                           ! start piont ......dly!
*
*     ******************************************************************
*     * ijhr used by fumili                                            *
*     * icase=1 monte carlo evaluation required; 2 if read from store  *
*     * method=1 if monte carlo evaluation of denominator is done from *
*     * stored events; 2 to generate monte carlo data using the stored *
*     * parameters.                                                    *
*     * iyw=1 at first entry; set to 2 as a flag after normalisation   *
*     * integral has been done in subroutine integ                     *
*     * nlimit = number of monte carlo events                          *
*     * fudge= factor by which the probability of every event is       *
*     * multiplied in order to get the likelihood in a range near      *
*     * 1 for numerical convenience and accuracy                       *
*     * nprojection = a flag for use in method 2 to indicate wether    *
*     * the monte carlo data is to be used to create projection (1)    *
*     * or to calculate chai**2 (0)                                    *
*     ******************************************************************
*
      nlimit = 149971
      idcs   = 0
      fudge  = 5.0
      if ( iflagcase .ne. 0 )                                 go to 50
*
      write(*, *) '  '
      write(*, *) '******* please enter iflag ? ******'
      read(5, *, err = 10) iflag
*
      write(*, *) '  '
      write(*, *) 'ok, you have choosed iflag = ', iflag
      write(*, *) '  '
*
      if ( iflag .eq. 1 )                                         then
         icase  = 1
         method = 1
      else if ( iflag .eq. 2 )                                    then
         icase  = 2
         method = 1
      else if ( iflag .eq. 3 )                                    then
         icase  = 2
         method = 2
      else if ( iflag .eq. 4 )                                    then
         icase  = 1
         method = 1
      else if ( iflag .eq. 5 )                                    then
         icase  = 3
         method = 1
      else if ( iflag .eq. 6 )                                    then
         icase  = 1
         method = 1
      else
                                                              go to 10
      endif
*
*     ***********************************************************
*
   50 nprojection = 1                    ! continue piont
      iyw         = 1
*
*     **** read input parameter list ****************************
*
      open(1,file='res.inp', status='unknown')
      read(1,*) mii
      do i = 1, mii
         read(1,340) lg, xmass(i), xwidth(i), rmode(i)
      end do
      close(1)
*
      if ( method .eq. 1 )                                        then
         open(1,file='para.inp', status='unknown')
      else if ( method .eq. 2 )                                   then
         open(1,file='para.res',status='unknown')
      endif
*
      read(1,*) mi
      do i = 1, mi
         read(1,350) lg,faa(i),fpl(i),asele(i),amode(i),famn(i),famx(i)
      end do
      close(1)
*
      nmode = 20
      mi1   = mi
*
      do i = 1, nmode
         wmode(i) = amode( 2*i - 1 )
      end do
*
*     *********** set up some kinematics ************************
      open(1,file='fun.out',status='unknown')
*     *********** iain's routine for making projections *********
*
      if ( method .eq. 2 )                                        then
         write(*,*) '  '
         write(*,*) '**************************************************'
         write(*,*) 'icase = 2, method = 2, begin to project to data'
         write(*,*) '**************************************************'
         write(*,*) '  '
         do i=1, nmode + 1
           do j=1, nmode + 1
             read(1,*) fun_temp(i,j)
           end do
         end do
         close(1)
         call eval
         write(*,*) '  '
         write(*,*) '  '
         write(*,360)
         write(*,370)
         write(*,380)
         write(*,390)
         write(*,400) nlimit
         write(*,410)
         write(*,*) '  '
         write(*,*) '  '
         stop
      endif
*
      kon2 = 0
      do 60 i = 1, nmode + 1
         do 60 j = 1, nmode + 1
   60 fu(i,j) = 0.0
*
*     ** set up monte carlo sums for the denominator in fun(21,21) *****
*
      if ( icase .eq. 1 )                                         then
         write(*,*) '  '
         write(*,*) '**************************************************'
         write(*,*) 'icase = 1, method = 1, begin to generate mc data  '
         write(*,*) '**************************************************'
         write(*,*) '  '
         call integ(1)
*
         do 70 i = 1, nmode + 1
           do 72 j=1, nmode + 1
             write(1,*) fun(i,j)
   72      continue
   70    continue
         close(1)
*
         write(*,*) '  '
         write(*,*) '  '
         write(*,430)
         write(*,440)
         write(*,452)
         write(*,460) nlimit
         write(*,470)
         write(*,*) '  '
         write(*,*) '  '
*
         if ( iflag .ge. 4 )                                      then
            icase     = 2
            method    = 1
            iflagcase = 1
                                                              go to 40
         endif
         stop
      endif
*
*
*    **** read monte carlo data generated by BES howl ******************
*
      if ( icase .eq. 3 )                                         then
         write(*,*) '  '
         write(*,*) '**************************************************'
         write(*,*) 'icase = 3, method = 3, begin to calcute fun(i,j)'
         write(*,*) '**************************************************'
         write(*,*) '  '
         call conv(cp)
         call integ(3)
*
         do 75 i=1,nmode + 1
           do 77 j = 1, nmode + 1
             write(1,*)fun(i,j)
   77      continue
   75    continue
         close(1)
*
         write(*,*) '  '
         write(*,*) '  '
         write(*,430)
         write(*,445)
         write(*,450)
         write(*,460) nlimit
         write(*,470)
         write(*,*) '  '
         write(*,*) '  '
*
         stop
         endif
*
*     **** read monte carlo sums from store into fun(21,21)************
*
      if ( icase .eq. 2 )                                         then
         write(*,*) '  '
         write(*,*) '**************************************************'
         write(*,*) 'icase = 2, method = 1, begin to optimize cp(i) '
         write(*,*) '**************************************************'
         write(*,*) '  '
*
         do i=1, nmode + 1
           do j=1, nmode + 1
             read(1,*) fun(i,j)
           end do
         end do
*
         close(1)
*
         open(1,file='fun.out',status='unknown')
         do i=1, nmode + 1
           do j=1, nmode + 1
             read(1,*)fun_temp(i,j)
           end do
         end do
         close(1)
      endif
*
      do 80 i = 1, nmode + 1
        do 80 j = 1, nmode + 1
          fun(i,j) = fun(i,j)*10
   80 continue
*
*     ********* read data events ********************************
*
      open(1,file='real.dat',status='unknown')
      n1 = 0
      n2 = 0
      n3 = 0
      read(1,*) Nreal
      do 100 j1 = 1, Nreal
        read(1,*) ( ( akn(j1,j,i),i = 1, 3 ),j = 1, 2 )
        do 90 i1 = 1, 2
          akn(j1,i1,4) = sqrt( pk2 + akn(j1,i1,1)**2
     >           + akn(j1,i1,2)**2 + akn(j1,i1,3)**2 )
   90   continue
  100 continue
      close(1)
      open(1,file='bg1.dat',status='unknown')
      read(1,*) Nbg1
      do 1101 j1 = Nreal+1, Nreal+Nbg1
        read(1,*) ( ( akn(j1,j,i),i = 1, 3 ),j = 1, 2 )
        do 1102 i1 = 1, 2
          akn(j1,i1,4) = sqrt( pk2 + akn(j1,i1,1)**2
     >           + akn(j1,i1,2)**2 + akn(j1,i1,3)**2 )
 1102   continue
 1101 continue
      close(1)
      nt1  = Nreal + Nbg1
      open(1,file='bg2.dat',status='unknown')
      read(1,*) Nbg2
      do 2201 j1 = Nt1+1, Nt1+Nbg2
        read(1,*) ( ( akn(j1,j,i),i = 1, 3 ),j = 1, 2 )
        do 2202 i1 = 1, 2
          akn(j1,i1,4) = sqrt( pk2 + akn(j1,i1,1)**2
     >           + akn(j1,i1,2)**2 + akn(j1,i1,3)**2 )
 2202   continue
 2201 continue
      close(1)
*
      nt   = Nt1 + Nbg2
      Nact = Nreal - Nbg1 - Nbg2
*
*     ********** define fun values for all data points **********
*
      if ( icase .le. 2 )                                         then
         do 130 i = 1, Nt
*
            if ( i .eq. 10   ) write(*,*) 'no. real data event =', i
            if ( i .eq. 500  ) write(*,*) 'no. real data event =', i
            if ( i .eq. 1000 ) write(*,*) 'no. real data event =', i
            if ( i .eq. 1500 ) write(*,*) 'no. real data event =', i
            if ( i .eq. 2000 ) write(*,*) 'no. real data event =', i
*
            x(1) = i
            dummy = funct(x)
            j1 = 0
*
            do 120 j = 1, nmode
               if ( kon(j) .eq. 0 )                          go to 120
               j1 = j1 + 1
               if ( j1 .gt. nall )                           go to 120
               k1 = 0
               do 110 k = 1, nmode
                  if ( kon(k) .eq. 0 )                       go to 110
                  k1 = k1 + 1
                  if ( k1 .gt. nall )                        go to 110
                  funall(i,j1,k1) = fu(j, k)
  110          continue
  120       continue
*
            j1 = j1 + 1
            k1 = k1 + 1
            funall(i,j1,k1) = fu(21,21)
            if ( i .ne.  1)                                  go to 130
            if ( j1 .gt. nall .or. k1 .gt. nall )                 then
               write(*,*) 'dimension of funall is too small', j1, k1
               stop
            endif
*
  130    continue
         idcs = 1
         write(*,*) 'no. real data event =', Nact
*
      endif
*
*     ************ fumili data **********************************
*
      it   = 1
      ns   = 1
      n1   = 3
      n2   = 2
      n3   = 60
      epfu = 0.1
*
*     ***** data for array fex(nex) fumili **************************
*
      do 140 i = 1, nt
         fex(i) = i
  140 continue
*
*     ****************** enter maximum likelihood fit ******************
*     * write out fitted parameter list into file param1 (note that it *
*     * is written into file dout automatically at every iteration)    *
*     ******************************************************************
*
      call likelm(ss,mi,n1,n2,n3,epfu,aka,ala,it,ms)
*
      close(4)
      open (4,file='para.res',status='unknown')
      write(4,730) mi1
      do j = 1, mi1
         write(4,350) j,faa(j),fpl(j),asele(j),amode(j),famn(j),famx(j)
      end do
      close(4)
      open (4,file='error.res',status='unknown')
      write(4,*) mi1
      do j = 1, mi1
         write(4,*) j,sig0(j)
      end do
      close(4)
*
      tl  = 0.0
      tll = 0.0
      n   = 0
*
*     ** calculate the fitted likelihood function and write 10 events **
*
      do 150 i = 1, nt
         x(1) = i
         ddd  = funct(x)
*
         if( i.le.Nreal ) then
           ad = alog(ddd)
         else if( i.gt.Nreal.and.i.le.Nt1 ) then
           ad =-1*alog(ddd)
         else if( i.gt.Nt1.and.i.le.nt ) then
           ad =-1*alog(ddd)
         endif
*
         tl   = tl - ad
         if ( ddd .lt. 0.05 )                                     then
            tll = tll - ad
            n   = n + 1
         endif
  150 continue
*
      write(*,*) '  '
      write(*,*) '  '
      write(*,*) 'scan finish !'
      write(*,*) '  '
      write(*,*) 'sum of -log is equal to:'
      write(*,*) 'low cross-section points: (-lns<0.05)      ', tll, n
      write(*,*) 'number  real data points: ', Nact
*
*     ************ save the final results ***********************
*
      open (22, file='denom.out',status='unknown')
*
      write(22,590)
      write(22,480)
      write(22,610) ms
      if ( ms .eq. 1 )                                            then
         write(22,620)
      else if ( ms .eq. -1 )                                      then
         write(22,630)
      else if ( ms .eq. -2 )                                      then
         write(22,640)
      else if ( ms .eq. -3 )                                      then
         write(22,650)
      else if ( ms .eq. -4 )                                      then
         write(22,660)
      end if
      write(22,670) tl
      write(22,490) was
      write(22,700) Nact, nlimit
      write(22,710)
      write(22,*) '  '
      write(22,500)
*
      d0p = 0.0
      d2p = 0.0
      d4p = 0.0
*
      do i = 1, 11
         dreson(i) = 0.0
      end do
*
      do 170 i = 1, nmode
         if ( kon(i) .eq. 0 )                                go to 170
         do 160 j = 1, nmode
            if ( kon(j) .eq. 0 )                             go to 160
*
            if ( i .eq. j )                                       then
*
               write (22,*) '   '
               dvalue  = pa(i,j)*fun(i,j)/nlimit
               pdvalue = dvalue/was
               xnevents = pdvalue*Nact
*
               write (22,720) i, j, dvalue, pdvalue, xnevents,
     >                        wmode(i), wmode(j)
*
               if (i.ge.1 .and.i.le.5  .and. j.ge.1 .and.j.le.5 ) then
                  d0p = d0p + dvalue
               endif
               if (i.ge.6.and.i.le.17.and.j.ge.6 .and.j.le.17)    then
                  d2p = d2p + dvalue
               endif
               if (i.ge.18.and.i.le.20.and.j.ge.18 .and.j.le.20)  then
                  d4p = d4p + dvalue
               endif
* 0+
               if (i.eq.1 .and. j.eq.1)
     >                             dreson(1) = dreson(1) + dvalue
               if (i.eq.2 .and. j.eq.2)
     >                             dreson(2) = dreson(2) + dvalue
               if (i.eq.3 .and. j.eq.3)
     >                             dreson(3) = dreson(3) + dvalue
               if (i.eq.4 .and. j.eq.4)
     >                             dreson(4) = dreson(4) + dvalue
               if (i.eq.5 .and. j.eq.5)
     >                             dreson(5) = dreson(5) + dvalue

* 2+
               if ( i.ge.6.and.i.le.8.and.j.ge.6.and.j.le.8 )
     >                             dreson(6) = dreson(6) + dvalue
               if ( i.ge.9.and.i.le.11.and.j.ge.9.and.j.le.11)
     >                             dreson(7) = dreson(7) + dvalue
               if ( i.ge.12.and.i.le.14.and.j.ge.12.and.j.le.14 )
     >                             dreson(8) = dreson(8) + dvalue
               if ( i.ge.15.and.i.le.17.and.j.ge.15.and.j.le.17 )
     >                             dreson(9) = dreson(9) + dvalue
* 4+
               if ( i.ge.18.and.i.le.20.and.j.ge.18.and.j.le.20 )
     >                             dreson(10) = dreson(10) + dvalue
*
            endif
*
            if ( i .lt. j )                                       then
*
               dvar    = (pa(i,j)*fun(i,j) + pa(j,i)*fun(j,i))/nlimit
               pdvar   = dvar/was
               xnevents = pdvar*Nact
*
               if (dvar .ne. 0)                                   then
                  write (22,720) i, j, dvar, pdvar, xnevents,
     >                           wmode(i), wmode(j)
               end if
*
               if (i.ge.1 .and.i.le.5  .and. j.ge.1 .and.j.le.5 ) then
                  d0p = d0p + dvar
               endif
               if (i.ge.6.and.i.le.17.and.j.ge.6 .and.j.le.17)    then
                  d2p = d2p + dvar
               endif
               if (i.ge.18.and.i.le.20.and.j.ge.18 .and.j.le.20)  then
                  d4p = d4p + dvar
               endif

* 0+
               if (i.eq.1 .and. j.eq.1 )
     >                             dreson(1) = dreson(1) + dvar
               if (i.eq.2 .and. j.eq.2 )
     >                             dreson(2) = dreson(2) + dvar
               if (i.eq.3 .and. j.eq.3 )
     >                             dreson(3) = dreson(3) + dvar
               if (i.eq.4 .and. j.eq.4 )
     >                             dreson(4) = dreson(4) + dvar
               if (i.eq.5 .and. j.eq.5 )
     >                             dreson(5) = dreson(5) + dvar
* 2+
               if ( i.ge.6.and.i.le.8.and.j.ge.6.and.j.le.8 )
     >                             dreson(6) = dreson(6) + dvar
               if ( i.ge.9.and.i.le.11.and.j.ge.9.and.j.le.11 )
     >                             dreson(7) = dreson(7) + dvar
               if ( i.ge.12.and.i.le.14.and.j.ge.12.and.j.le.14 )
     >                             dreson(8) = dreson(8) + dvar
               if ( i.ge.15.and.i.le.17.and.j.ge.15.and.j.le.17 )
     >                             dreson(9) = dreson(9) + dvar
* 4+
               if ( i.ge.18.and.i.le.20.and.j.ge.18.and.j.le.20 )
     >                             dreson(10) = dreson(10) + dvar
            endif
*
  160    continue
  170 continue
*
      bgdenom = faa(41)*fun(21,21)/nlimit
*
      write (22,*) '  '
      write (22,510)
      write (22,520)
      write (22,530)
      write (22,540)
      write (22,530)
      write (22,550) 'zero plus', d0p, d0p/was, d0p/was*Nact
      write (22,550) 'two  plus', d2p, d2p/was, d2p/was*Nact
      write (22,550) 'four plus', d4p, d4p/was, d4p/was*Nact
      write (22,530)
*
      do 180 i = 1, 11
        if ( dreson(i) .lt. 0.000001 )                       go to 180
        write(22,550) rmode(i),dreson(i),
     >                         dreson(i)/was,dreson(i)/was*Nact
  180 continue
      write(22,550) 'bkg', bgdenom, bgdenom/was, bgdenom/was*Nact
*
      write (22,550) 'total denom', was ,was/was, was/was*Nact
      write (22,560)
*
      write(*,*) '  '
      write(*,*) '  '
      write(*,590)
      write(*,600)
      write(*,610) ms
      if ( ms .eq. 1 )                                            then
         write(*,620)
      else if ( ms .eq. -1 )                                      then
         write(*,630)
      else if ( ms .eq. -2 )                                      then
         write(*,640)
      else if ( ms .eq. -3 )                                      then
         write(*,650)
      else if ( ms .eq. -4 )                                      then
         write(*,660)
      end if
      write(*,670) tl
      write(*,490) was
      write(*,680)
      write(*,690)
      write(*,700) Nact,nlimit
      write(*,710)
      write(*,*) '  '
      write(*,*) '  '
*
      if ( iflag .ge. 6 )                                         then
         icase     = 2
         method    = 2
         iflagcase = 2
                                                              go to 40
      endif
      stop
*
  190 format(9x,'*****************************************************')
  200 format(9x,'* PWA Analysis of J/Psi --> Gamma K+ K-  at BES     *')
  210 format(9x,'*                                                   *')
  220 format(9x,'* please input run-time parameter                   *')
  230 format(9x,'* the availbale paramters are:                      *')
  240 format(9x,'* iflag=1 ==> icase=1, method=1, generate mc data   *')
  250 format(9x,'* iflag=2 ==> icase=2, method=1, optimize cp(i)     *')
  260 format(9x,'* iflag=3 ==> icase=2, method=2, project to data    *')
  270 format(9x,'* iflag=4 ==> do iflag=1 and iflag=2                *')
  280 format(9x,'* iflag=5 ==> icase=3, method=3, generate fun.out   *')
  290 format(9x,'* iflag=6 ==> do iflag=1, iflag=2 and iflag=3       *')
  300 format(9x,'* iflag=the other ==> please input again !          *')
  310 format(9x,'*                                                   *')
  320 format(9x,'* now, choose a flag !                              *')
  330 format(9x,'*****************************************************')
  340 format(3x, i2,f13.4,f13.4,20x,a10,2x)
  350 format(1x, i3,f9.4,f9.3,4x,a5,1x,a16,f10.3,f11.3)
  360 format(12x,'****************************************************')
  370 format(12x,'*  icase=2, method=2 has done !                    *')
  380 format(12x,'*  the results has been put to gkkzj-fit.tohbk !   *')
  390 format(12x,'*  you must run histogen to generate hbook file !  *')
  400 format(12x,'*  the numbers of mc events is',i10, '           *')
  410 format(12x,'****************************************************')
  420 format(97(e14.7,1x))
  430 format(12x,'****************************************************')
  440 format(12x,'*  icase=1, method=1 has done !                    *')
  445 format(12x,'*  icase=3, method=1 has done !                    *')
  452 format(12x,'*  the gen. mc data have been put to mcgkk.dat !   *')
  450 format(12x,'*  the fun result has been put to fun.out !        *')
  460 format(12x,'*  the numbers of mc events is',i10, '           *')
  470 format(12x,'****************************************************')
  480 format(12x,'*                fitting results                   *')
  490 format(12x,'*  the total denom value is:  ',f13.4, '        *')
  500 format(' i',2x,' j',2x,'   denom ',1x,'percent',1x,' nevents',2x,
     >'<partial wave mode> *<partial wave mode>')
  510 format(4x,'*****************************************************')
  520 format(4x,'*              conclusionm result                   *')
  530 format(4x,'*                                                   *')
  540 format(4x,'*    component      denom    percent     n-events   *')
  550 format(4x,'*   ',a10,3x, f8.3, 4x, f7.3, 4x, f9.4, '   *')
  560 format(4x,'*****************************************************')
  570 format(13x,'total      1.00---1.65   1.65---1.90   1.90---2.50'  )
  580 format(6x, 4f14.4)
  590 format(12x,'****************************************************')
  600 format(12x,'*  icase=2, method=1 has been done !               *')
  610 format(12x,'*  the optimitise situation is:',i3,6x,'           *')
  620 format(12x,'*         normal return on finding minimum !!!!    *')
  630 format(12x,'*         no further decrease in ob function ????  *')
  640 format(12x,'*         z matrix can not be inverted ????        *')
  650 format(12x,'*         iteraction limit exceeded ????           *')
  660 format(12x,'*         ml objective function is negative ????   *')
  670 format(12x,'*  the likelihood function is:',f13.4, '        *')
  680 format(12x,'*  the fitting results has been put to denom.out ! *')
  690 format(12x,'*  the fitting xpara.. has been put to para.res !  *')
  700 format(12x,'*  data events is:',i5,',   mc events is:',i8, '   *')
  710 format(12x,'****************************************************')
  720 format(i2,2x,i2,2x,f9.3,2x,f5.2,2x,f8.2,2x,a16,' *',a16)
  730 format(5x,i4)
  740 format(5x,4f15.4)
  750 format(3f12.3)
  760 format(/1x,70('-'),/)
*
      end
*
*     ******************************************************************
*     *                calculation of parameters cp(i)                 *
*     ******************************************************************
*
      subroutine conv(cp)
      parameter (npa=41,nd1=10000,nd2=4)
      implicit complex (c)
      common/a/faa(npa)
      common/pl/fpl(npa)
      common/cfnew/cf(20,4,4),kon(20),kon1(3),kon2
      common/dvb/ci
      common/fun_temp/fun_temp(21,21)
      common/coef/fun(21,21),nmode
      character wmode(20)*16,rmode(11)*10
      common/wrmode/wmode,rmode
      dimension cp(20)
*
      j = 1
      do 10 i = 1, nmode
*       cp(i) = cmplx( faa(j), faa(j+1) )
        PHI=FAA(J+1)*3.14159/180.
        CP(I)=FAA(J)*(COS(PHI)+CI*SIN(PHI))
        j = j + 2
   10 continue
***************************
*0+
cc        cp(3) = cp(4)*faa(5)
*2+
        cp(7) = cp(6)*faa(13)
        cp(8) = cp(6)*faa(15)
cc        cp(6) = cp(7)*faa(11)
cc        cp(8) = cp(7)*faa(15)
*
        cp(10) = cp(9)*faa(19)
        cp(11) = cp(9)*faa(21)
*
        cp(13) = cp(12)*faa(25)
        cp(14) = cp(12)*faa(27)
cccc        cp(12) = cp(13)*faa(23)
c        cp(14) = cp(13)*faa(27)
c        cp(12) = cp(14)*faa(23)
cc        cp(13) = cp(14)*faa(25)
*
cc        cp(16) = cp(15)*faa(31)
cc        cp(17) = cp(15)*faa(33)
*
*4+
cc        cp(19) = cp(18)*faa(37)
cc        cp(20) = cp(18)*faa(39)
*
      if ( kon2 .eq. 0 )                                          then
         j = 1
         do 50 i = 1, nmode
            kon(i) = 1
            if (  faa(j) .eq. 0. .and. faa(j+1) .eq. 0.
     >      .and. fpl(j) .le. 0. .and. fpl(j+1) .le. 0. )  kon(i) = 0
            j = j + 2
   50    continue
*
         write(*,*) '  '
         write(*,*) 'the partial waves used in the fit are :'
         write(*,*) '  '
         do 60 i = 1, nmode
            if ( kon(i) .ne. 0 ) write(*,140) i, kon(i), wmode(i)
   60    continue
         write(*,*) '  '
*
         do 70 i = 1, 3
   70       kon1(i) = 0
         do 80 i = 1, 5
   80       kon1(1) = kon1(1) + kon(i)
         do 90 i = 6, 17
            kon1(2) = kon1(2) + kon(i)
   90    continue
         do 95 i = 18, 20
            kon1(3) = kon1(3) + kon(i)
   95    continue
*
         kon2 = 1
         write(*,*) '   '
         write(*,150)
         write(*,160) (kon1(i),i = 1, 3), kon1(1)+kon1(2)+kon1(3)
         write(*,*) '   '
*
         do 130 i = 1, 20
            do 130 j = 1, 4
               do 130 k = 1, 4
  130    cf(i,j,k) = 0.0
*
      endif
*
  140 format(8x,i3,3x,i2,5x,a16)
  150 format(3x,'0+wave 2+wave 4+wave',3x,'total')
  160 format(2x,3(3x,i2,2x),5x,i2,2x)
*
      return
      end
*
*     ******************************************************************
*     *          calculation of the differential cross section         *
*     ******************************************************************
      function dcs(pa)
      parameter (npa=41,nd1=10000,nd2=4,nall=35)
      implicit complex (c)
      common/mass/amj,pk
      common/metr/eps(4,4,4,4),del(4,4),pn(4)
      common/a/faa(npa)
      common/info/sx
      common/iscba1/icase,mi1
      common/coef/fun(21,21),nmode
      common/bar/fud1,fud2,fud3
      common/trans/fu(21,21)
      common/check/ak1(4),ak2(4),prob
      common/akx/akx,q
      common/dvb/ci
      common/parrho/pk2,sj
      common/x/x(11)
      common/cppp/cp(20),waa(npa),was
      common/startup/idcs, funall(nd1,nall,nall)
      common/ncount/ncount,nlimit,fudge
      common/cfnew/cf(20,4,4),kon(20),kon1(3),kon2
      common/dly1/wazerop,watwop,wafourp,wac,wad
*
      dimension q(4),pa(20,20),akd(4),akx(4),
     >          delp(4,4),delpp(4,4),akxq(4)
*
      dimension akw(4),tf2(4,4),tf4(4,4,4,4)
*
*     ************ form amplitudes ******************************
*     ************ four-vectors for x and gamma, k12=k1-k2 ******
*
      do i = 1, 4
        akx(i) = ak1(i) + ak2(i)
        q(i) = pn(i) - ak1(i) - ak2(i)
        akd(i) = ak1(i) - ak2(i)
        akxq(i) = 2.0*(ak1(i) + ak2(i)) - pn(i)
      end do
*
      sx = scalar(akx,akx)
      q2gg=(3.097**2-sx)**2/(2*3.097)**2
*
      qkx   = scalar(q,akx)
      qkx2  = qkx**2
*
************************************************************************
      if( idcs .eq. 1 )                                          then
*
        wa = 0.0
        ii = x(1)
        i1 = 0
*
        do 20 i = 1, nmode
          if ( kon(i) .eq. 0 )                               go to 20
          i1 = i1 + 1
          j1 = 0
          do 10 j = 1, nmode
            if( kon(j) .eq. 0 )                              go to 10
              j1 = j1 + 1
              fu(i,j) = funall(ii,i1,j1)
              wa = wa + pa(i,j)*fu(i,j)
   10     continue
   20   continue
        i1 = i1 + 1
        j1 = j1 + 1
        fu(21,21) = funall(ii,i1,j1)
*
        if( wa .lt. 0.0001 )                                     then
          wa = 0.00001
        endif
*
        dcs = wa
        return
*
      endif
*
*    ****************** barrier func ********************
*
      qf2k = sx/4.0 - pk2
      qjsif = (pn(4)**2 - sx )**2/pn(4)**2/4.0
*
      b2gx = sqrt( qjsif**2 + 3.*qjsif*fud3 + 9.*fud3**2)
      b4gx = sqrt( qjsif**4 + 10.*qjsif**3*fud3 +
     >   135.*qjsif**2*fud3**2 + 1575.*qjsif*fud3**3 + 11025.*fud3**4)
*
      b2f2 = sqrt( qf2k**2 + 3.*qf2k*fud3 + 9.*fud3**2)
      b4f2 = sqrt( qf2k**4 + 10.*qf2k**3*fud3 +
     >   135.*qf2k**2*fud3**2 + 1575.*qf2k*fud3**3 + 11025.*fud3**4)
*
*     ******* factors for sums over spins ***********************
*
      do i = 1, 4
        do j = 1, 4
          delp(i,j)  = del(i,j) - akx(i)*akx(j)/sx
          delpp(i,j) = del(i,j) - ( q(i)*akx(j) + akx(i)*q(j) )/qkx
     >                                          + sx/qkx2*q(i)*q(j)
        end do
      end do
*
*     ************
*
      do i=1,4
        akw(i) = 0.0
      end do
*
      do i=1,4
        do j=1,4
          akw(i) = akw(i) + akd(j)*del(j,j)*delp(i,j)
        end do
      end do
*
      akxqw = scalar(akd,akw)
*
      do i=1,4
        do j=1,4
          tf2(i,j) = akw(i)*akw(j) - 1./3.*delp(i,j)*akxqw
*
          do k=1,4
            do l=1,4
              tf4(i,j,k,l) = akw(i)*akw(j)*akw(k)*akw(l) - akxqw/7.*
     >           (delp(i,j)*akw(k)*akw(l) + delp(j,k)*akw(i)*akw(l)
     >           +delp(k,i)*akw(j)*akw(l) + delp(i,l)*akw(j)*akw(k)
     >           +delp(j,l)*akw(k)*akw(i) + delp(k,l)*akw(i)*akw(j))
     >     + akxqw**2/35.*( delp(i,j)*delp(k,l)+delp(j,k)*delp(i,l)
     >                     +delp(k,i)*delp(j,l) )
            end do
          end do
*
        end do
      end do
*
*     *** propagators for 0+, 2+ and 4+ resonances ***
*
      cd0p1 = ca0p1(sx)
      cd0p2 = ca0p2(sx)
      cd0p3 = ca0p3(sx)
      cd0p4 = ca0p4(sx)
      cd0p5 = ca0p5(sx)
*
      cd2p1 = ca2p1(sx)
      cd2p2 = ca2p2(sx)
      cd2p3 = ca2p3(sx)
      cd2p4 = ca2p4(sx)
*
      cd4p1 = ca4p1(sx)
*
      cdbg  = cabg(sx)
*
*     ******************************************************************
*     *                        0+ contribution                         *
*     ******************************************************************
*
      if ( kon1(1) .eq. 0 )                                  go to 50
*
* for 0+
*
      do 40 i = 1, 2
        do 30 j = 1, 3
          if(j.ne.i) go to 30
*
          cf(1,i,j) = cd0p1*del(i,j)
*
          cf(2,i,j) = cd0p2*del(i,j)
*
*         cf(3,i,j) = cd0p3*del(i,j)
          cf(3,i,j) = cd0p4*del(i,j)*sx
*
          cf(4,i,j) = cd0p4*del(i,j)
*
          cf(5,i,j) = cd0p5*del(i,j)
*
   30   continue
   40 continue
*
   50 continue
*
*     ******************************************************************
*     *                        2+ contribution                         *
*     ******************************************************************
*
      if ( kon1(2) .eq. 0 )                                  go to 60
*
* for 2+
*
      do i=1,2
        do j=1,3
*
        cf(6,i,j) = cd2p1*tf2(i,j)/b2f2
        cf(7,i,j) = cd2p1*del(i,j)*tf2(4,4)/b2gx/b2f2
        cf(8,i,j) = cd2p1*akxq(i)*tf2(j,4)/b2gx/b2f2
*
        cf(9,i,j) = cd2p2*tf2(i,j)/b2f2
        cf(10,i,j) = cd2p2*del(i,j)*tf2(4,4)/b2gx/b2f2
        cf(11,i,j) = cd2p2*akxq(i)*tf2(j,4)/b2gx/b2f2
*
        cf(12,i,j) = cd2p3*tf2(i,j)/b2f2
        cf(13,i,j) = cd2p3*del(i,j)*tf2(4,4)/b2gx/b2f2
        cf(14,i,j) = cd2p3*akxq(i)*tf2(j,4)/b2gx/b2f2
*
        cf(15,i,j) = cd2p4*tf2(i,j)/b2f2
        cf(16,i,j) = cd2p4*del(i,j)*tf2(4,4)/b2gx/b2f2
        cf(17,i,j) = cd2p4*akxq(i)*tf2(j,4)/b2gx/b2f2
*
        end do
      end do
*
  60  continue
*
*     ******************************************************************
*     *                        4+ contribution                         *
*     ******************************************************************
*
      if ( kon1(3) .eq. 0 )                                  go to 70
*
* for 4+
*
      do i=1,2
        do j=1,3
*
          cf(18,i,j) = cd4p1*tf4(i,j,4,4)/b4f2/b2gx
          cf(19,i,j) = cd4p1*del(i,j)*tf4(4,4,4,4)/b4gx/b4f2
          cf(20,i,j) = cd4p1*akxq(i)*tf4(j,4,4,4)/b4gx/b4f2
*
        end do
      end do
*
   70 continue
*
*     ***********************************************************
*     *  ok, now calculation of the differential cross section  *
*     ***********************************************************
*
      wa      = 0.0
      wazerop = 0.0
      watwop  = 0.0
      wafourp = 0.0
      wac     = 0.0
      wad     = 0.0
*
      ii = x(1)
*
      do 90 i = 1, nmode
        if ( kon(i) .eq. 0 )                                 go to 90
        do 80 j = 1, nmode
          if ( kon(j) .eq. 0 )                               go to 80
*
          cw = 0.0
          do k = 1, 2
            do l = 1, 3
              do m = 1, 3
                cw = cw - cf(i,k,l)*conj(cf(j,k,m))*delpp(l,m)/2.0
              end do
	    end do
	  end do
*
          if ( i .eq. j ) fu(i,j) =  cw
          if ( i .lt. j ) fu(i,j) =  real(cw)
          if ( i .gt. j ) fu(i,j) = -aimag(cw)
*
          temp = pa(i,j)*fu(i,j)
          wa   = wa + temp
*
          if( i.ge.1 .and. i.le.5 .and. j.ge.1 .and. j.le.5 ) then
            wazerop = wazerop + temp
          endif
          if( i.ge.6 .and. i.le.17 .and. j.ge.6 .and. j.le.17 ) then
            watwop = watwop + temp
          endif
          if( i.ge.18 .and. i.le.20 .and. j.ge.18 .and. j.le.20 ) then
            wafourp = wafourp + temp
          endif
          if( i.ge.1 .and. i.le.5 .and. j.ge.6 .and. j.le.17 ) then
            wac = wac + temp
          endif
          if( i.ge.6 .and. i.le.17 .and. j.ge.1 .and. j.le.5 ) then
            wac = wac + temp
          endif
          if( i.ge.1 .and. i.le.1 .and. j.ge.6 .and. j.le.8 ) then
            wad = wad + temp
          endif
          if( i.ge.6 .and. i.le.8 .and. j.ge.1 .and. j.le.1 ) then
            wad = wad + temp
          endif
*
  80    continue
  90  continue
*
      fu(21,21) = cdbg
*
      if ( wa .lt. 0.0001 ) then
        wa = 0.00001
      endif
*
*** according to andrei
*
      if ( wa .lt. -0.001 ) then
        open(4, file='wa.dat',status='unknown')
        write(4,*)'wa = ',wa
        close(4)
      end if
*
***********************
*
      if ( wazerop .lt. 0.0001 )                                 then
        wazerop = 0.00001
      endif
      if ( watwop .lt. 0.0001 )                                  then
        watwop = 0.00001
      endif
      if ( wafourp .lt. 0.0001 )                                 then
        wafourp = 0.00001
      endif
*
      dcs = wa
*
      return
      end
*
*     ******************************************************************
*     *      this function is called for every data event in every     *
*     *      iteration by fumili                                       *
*     ******************************************************************
      function funct(x)
      parameter (npa=41,nd1=10000,nd2=4)
      implicit complex (c)
      common/a/faa(npa)
      common/data/akn(nd1,2,5)
      common/iscba1/icase,mi1
      common/coef/fun(21,21),nmode
      common/pan/pa(20,20)
      common/check/ak1(4),ak2(4),prob
      common/norm/wa1,iyw
      common/meth/method, nprojection
      common/cppp/cp(20),waa(npa),was
      common/ncount/ncount,nlimit,fudge
      common/cfnew/cf(20,4,4),kon(20),kon1(3),kon2
      common/trans/fu(21,21)
      common/gggg/fc
      dimension x(11)
*
*     ****** the event number is stored in x(1) and put into ii ********
*
      ii = x(1)
      if ( ii .ne. 1 )                                        go to 60
*
*     ******************************************************************
*     * form the denominator at first entry and store in was at first  *
*     * entry, calculate cp and pa; lambda parameters (coupling        *
*     * constants) are stored in faa(7) et seq and the list ends after *
*     * mm2 pairs of numbers; lambda set up in cp(1) to cp(mm2)        *
*     ******************************************************************
*
      call conv(cp)
*
      do 20 i = 1, nmode
         if ( kon(i) .eq. 0 )                                 go to 20
         do 10 j = 1, nmode
            if ( kon(j) .eq. 0 )                              go to 10
            cw = cp(i)*conj( cp(j) )
            if (i .eq. j ) pa(i,j) = cw
            if (i .lt. j ) pa(i,j) = 2.0*real(cw)
            if (i .gt. j ) pa(i,j) = 2.0*aimag(cw)
   10    continue
   20 continue
*
      was   = 0.0
*
      do 50 i = 1, nmode
         if ( kon(i) .eq. 0 )                                 go to 50
         do 40 j = 1, nmode
            if ( kon(j) .eq. 0 )                              go to 40
*
            was = was + pa(i,j)*fun(i,j)
*
   40    continue
   50 continue
*
      fc  = faa(41)
      was = was + faa(41)*fun(21,21)
      was = was/nlimit
      if ( ii .eq. 1 ) write(*,*) 'denom =', was
*
*     ********** form the numerator using pa ********************
*
   60 continue
      do 70 i = 1, 4
         ak1(i) = akn(ii,1,i)
         ak2(i) = akn(ii,2,i)
   70 continue
*
*     ********** likelihood function for this event *************
*
      temp1 = dcs(pa)
      temp2 = faa(41)*fu(21,21)
      prob  = ( temp1 + temp2 )*fudge
      funct = prob/was
*
      return
      end
*
*     ******************************************************************
*     *  this routine is used to prepare the values for pa for         *
*     *  method 2 monte carlo, and then call integ to generate         *
*     *  the data points.                                              *
*     ******************************************************************
*
      subroutine eval
      parameter (npa=41,nd1=10000,nd2=4)
      implicit complex (c)
      common/a/faa(npa)
      common/data/akn(nd1,2,5)
      common/iscba1/icase,mi1
      common/coef/fun(21,21),nmode
      common/pan/pa(20,20)
      common/norm/wa1,iyw
      common/meth/method, nprojection
      common/cppp/cp(20),waa(npa),was
      common/cfnew/cf(20,4,4),kon(20),kon1(3),kon2
      common/ncount/ncount,nlimit,fudge
*
*     ***** calculate cp and pa values for use in monte carlo **********
*
      call conv(cp)
*
*     ** pa(mm2,mm2) is a matrix containing lambda(i)*conj(lambda(j)) **
*     ** with a factor 2 for later arithmetic **************************
*
      do 20 i = 1, nmode
         if ( kon(i) .eq. 0 )                                   go to 20
         do 10 j = 1, nmode
            if ( kon(j) .eq. 0 )                                go to 10
            cw = cp(i)*conj(cp(j))
            if (i .eq. j ) pa(i,j) = cw
            if (i .lt. j ) pa(i,j) = 2.0*real(cw)
            if (i .gt. j ) pa(i,j) = 2.0*aimag(cw)
   10    continue
   20 continue
*
      call integ(2)
*
      return
      end
*
*     **********************************************************
*     *     calculation of the renormalization integral        *
*     **********************************************************
*
      subroutine integ(iph)
      parameter (npa=41,nd1=10000,nd2=1)
      implicit complex (c)
      common/coef/fun(21,21),nmode
      common/pan/pa(20,20)
      common/mass/amj,pk
      common/ned/nt,ns
      common/norm/wa1,iyw
      common/check/ak1(4),ak2(4),prob
      common/ncount/ncount,nlimit,fudge
      common/funmode/xinmass,nof
      common/meth/method, nprojection
      common weightmax, nflag
      common/util/np,tecm,amass(18),pcm(5,18),wt    ! for mc generator
*
      common/a/faa(npa)
      common/metr/eps(4,4,4,4),del(4,4),pn(4)
      common/iscba1/icase,mi1
      common/parrho/pk2,sj
      common/trans/fu(21,21)
      common/dly1/wazerop,watwop,wafourp,wac,wad
      dimension akx(4)
      dimension akr(10000,2,5),akb1(10000,2,5),akb2(10000,2,5)
      dimension xak1(3),xak2(3)
*
      real xak1,xak2,xp,sx,sqx
*
*     input for mc genev for J/Psi  -> Gamma K+ K-
*
      np=3
      tecm = amj
      amass(1)= pk
      amass(2)= pk
      amass(3)= 0.
*
      if ( iph .eq. 3 )              then
        do i = 1, nmode
          do j = 1, nmode
            if ( i .eq. j ) pa(i,j) = 1.0
            if ( i .lt. j ) pa(i,j) = 2.0
            if ( i .gt. j ) pa(i,j) = 0.0
            fun(i,j) = 0.0
          end do
        end do
            fun(21,21) = 0.0
*
        open (33, file='mcgkk.dat',status='old')
*
        read(33,*) nmc
*
        do i1=1, nmc
          read(33,*) (ak1(i2), i2=1,4)
          read(33,*) (ak2(i2), i2=1,4)
*
*     ****** form fun *******************
*
          temp1 = dcs(pa)
          wabg  = faa(41)*fu(21,21)
*
          do i = 1, nmode + 1
            do j = 1, nmode + 1
              fun(i,j) = fun(i,j) + fu(i,j)
            end do
          end do
*
        end do
*
        close(33)
        go to 200
*
      endif
*
      if ( iph .eq. 1 ) then
*
*     *********** open output file for mc **********************
*
        ncount=0
        open(44, file='mcgkk.dat',status='unknown')
*
        write(44,*) nlimit
  100   call genev                ! start mc !
*
        do j=1,4
          ak1(j)=pcm(j,1)
          ak2(j)=pcm(j,2)
          akx(j)=ak1(j)+ak2(j)
        enddo
*
        sx  = scalar(akx,akx)
        sqx = sqrt(sx)
*
czj     if ( sqx .lt.1.00.or.sqx.gt.2.00 )    go to 100
*
*     ********* save mc data **********************
*
        write(44,*) (ak1(i),i=1,4)
        write(44,*) (ak2(i),i=1,4)
*
        write(44,*) wt
*
        ncount = ncount + 1
*
        if ( ncount .eq. 10     ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 1000   ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 5000   ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 10000  ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 20000  ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 30000  ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 40000  ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 50000  ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 60000  ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 70000  ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 80000  ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 90000  ) write(*,*) 'ncount=', ncount
        if ( ncount .eq. 100000 ) write(*,*) 'ncount=', ncount
*
        if(ncount.lt.nlimit)   go to 100
*
        close(44)
        go to 200
*
      end if
*
      if ( iph .eq. 2 ) then
*
        nof = 55
        open (nof, file='gkk-fit.tohbk', status='unknown')
*
        open(66, file='mcgkk.dat',status='unknown')
*
        read(66,*) n_mc
        do j=1, n_mc
          read(66,*)(ak1(i),i=1,4)
          read(66,*)(ak2(i),i=1,4)
*
          do i=1,4
            akx(i) = ak1(i) + ak2(i)
          end do
*
          sx  = scalar(akx,akx)
          sqx = sqrt(sx)
*
*    ********specially for calculation of wazerop ...***********
*
          temp1 = dcs(pa)
          wabg  = faa(41)*fu(21,21)
          weight = temp1 + wabg
          wazerop = wazerop*1.
          watwop = watwop*1.
          wafourp = wafourp*1.
          wac  = wac*1.
          wad  = wad*1.
          wabg = wabg*1.
*
          xp=sqrt( akx(1)*akx(1)+akx(2)*akx(2)+akx(3)*akx(3) )
*
*     ***********************************************************
*     *              lorentz transformation                     *
*     ***********************************************************
*
          xak1(1)=(ak1(1)*akx(2)-ak1(2)*akx(1))/sqrt(akx(1)**2+akx(2)
     >    **2)
          xak1(2)=(ak1(1)*akx(1)*akx(3)+ak1(2)*akx(2)*akx(3)-ak1(3)
     >    *akx(1)**2-ak1(3)*akx(2)**2)/sqrt(akx(1)**2+akx(2)**2)/xp
          xak1(3)=(-ak1(4)*(akx(4)**2-sx)+akx(4)*(ak1(1)*akx(1)+ak1
     >    (2)*akx(2)+ak1(3)*akx(3)))/sqx/xp
          xak2(1)=(ak2(1)*akx(2)-ak2(2)*akx(1))/sqrt(akx(1)**2+akx(2)
     >    **2)
          xak2(2)=(ak2(1)*akx(1)*akx(3)+ak2(2)*akx(2)*akx(3)-ak2(3)
     >    *akx(1)**2-ak2(3)*akx(2)**2)/sqrt(akx(1)**2+akx(2)**2)/xp
          xak2(3)=(-ak2(4)*(akx(4)**2-sx)+akx(4)*(ak2(1)*akx(1)+ak2
     >    (2)*akx(2)+ak2(3)*akx(3)))/sqx/xp
*
*    ***********************************************************
*
          xgam_jsi = -akx(3)/xp
          xk_x = -xak1(3)/sqrt(xak1(1)**2+xak1(2)**2+xak1(3)**2)
          xphik_x = xatan(xak1(1),xak1(2))
*
*     ***********************************************************
*     *           write the value out                           *
*     ***********************************************************
*
          write (nof,*) sqx,weight,wazerop, watwop,wafourp,
     >                  wac,wad,wabg,xgam_jsi,xk_x,xphik_x
*
        end do
*
        close(66)
        close(nof)
*
*     ********* read data events ********************************
*
        open(77,file='real.dat',status='unknown')
        open(88,file='real_proj.dat',status='unknown')
*
        read(77,*) nrl
        do j1 = 1, nrl
          read(77,*)( ( akr(j1,j,i),i = 1, 3 ),j = 1, 2 )
          do i1 = 1, 2
            akr(j1,i1,4) = sqrt( pk2 + akr(j1,i1,1)**2
     >                               + akr(j1,i1,2)**2
     >                               + akr(j1,i1,3)**2 )
          end do
*
          do k=1,4
            ak1(k) = akr(j1,1,k)
            ak2(k) = akr(j1,2,k)
            akx(k) = akr(j1,1,k) + akr(j1,2,k)
          end do
*
          sx = scalar(akx,akx)
          sqx = sqrt(sx)
*
*     ***********************************************************
*     *              lorentz transformation                     *
*     ***********************************************************
*
          xp=sqrt(akx(1)**2+akx(2)**2+akx(3)**2)
          xak1(1)=(ak1(1)*akx(2)-ak1(2)*akx(1))/sqrt(akx(1)**2+akx(2)
     >    **2)
          xak1(2)=(ak1(1)*akx(1)*akx(3)+ak1(2)*akx(2)*akx(3)-ak1(3)
     >    *akx(1)**2-ak1(3)*akx(2)**2)/sqrt(akx(1)**2+akx(2)**2)/xp
          xak1(3)=(-ak1(4)*(akx(4)**2-sx)+akx(4)*(ak1(1)*akx(1)+ak1
     >    (2)*akx(2)+ak1(3)*akx(3)))/sqx/xp
          xak2(1)=(ak2(1)*akx(2)-ak2(2)*akx(1))/sqrt(akx(1)**2+akx(2)
     >    **2)
          xak2(2)=(ak2(1)*akx(1)*akx(3)+ak2(2)*akx(2)*akx(3)-ak2(3)
     >    *akx(1)**2-ak2(3)*akx(2)**2)/sqrt(akx(1)**2+akx(2)**2)/xp
          xak2(3)=(-ak2(4)*(akx(4)**2-sx)+akx(4)*(ak2(1)*akx(1)+ak2
     >    (2)*akx(2)+ak2(3)*akx(3)))/sqx/xp
*
*   ************************************************************
*
          rgam_jsi = -akx(3)/xp
          rk_x = -xak1(3)/sqrt(xak1(1)**2+xak1(2)**2+xak1(3)**2)
          rphik_x = xatan(xak1(1),xak1(2))
*
          write(88,*) sqx,rgam_jsi,rk_x,rphik_x
*
        end do
*
        close(88)
        close(77)
*
*     ********* background events 1 ********************************
*
        open(97,file='bg1.dat',status='unknown')
        open(98,file='bg1_proj.dat',status='unknown')
*
        read(97,*) nback1
        do j1 = 1, nback1
          read(97,*)( ( akb1(j1,j,i),i = 1, 3 ),j = 1, 2 )
          do i1 = 1, 2
            akb1(j1,i1,4) = sqrt( pk2 + akb1(j1,i1,1)**2
     >                                + akb1(j1,i1,2)**2
     >                                + akb1(j1,i1,3)**2 )
          end do
*
          do k=1,4
            ak1(k) = akb1(j1,1,k)
            ak2(k) = akb1(j1,2,k)
            akx(k) = akb1(j1,1,k) + akb1(j1,2,k)
          end do
*
          sx = scalar(akx,akx)
          sqx = sqrt(sx)
*
*     ***********************************************************
*     *              lorentz transformation                     *
*     ***********************************************************
*
          xp=sqrt(akx(1)**2+akx(2)**2+akx(3)**2)
          xak1(1)=(ak1(1)*akx(2)-ak1(2)*akx(1))/sqrt(akx(1)**2+akx(2)
     >    **2)
          xak1(2)=(ak1(1)*akx(1)*akx(3)+ak1(2)*akx(2)*akx(3)-ak1(3)
     >    *akx(1)**2-ak1(3)*akx(2)**2)/sqrt(akx(1)**2+akx(2)**2)/xp
          xak1(3)=(-ak1(4)*(akx(4)**2-sx)+akx(4)*(ak1(1)*akx(1)+ak1
     >    (2)*akx(2)+ak1(3)*akx(3)))/sqx/xp
          xak2(1)=(ak2(1)*akx(2)-ak2(2)*akx(1))/sqrt(akx(1)**2+akx(2)
     >    **2)
          xak2(2)=(ak2(1)*akx(1)*akx(3)+ak2(2)*akx(2)*akx(3)-ak2(3)
     >    *akx(1)**2-ak2(3)*akx(2)**2)/sqrt(akx(1)**2+akx(2)**2)/xp
          xak2(3)=(-ak2(4)*(akx(4)**2-sx)+akx(4)*(ak2(1)*akx(1)+ak2
     >    (2)*akx(2)+ak2(3)*akx(3)))/sqx/xp
*
*   ************************************************************
*
          b1gam_jsi = -akx(3)/xp
          b1k_x = -xak1(3)/sqrt(xak1(1)**2+xak1(2)**2+xak1(3)**2)
          b1phik_x = xatan(xak1(1),xak1(2))
*
          write(98,*) sqx,b1gam_jsi,b1k_x,b1phik_x
*
        end do
*
        close(98)
        close(97)
*
*     ********* background events 2 ********************************
*
        open(93,file='bg2.dat',status='unknown')
        open(94,file='bg2_proj.dat',status='unknown')
*
        read(93,*) nback2
        do j1 = 1, nback2
          read(93,*)( ( akb2(j1,j,i),i = 1, 3 ),j = 1, 2 )
          do i1 = 1, 2
            akb2(j1,i1,4) = sqrt( pk2 + akb2(j1,i1,1)**2
     >                                + akb2(j1,i1,2)**2
     >                                + akb2(j1,i1,3)**2 )
          end do
*
          do k=1,4
            ak1(k) = akb2(j1,1,k)
            ak2(k) = akb2(j1,2,k)
            akx(k) = akb2(j1,1,k) + akb2(j1,2,k)
          end do
*
          sx = scalar(akx,akx)
          sqx = sqrt(sx)
*
*     ***********************************************************
*     *              lorentz transformation                     *
*     ***********************************************************
*
          xp=sqrt(akx(1)**2+akx(2)**2+akx(3)**2)
          xak1(1)=(ak1(1)*akx(2)-ak1(2)*akx(1))/sqrt(akx(1)**2+akx(2)
     >    **2)
          xak1(2)=(ak1(1)*akx(1)*akx(3)+ak1(2)*akx(2)*akx(3)-ak1(3)
     >    *akx(1)**2-ak1(3)*akx(2)**2)/sqrt(akx(1)**2+akx(2)**2)/xp
          xak1(3)=(-ak1(4)*(akx(4)**2-sx)+akx(4)*(ak1(1)*akx(1)+ak1
     >    (2)*akx(2)+ak1(3)*akx(3)))/sqx/xp
          xak2(1)=(ak2(1)*akx(2)-ak2(2)*akx(1))/sqrt(akx(1)**2+akx(2)
     >    **2)
          xak2(2)=(ak2(1)*akx(1)*akx(3)+ak2(2)*akx(2)*akx(3)-ak2(3)
     >    *akx(1)**2-ak2(3)*akx(2)**2)/sqrt(akx(1)**2+akx(2)**2)/xp
          xak2(3)=(-ak2(4)*(akx(4)**2-sx)+akx(4)*(ak2(1)*akx(1)+ak2
     >    (2)*akx(2)+ak2(3)*akx(3)))/sqx/xp
*
*   ************************************************************
*
          b2gam_jsi = -akx(3)/xp
          b2k_x = -xak1(3)/sqrt(xak1(1)**2+xak1(2)**2+xak1(3)**2)
          b2phik_x = xatan(xak1(1),xak1(2))
*
          write(94,*) sqx,b2gam_jsi,b2k_x,b2phik_x
*
        end do
*
        close(94)
        close(93)
*
      endif
*
  200 continue
      return
      end
*
*     ******************************************************************
*     * file arithm called by fumili for every event to form gradients *
*     ******************************************************************
*
      subroutine arithm (y)
      parameter (npa=41,nd1=10000,nd2=4)
*     ******* arithm sets y and calculates dy/da ****************
      common /df/df(npa)/a/a(npa)/x/x(11)
      common /endflg/ endflg,na,indflg(5)
      common /pl/pl(npa)/au/amx(npa)/al/amn(npa)
*
*     ******* 10.*maximum relative precision on cdc 6000 ********
*
      data rp/1.e-14/
*
*     ******* unperturbed y **************************
*
      y = funct(x)
*
*     ******* run through all variables **************
*
      do 20 i = 1, na
         df(i) = 0.0
         if (pl(i)) 20, 20, 10
   10    ai    = a(i)
*
*     ******* hi=perturbation ************************
*
         hi    = 0.01*pl(i)
         pi    = rp*abs(ai)
         if ( hi .le. pi ) hi = pi
         a(i)  = ai + hi
*
*     ******* form gradient and restore parameters ***
*
         df(i) = grad(x,hi,i)
*        df(i) = ( funct(x) - y )/hi
         a(i)  = ai
   20 continue
      return
      end
*
*     ********** form gradients (called by subroutine arithm) **
*     ********** nb: this subroutine must not disturb cp or pa *
*
      function grad(x,step,ider)
      parameter (npa=41,nd1=10000,nd2=4)
      implicit complex (c)
      common/a/faa(npa)
      common/data/akn(nd1,2,5)
      common/coef/fun(21,21),nmode
      common/pan/pa(20,20)
      common/pad/pag(20,20)
      common/check/ak1(4),ak2(4),prob
      common/norm/wa1,iyw
      common/meth/method, nprojection
      common/cppp/cpn(20),waa(npa),was
      common/trans/fu(21,21)
      common/gggg/fc
      common/ncount/ncount,nlimit,fudge
      common/cfnew/cf(20,4,4),kon(20),kon1(3),kon2
      dimension x(11),cp(20),cdr(20)
*
*     ********* much of this subroutine is a carbon copy of funtn ******
*     ********* ider=index of parameter in faa being varied ************
*
      ii = x(1)
*
      call conv(cp)
      do 10 i = 1, nmode
         if ( kon(i) .eq. 0 )                                   go to 10
         cdr(i) = ( cp(i) - cpn(i) )/step
   10 continue
      ff = ( faa(41) - fc )/step
      dprob = 0.0
      do 30 i = 1, nmode
         if ( kon(i) .eq. 0 )                                   go to 30
         do 20 j = 1, nmode
            if ( kon(j) .eq. 0 )                                go to 20
            cw = cdr(i)*conj(cpn(j)) + cpn(i)*conj(cdr(j))
            if ( i .eq. j ) pag(i,j) = cw
            if ( i .lt. j ) pag(i,j) = 2.0*real(cw)
            if ( i .gt. j ) pag(i,j) = 2.0*aimag(cw)
            dprob = dprob + pag(i,j)*fu(i,j)
   20    continue
   30 continue
      dprob = dprob + ff*fu(21,21)
      if ( ii .ge. 2 )                                          go to 60
*
*     **** form perturbed denominator at first entry and store in waa **
*
      wa1 = 0.0
      do 50 i = 1, nmode
         if ( kon(i) .eq. 0 )                                   go to 50
         do 40 j = 1, nmode
            if ( kon(j) .eq. 0 )                                go to 40
            wa1 = wa1 + pag(i,j)*fun(i,j)
   40    continue
   50 continue
      waa(ider) = ( wa1 + ff*fun(21,21) )/nlimit
*
*     *************** form gradient ****************************
*
   60 dprob = dprob*fudge
      grad  = dprob/was - prob/was**2*waa(ider)
*
      return
      end
*
*     ******************************************************************
*
      complex function ca0p1(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
      am    = xmass( 1)
      g1    = xmass( 1)*xwidth( 1)
      ca0p1 = g1/( s - am**2 + ci*g1 )
c      ca0p1 = 1.
      return
      end
*     ***********************************************************
*
*     ***********************************************************
      complex function ca0p2(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
      am    = xmass( 2)
      g1    = xmass( 2)*xwidth( 2)
      ca0p2 = g1/( s - am**2 + ci*g1 )
      return
      end
*     ***********************************************************
*
*     ***********************************************************
      complex function ca0p3(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
      am    = xmass( 3)
      g1    = xmass( 3)*xwidth( 3)
      ca0p3 = g1/( s - am**2 + ci*g1 )
      return
      end
*     ***********************************************************
*
*     ***********************************************************
      complex function ca0p4(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
ccc      am    = xmass( 4)
ccc      g1    = xmass( 4)*xwidth( 4)
ccc      ca0p4 = g1/( s - am**2 + ci*g1 )
ccc      return
ccc      end
c----------------------------------------------------------
c       sigma from bsz, nucl.phys.b471 (1996) 59
c----------------------------------------------------------
      ci=cmplx(0.,1.)
      pm=0.135
      am=1.067
      as=am*am
      q2g=(3.097**2-s)**2/(2*3.097)**2
      cgam1=am*1.378*cro(s,pm,pm)/cro(as,pm,pm)
     1  *(s-0.0097)/(as-0.0097)*exp(-(s-as)/4./0.49)
      cgam2=0.0036*am*r4pip(s)/r4pip(as)
c      ca0p4=1./(as-s-ci*(cgam1+cgam2))*exp(0.60*q2g)
      ca0p4=1./(as-s-ci*(cgam1+cgam2))
c      ca0p4=1./(as-s-ci*(cgam1+cgam2))*exp(-0.03*q2g)
      return
      end
c
c----------------------------------------------------------
c     calculation of two particle phase volume
c----------------------------------------------------------
      complex function cro(s,am1,am2)
      implicit complex (c)
      common/dvb/ci
      t1=(am1+am2)**2
      t2=(am1-am2)**2
      st=(s-t1)*(s-t2)
      cro=sqrt(abs(st))/s
      if(st.lt.0.) cro=cro*ci
      return
      end
c
c----------------------------------------------------------
c     4 pion phase volume
c----------------------------------------------------------
      function r4pip(s)
      xk2=s-0.56**2
      if(xk2.le.0.)xk2=0.
      r4pip=sqrt(xk2/s)/(1.+exp(3.5*(2.8-s)))
      return
      end
c
*     ***********************************************************
      complex function ca0p5(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
      am    = xmass( 5)
      g1    = xmass( 5)*xwidth( 5)
      ca0p5 = g1/( s - am**2 + ci*g1 )
      return
      end
c
*     ***********************************************************
      complex function ca2p1(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
      am    = xmass( 6)
      g1    = xmass( 6)*xwidth( 6)
      ca2p1 = g1/( s - am**2 + ci*g1 )
c      ca2p1 = 1.
      return
      end
*     ***********************************************************
*
*     ***********************************************************
      complex function ca2p2(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
      am    = xmass( 7)
      g1    = xmass( 7)*xwidth( 7)
      ca2p2 = g1/( s - am**2 + ci*g1 )
      return
      end
*     ***********************************************************
*
*     ***********************************************************
      complex function ca2p3(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
      am    = xmass( 8)
      g1    = xmass( 8)*xwidth( 8)
      ca2p3 = g1/( s - am**2 + ci*g1 )
      return
      end
*     ***********************************************************
*
*     ***********************************************************
      complex function ca2p4(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
      am    = xmass( 9)
      g1    = xmass( 9)*xwidth( 9)
      ca2p4 = g1/( s - am**2 + ci*g1 )
      return
      end
*     ***********************************************************
*
*     ***********************************************************
      complex function ca4p1(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
      am    = xmass( 10)
      g1    = xmass( 10)*xwidth( 10)
c      ca4p1 = g1/( s - am**2 + ci*g1 )
      ca4p1 = 1.
      return
      end
*     ***********************************************************
*
*     ***********************************************************
      complex function cabg(s)
      implicit complex (c)
      common/xinfo/xmass(11),xwidth(11)
      common/dvb/ci
*
      cabg = 1.
*
      return
      end
*
*     ************* scalar product ******************************
*
      function scalar(q,w)
      common/metr/eps(4,4,4,4),del(4,4),pn(4)
      dimension q(4),w(4)
      scalar  = 0.0
      do 10 i = 1, 4
   10 scalar  = scalar + q(i)*w(i)*del(i,i)
      return
      end
*
*     ************ form complex conjugate ***********************
*
      complex function conj(c)
      implicit complex (c)
      conj = cmplx(real(c),-aimag(c))
      return
      end
*
*     ******** set up delta(i,j) and epsilon(i,j,k,l) ***********
*
      subroutine metric
      common/metr/eps(4,4,4,4),del(4,4),pn(4)
*
      do 10 i = 1, 4
         do 10 j = 1, 4
            del(i,j) = 0.0
            if(i.eq.j) del(i,j) = -1.0
            do 10 k = 1, 4
               do 10 l = 1, 4
   10 eps(i,j,k,l) = 0.0
      del(4,4) = 1.0
*
      eps(1,2,3,4) =  1.0
      eps(1,2,4,3) = -1.0
      eps(1,3,2,4) = -1.0
      eps(1,3,4,2) =  1.0
      eps(1,4,2,3) =  1.0
      eps(1,4,3,2) = -1.0
      eps(2,1,3,4) = -1.0
      eps(2,1,4,3) =  1.0
      eps(2,3,1,4) =  1.0
      eps(2,3,4,1) = -1.0
      eps(2,4,1,3) = -1.0
      eps(2,4,3,1) =  1.0
      eps(3,1,2,4) =  1.0
      eps(3,1,4,2) = -1.0
      eps(3,2,1,4) = -1.0
      eps(3,2,4,1) =  1.0
      eps(3,4,1,2) =  1.0
      eps(3,4,2,1) = -1.0
      eps(4,1,2,3) = -1.0
      eps(4,1,3,2) =  1.0
      eps(4,2,1,3) =  1.0
      eps(4,2,3,1) = -1.0
      eps(4,3,1,2) = -1.0
      eps(4,3,2,1) =  1.0
*
      return
      end
*
c*****************************************************
c     file fumili
c*****************************************************
        subroutine fumili(s,m,n1,n2,n3,eps,akappa,alambd,it,mc)
        call fumixx(s,m,n1,n2,n3,eps,akappa,alambd,it,mc,1)
        return
        end
c
        subroutine likelm(s,m,n1,n2,n3,eps,akappa,alambd,it,mc)
        call fumixx(s,m,n1,n2,n3,eps,akappa,alambd,it,mc,2)
        return
        end
c
      subroutine fumixx(s,m,n1,n2,n3,eps,akappa,alambd,it,mc,nlog)
c-----entry for chisq minimisation
      parameter (npa=41,nd1=10000,nd2=4)
      parameter (nda=nd1*nd2,nex=nd1*nd2*4,nzz=npa*(npa+1)/2)
      common /z/ z(nzz)/g/g(npa)/a/a(npa)/pl/pl0(npa)/sigma/sigma(npa)/
     1plu/pl(npa)/r/r(npa)/da/da(npa)/endflg/endflg,na,indflg(5)/au/amx(
     2npa)/al/amn(npa)/z0/z0(nzz)
c-----10.*maximum relative precision on cdc 6000
      data rp/1.e-14/
        goto (201,202),nlog
201     continue
      indflg(3)=0
 1    if (it.ge.0) print  84
      call vfll(amx,amn,npa,1.e35)
      nn2=0
      n=m
      fixflg=0.
      endflg=0.
      indflg(2)=0
      ifix1=0.
      fi=0.
      nn3=0
      do 2 i=1,n
      r(i)=0.
      if (eps.gt.0.) sigma(i)=0.
 2    pl(i)=pl0(i)
c-----start new iteration
 3    nn1=1
      t1=1.
c-----repeat iteration with smaller step
 4    s=0.
      n0=0
      do 7 i=1,n
      g(i)=0.
      if (pl0(i)) 7,7,5
 5    n0=n0+1
      if (pl(i)) 7,7,6
 6    pl0(i)=pl(i)
 7    continue
      nn0=n0*(n0+1)/2
      if (nn0.lt.1) go to 9
      do 8 i=1,nn0
      z(i)=0.
 8    continue
 9    na=m
      indflg(1)=0
c-----calculate objective function
      call sgz (m,s)
      sp=rp*abs(s)
      if (nn0.lt.1) go to 11
      do 10 i=1,nn0
      z0(i)=z(i)
 10   continue
 11   if (nn3) 19,19,12
 12   if (nn1-n1) 13,13,19
 13   t=2.*(s-olds-gt)
      if (indflg(1)) 16,14,16
 14   if (abs(s-olds).le.sp.and.-gt.le.sp) go to 19
      if (0.59*t+gt) 19,15,15
 15   t=-gt/t
      if (t-0.25) 16,17,17
 16   t=0.25
 17   gt=gt*t
      t1=t1*t
      nn2=0
      do 18 i=1,n
      if (pl(i).le.0.) go to 18
      a(i)=a(i)-da(i)
      pl(i)=pl(i)*t
      da(i)=da(i)*t
      a(i)=a(i)+da(i)
 18   continue
      nn1=nn1+1
      go to 4
c-----remove contribution of fixed parameters from z
   19 if(indflg(1).eq.0) go to 20
      endflg=-4.
      go to 85
 20   k1=1
      k2=1
      i1=1
      do 30 i=1,n
      if (pl0(i)) 30,30,21
 21   if (pl(i).eq.0.) pl(i)=pl0(i)
      if (pl(i)) 23,23,24
 22   pl(i)=0.
 23   k1=k1+i1
      go to 29
 24   if (a(i).ge.amx(i).and.g(i).lt.0.) go to 22
      if (a(i).le.amn(i).and.g(i).gt.0.) go to 22
      do 28 j=1,i
      if (pl0(j)) 28,28,25
 25   if (pl(j)) 27,27,26
 26   z(k2)=z0(k1)
      k2=k2+1
 27   k1=k1+1
 28   continue
 29   i1=i1+1
 30   continue
c-----invert z
      i1=1
      l=i1
      do 32 i=1,n
      if (pl(i)) 32,32,31
 31   r(i)=z(l)
      i1=i1+1
      l=l+i1
 32   continue
      n0=i1-1
      call mconv (n0)
      if (indflg(1)) 33,34,33
 33   indflg(1)=0
      indflg(2)=1
      go to 49
 34   continue
c-----calculate theoretical step to minimum
      i1=1
      do 41 i=1,n
      da(i)=0.
      if (pl(i)) 41,41,35
 35   l1=1
      do 40 l=1,n
      if (pl(l)) 40,40,36
 36   if (i1-l1) 37,37,38
 37   k=l1*(l1-1)/2+i1
      go to 39
 38   k=i1*(i1-1)/2+l1
 39   da(i)=da(i)-g(l)*z(k)
      l1=l1+1
 40   continue
      i1=i1+1
 41   continue
c-----check for parameters on boundary
      afix=0.
      ifix=0
      i1=1
      l=i1
      do 47 i=1,n
      if (pl(i)) 47,47,42
 42   sigi=sqrt(abs(z(l)))
      r(i)=r(i)*z(l)
      if (eps) 44,44,43
 43   sigma(i)=sigi
 44   if ((a(i).lt.amx(i).or.da(i).le.0.).and.(a(i).gt.amn(i).or.da(i).g
     1e.0.)) go to 46
      akap=abs(da(i)/sigi)
      if (akap-afix) 46,46,45
 45   afix=akap
      ifix=i
      ifix1=i
 46   i1=i1+1
      l=l+i1
 47   continue
      if (ifix) 48,50,48
 48   pl(ifix)=-1.
 49   fixflg=fixflg+1.
      fi=0.
c-----repeat calculation of theoretical step after fixing each parameter
      go to 19
c-----calculate step correction factor
 50   alambd=1.
      akappa=0.
      imax=0
      do 60 i=1,n
      if (pl(i)) 60,60,51
 51   bm=amx(i)-a(i)
      abi=a(i)+pl(i)
      abm=amx(i)
      if (da(i)) 52,52,53
 52   bm=a(i)-amn(i)
      abi=a(i)-pl(i)
      abm=amn(i)
 53   bi=pl(i)
      if (bi-bm) 55,55,54
 54   bi=bm
      abi=abm
 55   if (abs(da(i))-bi) 58,58,56
 56   al=abs(bi/da(i))
      if (alambd-al) 58,58,57
 57   imax=i
      aimax=abi
      alambd=al
 58   akap=abs(da(i)/sigma(i))
      if (akap-akappa) 60,60,59
 59   akappa=akap
 60   continue
c-----calculate new corrected step
      gt=0.
      amb=1.e18
      if (alambd) 62,62,61
 61   amb=0.25/alambd
 62   continue
      do 67 i=1,n
      if (pl(i)) 67,67,63
 63   if (nn2-n2) 66,66,64
 64   if (abs(da(i)/pl(i))-amb) 66,65,65
 65   pl(i)=4.*pl(i)
      t1=4.
 66   da(i)=da(i)*alambd
      gt=gt+da(i)*g(i)
 67   continue
c-----check if minimum attained and set exit mode
      if (-gt.gt.sp.or.t1.ge.1..or.alambd.ge.1.) go to 68
      endflg=-1.
 68   if (endflg) 85,69,69
 69   if (akappa-abs(eps)) 70,75,75
 70   if (fixflg) 72,71,72
 71   endflg=1.
      go to 85
 72   if (endflg) 85,77,73
 73   if (ifix1) 85,85,76
 74   if (fi-fixflg) 76,76,77
 75   if (fixflg) 74,76,74
 76   fi=fi+1.
      endflg=0.
 85   if(endflg.eq.0..and.nn3.ge.n3) endflg=-3.
      if(endflg.gt.0..and.indflg(2).gt.0) endflg=-2.
      call monito (s,m,nn3,it,eps,gt,akappa,alambd)
      if (endflg) 83,79,83
c-----check if fixing on bound is correct
 77   endflg=1.
      fixflg=0.
      ifix1=0
      do 78 i=1,m
 78   pl(i)=pl0(i)
      indflg(2)=0
      go to 19
c-----next iteration
 79   endflg=0.
      do 80 i=1,n
      a(i)=a(i)+da(i)
 80   continue
      if (imax) 82,82,81
 81   a(imax)=aimax
 82   olds=s
      nn2=nn2+1
      nn3=nn3+1
      go to 3
 83   mc=endflg
      return
c-----entry for maximum liklehood
c      entry likelm(s,m,n1,n2,n3,eps,akappa,alambd,it,mc)
202     continue
      indflg(3)=1
      go to 1
c
* 84   format (1h1,43x,50hfunction minimisation by subroutine fumili/like
*     +lm./55x,26hin the following print-out/27x,'s = value of
*     +objective function,  ec = expected change in s during next iterati
*     +on',/34x,'kappa = estimated distance to minimum,  lambda = st
*     +ep length modifier',///)
 84   format (//3x,'****************************************************
     +**********************',/
     +3x,'*',11x,'function minimisation by subroutine fumili/likelm.',
     +9x,'  *',
     +/3x,'*',11x, '         in the following print-out',24x,'  *',
     +/3x,'*',72x,'*',
     +/3x,'* s = value of objective function',38x,'  *',
     +/3x,'* ec = expected change in s during next iteration',22x,'  *',
     +/3x,'* kappa = estimated distance to minimum',
     + 3x,'lambda = step length modifier','  *',
     +/3x,'*************************************************************
     +*************',///)
       end
c
      subroutine mconv (n)
c-----mconv inverts the positive definite packed symmetric matrix z
c-----by the square-root method
      parameter (npa=41,nd1=10000,nd2=4)
      parameter (nda=nd1*nd2,nex=nd1*nd2*4,nzz=npa*(npa+1)/2)
      common /z/ z(nzz)
      common /plu/ pl0(npa)/r/r(npa)
      common /endflg/ endflg,na,indflg(5)
c-----maximum real number and 10.*maximum relative precision on cdc6000
      data am,rp/1.e35,1.e-14/
      if (n.lt.1) return
      aps=sqrt(am/float(n))
      ap=1./(aps*aps)
      ir=0
      do 11 i=1,n
 1    ir=ir+1
      if (pl0(ir)) 1,1,2
 2    ni=i*(i-1)/2
      ii=ni+i
      k=n+1
      if (z(ii).le.rp*abs(r(ir)).or.z(ii).le.ap) go to 19
      z(ii)=1./sqrt(z(ii))
      nl=ii-1
 3    if (nl-ni) 5,5,4
 4    z(nl)=z(nl)*z(ii)
      if (abs(z(nl)).ge.aps) go to 16
      nl=nl-1
      go to 3
 5    if (i-n) 6,12,12
 6    k=k-1
      nk=k*(k-1)/2
      nl=nk
      kk=nk+i
      d=z(kk)*z(ii)
      c=d*z(ii)
      l=k
 7    ll=nk+l
      li=nl+i
      z(ll)=z(ll)-z(li)*c
      l=l-1
      nl=nl-l
      if (l-i) 9,9,7
 8    ll=nk+l
      li=ni+l
      z(ll)=z(ll)-z(li)*d
 9    l=l-1
      if (l) 10,10,8
 10   z(kk)=-c
      if (k-i-1) 11,11,6
 11   continue
 12   do 14 i=1,n
      do 14 k=i,n
      nl=k*(k-1)/2
      ki=nl+i
      d=0.
      do 13 l=k,n
      li=nl+i
      lk=nl+k
      d=d+z(li)*z(lk)
      nl=nl+l
 13   continue
      ki=k*(k-1)/2+i
      z(ki)=d
 14   continue
 15   return
 16   k=i+nl-ii
      ir=0
      do 18 i=1,k
 17   ir=ir+1
      if (pl0(ir)) 17,17,18
 18   continue
 19   pl0(ir)=-2.
      r(ir)=0.
      indflg(1)=ir
      go to 15
      end
      subroutine sgz (m,s)
c-----subroutine sgz sets up s(objective function),g(gradient of s) and
c-----z(approximate covariance matrix)
      parameter (npa=41,nd1=10000,nd2=4)
      parameter (nda=nd1*nd2,nex=nd1*nd2*4,nzz=npa*(npa+1)/2)
      common /g/ g(npa)/z/z(nzz)/a/a(npa)/df/df(npa)/ned/nt,ns/exda/ex
     1da(nex)/x/x(11)/pl/pl(npa)/endflg/endf6g,na,indflg(5)
      common/uprmon/ikk
      common/nnn/Nreal,Nbg1,Nbg2,Nt1
      we=1.0
      k=nt
      k2=1
      do 12 l1=1,k
      k1=k2
      nx=ns-2
      if (indflg(3)) 1,2,1
 1    nx=ns
      k1=k1-2
 2    continue
      do 3 i=1,nx
      ki=k1+1+i
      x(i)=exda(ki)
 3    continue
      call arithm (y)
      if(ikk.eq.2) then
      print 100,x(1),y,exda(k1),exda(k1+1)
  100 format(5x,4e15.4)
      endif
      if (indflg(3)) 4,6,4
 4    if (y) 13,13,5
c-----maximum liklehood
 5    continue
      if(l1.gt.Nreal.and.l1.le.Nt1) we=-1.0
      if(l1.gt.Nt1.and.l1.le.nt)    we=-1.0
      s=s-log(y)*we
      y=-y
      sig=y
      go to 7
c-----chi squared
 6    sig=exda(k2+1)
      y=y-exda(k1)
      s=s+((y/sig)**2)/2.
 7    continue
      n=0
      do 9 j=1,m
      if (pl(j)) 9,9,8
 8    n=n+1
      df(n)=df(j)/sig
      g(j)=g(j)+df(n)*(y/sig)*we
 9    continue
      l=1
      if (n.lt.1) go to 11
      do 10 i=1,n
      do 10 j=1,i
      z(l)=z(l)+df(i)*df(j)*we
      l=l+1
 10   continue
 11   k2=k2+ns
 12   continue
      return
c-----  -ve or zero y in maximum liklehood
 13   indflg(1)=1
      s=1.e10
      return
      end
      subroutine errorf (m)
c-----final error analysis for chisq.
      parameter (npa=41,nd1=10000,nd2=4)
      parameter (nda=nd1*nd2,nex=nd1*nd2*4,nzz=npa*(npa+1)/2)
      common /ned/ ns,np/x/x(11)/exda/exda(nex)/error/error(nda)/a/
     . a(npa)/df/df(npa)/z/z(nzz)
      print 3
      if (np.gt.7) print 4
      do 2 j=1,ns
      k1=np*(j-1)+1
      fun=exda(k1)
      sig=exda(k1+1)
      nx=np-2
      do 1 k=1,nx
      k2=k1+1+k
      x(k)=exda(k2)
 1    continue
c-----calculate dy/da"s for scal
      call arithm (y)
      call scal (m,er)
      xi=(fun-y)/sig
      xi=0.5*xi*xi
      er=sqrt(er)
      error(j)=er
      print 5,j,y,er,xi,(x(i),i=1,nx)
 2    continue
      return
c
 3    format (1h1,79herror analysis for each data point using final para
     +meter values (chisq only)   ////1h ,10x,5hpoint,8x,6hfitted,9x,10h
     +y standard,6x,12hcontribution,4x,14hx co-ordinates/1h ,11x,3hno.,8
     +x,8hy  value,8x,9hdeviation,7x,10hto chisq/2,6x,14hof data point./
     +/)
 4    format (1h+,86x,22h(printed in row order))
 5    format (1h ,10x,i3,2x,7(5x,e12.5),(/1h ,66x,4(5x,e12.5)))
      end
      subroutine scal (m,er)
c-----subroutine scal calculates er=variance of theoretical function y
      parameter (npa=41,nd1=10000,nd2=4)
      parameter (nda=nd1*nd2,nex=nd1*nd2*4,nzz=npa*(npa+1)/2)
      common /z/ z(nzz)/df/df(npa)
      common /plu/ pl(npa)
      er=0.
      n=0
      do 2 j=1,m
      if (pl(j)) 2,2,1
 1    n=n+1
      df(n)=df(j)
 2    continue
      if (n.eq.0) return
      do 6 i=1,n
      do 6 l=1,n
      if (i-l) 3,3,4
 3    k=l*(l-1)/2+i
      go to 5
 4    k=i*(i-1)/2+l
 5    er=er+z(k)*df(i)*df(l)
 6    continue
      return
      end
      subroutine monito (s,m,nn3,it,eps,gt,akappa,alambd)
c-----iteration progress output
      parameter (npa=41,nd1=10000,nd2=4)
      parameter (nda=nd1*nd2,nex=nd1*nd2*4,nzz=npa*(npa+1)/2)
      common /a/ a(npa)/sigma/sigma(npa)/r/r(npa)/pl/pl(npa)/plu/pl0(npa
     1)/endflg/endflg,na,indflg(5)/au/amx(npa)/al/amn(npa)
      common/uprmon/ikk
      if (it) 11,3,1
 1    if (nn3) 4,4,2
 2    if (nm) 3,4,4
 3    if (endflg) 4,12,4
c-----printer carriage control
 4    i1=6
      if (m.gt.6) i1=5
      if (m.gt.12) i1=4
      if (m.gt.23) i1=1
c   non-ansi carriage control suppressed on ibm
      if(i1.gt.1) i1=0
      print 19,i1,nn3,s,gt,akappa,alambd
      if(ikk.ge.1) print 191
c***************************************************
c-----record parameters to hard disk
      open(13,file='xaram_tmp.res',status='unknown')
      write(13,116) na
      write(13,117)(j,a(j),pl(j),amn(j),amx(j),j=1,na)
  116 format(5x,i5)
  117 format(i5,f15.5,3f15.3)
      close(13)
c***************************************************
      do 10 i=1,m
      if (pl(i)) 9,9,5
 5    if (pl0(i)) 8,7,6
 6    continue
      if(ikk.ge.1) print 20,i,a(i),sigma(i),r(i)
      go to 10
    7 continue
      if(ikk.ge.1) print 21,i,a(i),sigma(i),r(i)
      go to 10
 8    if (pl0(i).ge.-1.) go to 7
      if(ikk.ge.1) print 22,i,a(i)
      go to 10
    9 continue
      if(ikk.ge.1) print 23,i,a(i)
 10   continue
 11   nm=-it
 12   nm=nm+1
      if (endflg) 13,14,14
 13   i=-endflg
      go to (15,16,17,18), i
 14   return
 15   print 24
      go to 14
 16   print  25
      go to 14
 17   print  26
      go to 14
 18   print  27
      go to 14
c
* 19   format (i1,13hiteration no.,i3,5h, s= ,e12.5,7h, ec = ,e12.5,9h, k
*     +appa= ,e12.5,10h, lambda= ,e12.5)
  19  format (/1x,i2,' **********',2x,'iteration no.',i3,/4x,'s= ',f8.3,
     +4x,'ec = ',f8.3,4x,'kappa= ',f8.3,4x,'lambda= ',f8.3)
 191  format (/1h ,6x,9hparameter,6x,9hparameter,9x,8hstandard,8x,
     +11hcorrelation/1h ,8x,6hnumber,9x,5hvalue,11x,9
     +hdeviation,9x,6hfactor/)
 20   format (1h ,8x,i3,4x,3(5x,e12.5))
 21   format (1h ,8x,i3,4x,3(5x,e12.5),22h parameter on boundary)
 22   format (1h ,8x,i3,9x,e12.5,5x,24hinfinite error estimated)
 23   format (1h ,8x,i3,9x,e12.5,5x,20hthis parameter fixed)
 24   format (1h0,65hminimisation terminated as no further decrease in s
     + is obtainable/1h1)
 25   format (1h0,52hminimisation terminated as infinite errors estimate
     +d/1h1)
 26   format (1h0,50hminimisation terminated as iteration limit reached/
     +1h1)
 27   format (1h0,82hminimisation terminated as negative or zero y encou
     +ntered as logarithmic arguement/1h1)
      end
c*****************************************************
c     file vfll
c*****************************************************
      subroutine vfll(amx,amn,n,edd)
      parameter (npa=41,nd1=10000,nd2=4)
      dimension amx(npa),amn(npa)
      common/pl/pl(npa)
      do 1 i=1,n
      if(amx(i).lt.amn(i)) then
      write(6,100)i
      go to 1
      endif
      if(amx(i).eq.0.and.amn(i).eq.0.) then
      amx(i)=edd
      amn(i)=-edd
      endif
    1 continue
      do 2 i=1,n
      if(amx(i).eq.0.) write (6,101)i
      if(amn(i).eq.0.) write (6,102)i
    2 continue
  100 format(10x,'maximum less then minimum for parametr',i3)
  102 format(10x,'warning: minimum is 0. for parametr',i3)
  101 format(10x,'warning: maximum is 0. for parametr',i3)
      return
      end
*
**
*
      subroutine genev
c--      called from - main program
c --     purpose - generates event (pcm and wt ) using amass and tecm
      common/util/np,tecm,amass(18),pcm(5,18),wt
c--       util2 contains further numbers useful to user,
c--            namely eff.massof particles 1-i, m**2, and delta sq.
c--       m**2 and delta sq. are indefinite if raubold-lynch method is u
      common/util2/ emm(18), emms(18), d2(18)
     +/shuffl/ rno(50)   ,ntnm4    ,ntm2     ,ntm1     ,qqcons(50) ,tir
c--       pcm1 is linear equiv. of pcm to avoid double indices
      dimension em(18),pd(18),ems(18),sm(18),ffq(18),pcm1(90)
      equivalence (nt,np),(amass(1),em(1)),(pcm1(1),pcm(1,1))
c   ffq(n)=pi * (twopi)**(n-2) / (n-2)factorial
      data  ffq/0.,3.141592, 19.73921, 62.01255, 129.8788, 204.0131,
     +                       256.3704, 268.4705, 240.9780, 189.2637,
     +                       132.1308,  83.0202,  47.4210,  24.8295,
     +                        12.0006,   5.3858,   2.2560,   0.8859/
      data etc, init, twopi / 0. , 0 , 6.2831853073 /
      if(tecm-etc) 115,455,115
c        initialization
  115 if(init.gt.0) goto 300
      init=1
      ntm1=nt-1
      ntm2=nt-2
      ntp1=nt+1
      ntnm4 = 3*nt - 4
      emm(1)=em(1)
      tm=0.0
      do 200 i=1,nt
      ems(i)=em(i)**2
      tm=tm+em(i)
 200  sm(i)=tm
c        constants depending on tecm
  300 continue
      tecmtm=tecm-tm
      etc=tecm
      emm(nt)=tecm
	kgenev=2
      if(kgenev.gt.1) goto 400
c        constant cross section as function of tecm
      emmax=tecmtm+em(1)
      emmin=0.0
      wtmax=1.0
      do 350 i=2,nt
      emmin=emmin+em(i-1)
      emmax=emmax+em(i)
  350 wtmax=wtmax*pdk(emmax,emmin,em(i))
      wtmaxq=1.0/wtmax
      goto 455
c--      fermi energy dependence for cross section
  400 wtmaxq=tecmtm**ntm2*ffq(nt) / tecm
c        calculation of wt based on effective masses emm
c--       rangnr fills rno with 3*nt-4 random numbers,
  455 call rangnr
c--            of which the first nt-2 are ordered.
      if(ntm2) 900,509,460
  460 continue
      do 508 j=2,ntm1
  508 emm(j)=rno(j-1)*(tecmtm)+sm(j)
  509 wt=wtmaxq
      ir=ntm2
      do 530 i=1,ntm1
      pd(i)=pdk(emm(i+1),emm(i),em(i+1))
  530 wt=wt*pd(i)
c--       complete specification of event (raubold-lynch method)
      pcm(1,1)=0.0
      pcm(2,1)=pd(1)
      pcm(3,1)=0.0
      do 570 i=2,nt
      pcm(1,i)=0.0
      pcm(2,i) = -pd(i-1)
      pcm(3,i)=0.0
      ir=ir+1
      bang=twopi*rno(ir)
      cb=cos(bang)
      sb=sin(bang)
      ir=ir+1
      c=2.0*rno(ir)-1.0
      s=sqrt(1.0-c*c)
      if(i.eq.nt) goto 1567
      esys=sqrt(pd(i)**2+emm(i)**2)
      beta=pd(i)/esys
      gama=esys/emm(i)
      do 568 j=1,i
      ndx = 5*j - 5
      aa= pcm1(ndx+1)**2 + pcm1(ndx+2)**2 + pcm1(ndx+3)**2
      pcm1(ndx+5) = sqrt(aa)
      pcm1(ndx+4) = sqrt(aa+ems(j))
      call rotes2(c,s,cb,sb,pcm,j)
      psave = gama*(pcm(2,j)+beta*pcm(4,j))
  568 pcm(2,j)=psave
      goto 570
 1567 do 1568 j=1,i
      aa=pcm(1,j)**2 + pcm(2,j)**2 + pcm(3,j)**2
      pcm(5,j)=sqrt(aa)
      pcm(4,j)=sqrt(aa+ems(j))
      call rotes2(c,s,cb,sb,pcm,j)
 1568 continue
  570 continue
  900 continue
      return
      end
      function pdk(a,b,c)
c=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
c--  called from -  genev
c     pdk = sqrt(abs(a*a+(b*b-c*c)**2/(a*a) - 2.0*(b*b+c*c)))/2.0
      a2 = a*a
      b2 = b*b
      c2 = c*c
      pdk = 0.5*sqrt(abs(a2 + (b2-c2)**2/a2 - 2.0*(b2+c2)))
      return
      end
      subroutine rangnr
c--       called from genev.  assembles random numbers for one event.
c--       it includes the quasirandom generator qqrndm,
c--       and uses a pseudorandom generator (rndm) for shuffling
      common
     +/shuffl/ rno(50)   ,ntnm4    ,ntm2     ,ntm1     ,qqcons(50) ,tir
      call nran(rno,ntnm4)
c--       order the first ntm2 random numbers
c--         two is a special case (faster)
      if(ntm2 - 2) 200,160,110
  110 km1 = ntm2 - 1
      do 150 i= 1, km1
      iquit = 0
      ni = ntm2 - i
      do 140 j= 1, ni
      if(rno(j) - rno(j+1)) 140,140,120
  120 sav = rno(j)
      rno(j) = rno(j+1)
      rno(j+1) = sav
      iquit = 1
  140 continue
      if(iquit) 200,200,150
  150 continue
      goto 200
  160 if(rno(1).le.rno(2)) goto 200
      sav = rno(1)
      rno(1) = rno(2)
      rno(2) = sav
  200 continue
      return
      end
      subroutine rotes2(c,s,c2,s2,pr,i)
c--  called from - genev
c         this subroutine now does two rotations (xy and xz)
      dimension pr(50)
      k1 = 5*i - 4
      k2 = k1 + 1
      sa = pr(k1)
      sb = pr(k2)
      a      = sa*c - sb*s
      pr(k2) = sa*s + sb*c
      k2 = k2 + 1
      b = pr(k2)
      pr(k1) = a*c2 - b*s2
      pr(k2) = a*s2 + b*c2
      return
      end
*
      function xatan(y,x)
c  get value of phi between 0 and twopi
c
      xatan = 0.
      if(x.eq.0.0.and.y.eq.0.0) return
      xatan = atan2(y,x)
      if(xatan.lt.0.0) then
      xatan =xatan+3.14159267*2
      endif
      return
      end
*
*    +******************************************************************
*     *                                                                *
*     *             end of data analysis  program v h1                 *
*     *                                                                *
*     *                                 tue oct  14 11:25 1997         *
*     *                                                                *
*     ******************************************************************
*

      REAL FUNCTION seln()
*********************************************************
*                                                       *
* This file was generated by HUWFUN.                    *
*                                                       *
*********************************************************
*
*     Ntuple Id:      2000 
*     Ntuple Title:   gammakk
*     Creation:       05/12/:1 11.21.02
*
*********************************************************
*
      LOGICAL         CHAIN
      CHARACTER*128   CFILE
      INTEGER         IDNEVT,NCHEVT,ICHEVT
      REAL            OBS(13)
*
      COMMON /PAWIDN/ IDNEVT,OBS
      COMMON /PAWCHN/ CHAIN, NCHEVT, ICHEVT
      COMMON /PAWCHC/ CFILE
*
*--   Ntuple Variable Declarations
*
      REAL irun,irec,tottks,nmdc,nneu,rx1,ry1,rz1,rx2,ry2,rz2,cosk1
     + ,cosk2,pxyk1,pxyk2,pp1,pp2,tof1,tof2,tq1,tq2,pid1,pid2,deltat
     + ,esc1,esc2,rmkk,rmks1,rmks2,rmkg1,rmkg2,umiss,api0,q2,chi2g
     + ,chi2pi,fmkk,fmgk1,fmgk2,cthetv,cthetx,cthetm,phim,escn,cosg,thdf
     + ,thpf1,thpf2,phpf1,phpf2,ppx1,ppy1,ppz1,ee1,amass1,ppx2,ppy2,ppz2
     + ,ee2,amass2,ppx3,ppy3,ppz3,ee3,amass3,rmht1,rmht2,chi2pi1,chi2pi2
     + ,chi2pi3,chi2pi4,chi2pi5,chi2pi6,rmpi01m,rmpi02m,rmpi03m,rmpi04m
     + ,rmpi05m,rmpi06m,idflag1,idflag2,xx1time1,xx1time2,xx1time3
     + ,xx1timee1,xx1timee2,xx1timee3,xx1timeoff1,xx1timeoff2
     + ,xx1timeoff3,xx1timesig1,xx1timesig2,xx1timesig3,xx2time1
     + ,xx2time2,xx2time3,xx2timee1,xx2timee2,xx2timee3,xx2timeoff1
     + ,xx2timeoff2,xx2timeoff3,xx2timesig1,xx2timesig2,xx2timesig3
     + ,iddflag1,iddflag2,xx1xsp1,xx1xsp2,xx1xsp3,xx1dedxoff1
     + ,xx1dedxoff2,xx1dedxoff3,xx1dedxsig1,xx1dedxsig2,xx1dedxsig3
     + ,xx2xsp1,xx2xsp2,xx2xsp3,xx2dedxoff1,xx2dedxoff2,xx2dedxoff3
     + ,xx2dedxsig1,xx2dedxsig2,xx2dedxsig3,IDGDTOF1,IDGDDEDX1,IDGDCOM1
     + ,IDGDTOF2,IDGDDEDX2,IDGDCOM2,thkk,rx0,ry0,rz0,chi2pi7,chi2pi8
     + ,chi2pi9,rmpi07m,rmpi08m,rmpi09m,rmkk07m,rmkk08m,rmkk09m,rmks107m
     + ,rmks108m
      REAL rmks109m,rmks207m,rmks208m,rmks209m
      INTEGER iscf1,iscf2,nscl,nfscl,nngg,ngg
*
      COMMON /PAWCR4/ irun,irec,tottks,nmdc,nneu,rx1,ry1,rz1,rx2,ry2,rz2
     + ,cosk1,cosk2,pxyk1,pxyk2,pp1,pp2,tof1,tof2,tq1,tq2,pid1,pid2
     + ,deltat,iscf1,iscf2,esc1,esc2,rmkk,rmks1,rmks2,rmkg1,rmkg2,umiss
     + ,api0,q2,chi2g,chi2pi,fmkk,fmgk1,fmgk2,cthetv,cthetx,cthetm,phim
     + ,escn,nscl,nfscl,cosg,thdf,thpf1,thpf2,phpf1,phpf2,nngg,ngg,ppx1
     + ,ppy1,ppz1,ee1,amass1,ppx2,ppy2,ppz2,ee2,amass2,ppx3,ppy3,ppz3
     + ,ee3,amass3,rmht1,rmht2,chi2pi1,chi2pi2,chi2pi3,chi2pi4,chi2pi5
     + ,chi2pi6,rmpi01m,rmpi02m,rmpi03m,rmpi04m,rmpi05m,rmpi06m,idflag1
     + ,idflag2,xx1time1,xx1time2,xx1time3,xx1timee1,xx1timee2,xx1timee3
     + ,xx1timeoff1,xx1timeoff2,xx1timeoff3,xx1timesig1,xx1timesig2
     + ,xx1timesig3,xx2time1,xx2time2,xx2time3,xx2timee1,xx2timee2
     + ,xx2timee3,xx2timeoff1,xx2timeoff2,xx2timeoff3,xx2timesig1
     + ,xx2timesig2,xx2timesig3,iddflag1,iddflag2,xx1xsp1,xx1xsp2
     + ,xx1xsp3,xx1dedxoff1,xx1dedxoff2,xx1dedxoff3,xx1dedxsig1
     + ,xx1dedxsig2,xx1dedxsig3,xx2xsp1,xx2xsp2,xx2xsp3,xx2dedxoff1
     + ,xx2dedxoff2,xx2dedxoff3,xx2dedxsig1,xx2dedxsig2,xx2dedxsig3
     + ,IDGDTOF1,IDGDDEDX1,IDGDCOM1,IDGDTOF2,IDGDDEDX2,IDGDCOM2,thkk,rx0
     + ,ry0,rz0,chi2pi7,chi2pi8,chi2pi9,rmpi07m,rmpi08m,rmpi09m,rmkk07m
     + ,rmkk08m,rmkk09m,rmks107m,rmks108m,rmks109m,rmks207m,rmks208m
     + ,rmks209m
*

*
*--   Enter user code here
*
      seln = 0.
*
       if( abs(cosk1).gt.0.80 ) return
       if( abs(cosk2).gt.0.80 ) return
*
       if( nngg.le.0.0 ) return
       if( nngg.ge.2.0 ) then
         if(chi2pi1.lt.50.and.abs(rmpi01m-0.135).lt.0.050) return
         if(chi2pi2.lt.50.and.abs(rmpi02m-0.135).lt.0.050) return
       endif
*
       if(chi2pi1.lt.chi2g ) return
       if(chi2pi2.lt.chi2g ) return
       if( chi2pi.le.chi2g.or.chi2g.ge.50.0
     *   ) return
       if( chi2pi.le.10..or.chi2g.ge.10.00
     *   ) return
*
       if( umiss.ge.0.20.or.umiss.le.-0.10 ) return
       if (thdf.ge.18.0 ) return
       if( q2.ge.0.0020 ) return
*
       if(fmkk.lt.1.40.and.idflag1.ne.1.0.or.idflag2.ne.1.0) return
*
       if(idflag1.eq.1.0.or.idflag2.eq.1.0) then
         seln=1.
       else
         seln=0.
       endif
*
      END

c----------------------------------------------------------------------*
c  subroutine angle(isys,i1,i2,i3,iv,cthtv*,cthtx*,ctheta*,phi*,iflag) *
c                                                                      *
c      this routine calculates theta and phi-angles of a two-body      *
c    or three body decay in a given helicity frame defined by the      *
c    p-vector of isys.                                                 *
c                                                                      *
c             e+e- --> (j/psi) --> v + x                               *
c                                      |                               *
c                                      ---> 1 + 2 (+ 3)                *
c                                                                      *
c    convention: +x' has to lie in production plane.                   *
c    frames:                                                           *
c       xyz frame(laboratory system, j/psi rest system, e+e- c.m.s)    *
c           resonance x moving with momenta p in xyz-frame.            *
c           1, 2, (3)  moving with momenta p1,p2,(p3) in xyz-frame.    *
c       x'y'z' frame(x rest system)                                    *
c    notes:                                                            *
c         isys   :  z-vector in xyz frame (defining convention).       *
c         i1     :  no. of particle 1, in 4-vector in xyz frame.       *
c         i2     :  no. of particle 2, in 4-vector in xyz frame.       *
c         i3     :  no. of particle 3, in 4-vector in xyz frame.       *
c         iv     :  no. of particle v, in 4-vector in xyz frame.       *
c         cthtv  :  cosine theta of v in xyz frame.                    *
c         cthtx  :  cosine theta of x in xyz frame.                    *
c         ctheta :  cosine theta of 1 in x'y'z' frame(if i3=0).        *
c                   or                                                 *
c                   cosine theta of normal to decay-plane in x'y'z'    *
c                   frame (if i3 not equals 0).                        *
c         phi    :  angle phi of 1 in x'y'z'-frame (if i3=0)           *
c                   or                                                 *
c                   angle phi of normal to decay-plane in x'y'z' frame *
c                   (if i3 not equals 0).                              *
c         iflag  :  coodinate system of x'y'z'-frame.                  *
c                   if it equals zero or it isn't given, default       *
c                   coordinate system is defined, ie. z'direction      *
c                   in direction of v (opposite to decaying particle). *
c                   if it equals 1, then z' direction in direction     *
c                   of x which decays into 1,2,(3).                    *
c    attention: needs locations 92-100 for temporary use.             *
c                                                                      *
c----------------------------------------------------------------------*
c                                                                      *
c   n.wermes last update 02/07/84                                      *
c   l.koepke last update 02/11/85 aditional flag for z-direction       *
c   r.xu     copied from mark iii. 10/23/90                            * 
c   s.j.chen aditional cosine theta(v) and cosine theta(x) 11/22/1990  *
c                                                                      *
c----------------------------------------------------------------------*
c
c
       subroutine angle(isys,i1,i2,i3,iv,cthtv,cthtx,ctheta,phi,iflag) 
       include 'ppp.inc'
       integer i1p/92/,i2p/93/
       integer zsys/94/,ix/95/,xpr/96/,ypr/97/,zpr/98/,normal/100/
       real*4 sp(4),sb(4),pf(4)

c
c  initial values
c
       cthtv =-100
       cthtx =-100
       ctheta=-100
       phi   =-100
       call pzer$(94,100)
c
c  values in xyz-system
c
       call norz$(isys,zsys)                   ! normalize z input axis
       call add$(i1,i2,ix)                     ! 4-vector of x
       if (i3.ne.0) call add$(ix,i3,ix)
       call ang$(iv,zsys,cthtv,tt)             ! theta of v
       call ang$(ix,zsys,cthtx,tt)             ! theta of x
c
c  vectors of x'y'z' system
c
       if (iflag.eq.0) then
          call smul$(ix,zpr,-1.)               ! z' = v direction         
          call norz$ (zpr,zpr)                 ! z' unit-vector
c          call cross$(zpr,zsys,ypr)            ! y' = z' cross z
          call cross$(zsys,zpr,ypr)            ! y' = z cross z'
          call norz$ (ypr,ypr)                 ! y' unit-vector
          call cross$(ypr,zpr,xpr)             ! x' = y' cross z'
          call norz$ (xpr,xpr)                 ! x' unit-vector
       endif
       if (iflag.eq.1) then
          call smul$(ix,zpr,+1.)               ! z' = x direction  
          call norz$ (zpr,zpr)                 ! z' unit-vector
c         call cross$(zpr,zsys,ypr)            ! y' = z' cross z
          call cross$(zsys,zpr,ypr)            ! y' = z cross z'
          call norz$ (ypr,ypr)                 ! y' unit-vector
          call cross$(ypr,zpr,xpr)             ! x' = y' cross z'
          call norz$ (xpr,xpr)                 ! x' unit-vector
	endif
c
c  do lorentz-boost & projections
c
       call lor$(i1,ix,i1p)                    ! transform to x-rest-frame
c 
       if (i3.ne.0) then
        call lor$(i2,ix,i2p)                 ! transform to x-rest-frame
c
          call cross$(i1p,i2p,normal)          ! normal to decay-plane 
          call norz$(normal,normal)            ! make it a unit vector
          iuse = normal
       else
          iuse =i1p
       endif
       call ang$(iuse,zpr,ctheta,tt)           ! theta of ii in x'y'z'
       call dot$(iuse,xpr,pxpr)                ! px given in x'y'z'-frame
       call dot$(iuse,ypr,pypr)                ! py given in x'y'z'-frame
       phi = xatan(pypr,pxpr)                  ! phi of ii in x'y'z'
       call pzer$(92,100)                     ! clear temporary storage
       return
       end

       function xatan(y,x)
c  get value of phi between 0 and twopi
c
       xatan = 0.
       if(x.eq.0.0.and.y.eq.0.0) return
       xatan = atan2(y,x)
       if(xatan.lt.0.0) then
       xatan =xatan+3.14159267*2
       endif
       return
       end

      PROGRAM GKKA
*
      implicit none
*
*     program to generate massx distribution from
*     monte carlo data
*
      common /pawc/ hmemor (800000) ! book memory
*
      real hmemor, prob, wazerop, watwop, wafourp, wac, wad, wabg
      real xmass, xgam_jsi, xk_x, xphik_x
      real rmass, rgam_jsi, rk_x, rphik_x
      real b1mass, b1gam_jsi, b1k_x, b1phik_x
      real b2mass, b2gam_jsi, b2k_x, b2phik_x
      integer i, j, k, l, istat, icycle
*
*     set up histograms
*
      call hlimit (800000)
*
      call hbook1 (100, 'Mass all contribution', 20, 1.4, 1.8, 0.)
      call hbook1 (110, 'Mass 0++ contribution', 20, 1.4, 1.8, 0.)
      call hbook1 (120, 'Mass 2++ contribution', 20, 1.4, 1.8, 0.)
      call hbook1 (130, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (131, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (132, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (133, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (833, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)     
      call hbook1 (140, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (141, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (142, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (143, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (843, 'K in X ', 20,-1.0,1.0, 0.)       
      call hbook1 (191, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (192, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (193, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (194, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (195, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (150, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (151, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (152, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (153, 'K in X (Phi)', 20,0.0,6.3, 0.)
*
      call hbook1 (200, 'Mass all contribution', 20, 1.4, 1.8, 0.)
      call hbook1 (230, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (231, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (232, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (233, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (240, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (241, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (242, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (243, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (250, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (251, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (252, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (253, 'K in X (Phi)', 20,0.0,6.3, 0.)
*
      call hbook1 (300, 'Mass all contribution', 20, 1.4, 1.8, 0.)
      call hbook1 (330, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (331, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (332, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (333, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (340, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (341, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (342, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (343, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (350, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (351, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (352, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (353, 'K in X (Phi)', 20,0.0,6.3, 0.)
*
      call hbook1 (400, 'Mass all contribution', 20, 1.4, 1.8, 0.)
      call hbook1 (430, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (431, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (432, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (433, 'Gamma in Jpsi ', 16,-0.8,0.8, 0.)
      call hbook1 (440, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (441, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (442, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (443, 'K in X ', 20,-1.0,1.0, 0.)
      call hbook1 (450, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (451, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (452, 'K in X (Phi)', 20,0.0,6.3, 0.)
      call hbook1 (453, 'K in X (Phi)', 20,0.0,6.3, 0.)
*
*     read in data
*
      open(66, file = 'gkk-fit.tohbk',status = 'old')
      do i=1,149971
        read(66,*) xmass, prob, wazerop, watwop, wafourp,
     +             wac, wad, wabg, xgam_jsi, xk_x, xphik_x
        call hfill (100, xmass, 0., prob)
        call hfill (110, xmass, 0., wazerop)
        call hfill (120, xmass, 0., watwop)
        call hfill (130, xgam_jsi, 0., prob)
        call hfill (140, xk_x, 0., prob)
        call hfill (150, xphik_x, 0., prob)
        if( xmass.gt.0.90.and.xmass.lt.1.40 ) then
          call hfill (131, xgam_jsi, 0., prob)
          call hfill (141, xk_x, 0., prob)
          call hfill (151, xphik_x, 0., prob)
        end if
        if( xmass.gt.1.45.and.xmass.lt.1.60 ) then
          call hfill (132, xgam_jsi, 0., prob)
          call hfill (142, xk_x, 0., prob)
          call hfill (152, xphik_x, 0., prob)
          call hfill (132, -xgam_jsi, 0., prob)
          call hfill (142, -xk_x, 0., prob)
          call hfill (152, -xphik_x, 0., prob)
        end if
        if( xmass.gt.1.65.and.xmass.lt.1.80 ) then
          call hfill (133, xgam_jsi, 0., prob)
          call hfill (833, xgam_jsi, 0., 1.)        
          call hfill (143, xk_x, 0., prob)
          call hfill (843, xk_x, 0., 1.)    
          call hfill (153, xphik_x, 0., prob)
          call hfill (191, xk_x, 0., 1.)        
          call hfill (192, xk_x, 0., wazerop)        
          call hfill (193, xk_x, 0., watwop)        
          call hfill (194, xk_x, 0., wac)        
          call hfill (195, xk_x, 0., wad)        
        end if
*
      end do
      close(66)
*
      open(77,file='real_proj.dat',status='old')
      do j=1,8585
        read(77,*) rmass, rgam_jsi, rk_x, rphik_x
        call hfill (200, rmass, 0., 1.)
        call hfill (230, rgam_jsi, 0., 1.)
        call hfill (240, rk_x, 0., 1.)
        call hfill (250, rphik_x, 0., 1.)
        if( rmass.gt.0.90.and.rmass.lt.1.40 ) then
          call hfill (231, rgam_jsi, 0., 1.)
          call hfill (241, rk_x, 0., 1.)
          call hfill (251, rphik_x, 0., 1.)
        end if
        if( rmass.gt.1.45.and.rmass.lt.1.60 ) then
          call hfill (232, rgam_jsi, 0., 1.)
          call hfill (242, rk_x, 0., 1.)
          call hfill (252, rphik_x, 0., 1.)
          call hfill (232, -rgam_jsi, 0., 1.)
          call hfill (242, -rk_x, 0., 1.)
          call hfill (252, -rphik_x, 0., 1.)
        end if
        if( rmass.gt.1.60.and.rmass.lt.1.80 ) then
          call hfill (233, rgam_jsi, 0., 1.)
          call hfill (243, rk_x, 0., 1.)
          call hfill (253, rphik_x, 0., 1.)
        end if
      end do
      close(77)
*
      open(88,file='bg1_proj.dat',status='old')
      do k=1,126
        read(88,*) b1mass, b1gam_jsi, b1k_x, b1phik_x
        call hfill (300, b1mass, 0., 1.)
        call hfill (330, b1gam_jsi, 0., 1.)
        call hfill (340, b1k_x, 0., 1.)
        call hfill (350, b1phik_x, 0., 1.)
        if( b1mass.gt.0.90.and.b1mass.lt.1.40 ) then
          call hfill (331, b1gam_jsi, 0., 1.)
          call hfill (341, b1k_x, 0., 1.)
          call hfill (351, b1phik_x, 0., 1.)
        end if
        if( b1mass.gt.1.45.and.b1mass.lt.1.60 ) then
          call hfill (332, b1gam_jsi, 0., 1.)
          call hfill (342, b1k_x, 0., 1.)
          call hfill (352, b1phik_x, 0., 1.)
          call hfill (332, -b1gam_jsi, 0., 1.)
          call hfill (342, -b1k_x, 0., 1.)
          call hfill (352, -b1phik_x, 0., 1.)
        end if
        if( b1mass.gt.1.65.and.b1mass.lt.1.80 ) then
          call hfill (333, b1gam_jsi, 0., 1.)
          call hfill (343, b1k_x, 0., 1.)
          call hfill (353, b1phik_x, 0., 1.)
        end if
      end do
      close(88)
*
      open(99,file='bg2_proj.dat',status='old')
      do l=1,422
        read(99,*) b2mass, b2gam_jsi, b2k_x, b2phik_x
        call hfill (400, b2mass, 0., 1.)
        call hfill (430, b2gam_jsi, 0., 1.)
        call hfill (440, b2k_x, 0., 1.)
        call hfill (450, b2phik_x, 0., 1.)
        if( b2mass.gt.0.90.and.b2mass.lt.1.40 ) then
          call hfill (431, b2gam_jsi, 0., 1.)
          call hfill (441, b2k_x, 0., 1.)
          call hfill (451, b2phik_x, 0., 1.)
        end if
        if( b2mass.gt.1.45.and.b2mass.lt.1.60 ) then
          call hfill (432, b2gam_jsi, 0., 1.)
          call hfill (442, b2k_x, 0., 1.)
          call hfill (452, b2phik_x, 0., 1.)
          call hfill (432, -b2gam_jsi, 0., 1.)
          call hfill (442, -b2k_x, 0., 1.)
          call hfill (452, -b2phik_x, 0., 1.)
        end if
        if( b2mass.gt.1.65.and.b2mass.lt.1.80 ) then
          call hfill (433, b2gam_jsi, 0., 1.)
          call hfill (443, b2k_x, 0., 1.)
          call hfill (453, b2phik_x, 0., 1.)
        end if
      end do
      close(99)
*
*     send histogram to histogram file
*
      call hropen(96,'gkkfit','gkk-fit.hbk','n', 1024, istat)
      call hrout(0,icycle,' ')
      call hrend('gkkfit')
      close (96)
*
      end

        SUBROUTINE PARTID(ITRKK,IFLAG,Ipero)
*************************************************************
*   The subroutine is used to to do particle identification *
* using the dEdX and tof information.  Considering the      *
* seperation ability of dEdX, we only use dEdX information  *
* when momenta less than 0.8GeV.                            *
*...........................................................*
*                                                           *
*   The tof information is corrected by subroutine toffsig  *
* and dEdX information is corrected by subroutine dedxcorp. *
*                                                           *
*   All the correction are the experical fitting of data    *
* from 50M J/psi data taken in 1999-2000 and 2000-2001.     *
* Then all the parameter depend on the reriod data and the  *
* reconstruction version. So the routine for correction only*
* will be used for 50M J/psi data taking in 1999-2000 and   *
* 2000-2001, thereconstruction version 102   *
*...........................................................*
*                                                           *
*   Because the routine is used to do PID for charged, we   *
* require sub1 and sub3 have information and at least one of*
* sub4 and sub7 has information.                            *
*   About the tof information, only barrel tof information  *
* can be used ,and the tof quality is required eq 1.0 2.0   *
* 7.0 or 10.0.                                              *
*   About dEdX information, only when mementa is less than  *
*  0.8Gev, and the hit munber hit .gt.10 and dedx quality   *
*  1 can be used.                                           *
*   The subroutine only can be used for RUN13691-RUN16835   *
* of Jpsi data taken in 1999-2000, and  RUN17009-RUN19149   *
* taken in 2000-2001.                                       *
*...........................................................*
*                                                           *
*   INPUT :                                                 *
*      ITRKK  ,  the track number of particle               *
*      IPERO  ,  the flag for differnt run set MC. data     *
*                1--the first run set of 24M j/psi data     *
*                2--the second run set of 27M j/psi data    *
*                3--the totly 50M j/psi data                *
*                if you analysis the first run set of 24M   *
*                j/psi data, ipero=1                        *
*   OUTPUT :                                                *
*      IFLAG ,  the paticle kind number                     *
*      1--for kaon, 2--for pion, 3--for proton              *
*...........................................................*
*   IDGDDEDX=1  , dedx information is used in PID           *
*   IDGDTOF=1   , tof information is used in PID            *
*   IDGDCOM=0   , none of dedx and tof info. be used in PID *
*          =1   , one  of dedx and tof info. be used in PID *
*          =2   , both of dedx and tof info. be used in PID *
*...........................................................*
*   TOFCHI      , the chi square of tof  information       *
*   DEDXCHI     , the chi square of dedx information       *
*   COMCHI      , the sum of chi square of dedx and tof     *
*                                                           *
*...........................................................*
*   A common block partid.inc is used at the process        *
*                                                           *
*         Author :  Peng Hai ping       USTC                *
*                             2001.2.20                     *
*************************************************************
      INCLUDE 'trklst.inc'
      INCLUDE 'evlst.inc'
      INCLUDE 'partid.inc'
       REAL EMASS(3),TOFQUALA(4)
       INTEGER IDEDXCH
       DATA IDEDXCH/10/
       DATA EMASS/0.4937,0.1396,0.9383/
       DATA TOFQUALA/1.0,2.0,8.0,10.0/
       IFLAG=0
       IDGDTOF=0
       IDGDDEDX=0
       IDGDCOM=0
       DO I=1,3
          TOFCHI(I)=999.
          DEDXCHI(I)=999.
          COMCHI(I)=999.
          PROBILITY(I)=-999.
       ENDDO
       XPIK=-999.
       ISUB1=TRKSUB(1,ITRKK)
       ISUB3=TRKSUB(3,ITRKK)
       ISUB4=TRKSUB(4,ITRKK)
       ISUB7=TRKSUB(7,ITRKK)
c
C*.....if not charged tracks, or no dedx and 
c*.....tof information then reject.
c
       IF(ISUB3.LE.0.OR.ISUB1.LE.0)RETURN
       IF(ISUB4.LE.0.AND.ISUB7.LE.0)RETURN
       PTOT=TRK(ISUB3+7)
       PZ=TRK(ISUB3+6)
       COSZ=PZ/PTOT
       ICHARG=ITRK(ISUB1+4)
c
C*......now get tof information.
c
       IF(ISUB4.GT.0)THEN
c
C*......only the barrel tof information can be used.....
c
           ICOUNT=ITRK(ISUB4+3)
           IF(ICOUNT.EQ.0.OR.ICOUNT.GT.48)GOTO 101
c
C*......only certain tof quality can be used..
c
           TQUAB=TRK(ISUB4+8)
           DO ICHE=1,4
             IF(TQUAB.EQ.TOFQUALA(ICHE))IDGDTOF=1
           ENDDO
           IF(IDGDTOF.EQ.0)GOTO 101
           TQQ=TRK(ISUB4+7)
           DO I=1,3
             TOFF=0.0
             TSIG=0.2
             TIME=TRK(ISUB4+4)
             eLENGTH=TRK(ISUB4+14)
             BETAA=PTOT/SQRT(PTOT**2+EMASS(I)**2)
             TIMEXP=eLENGTH/BETAA/0.3
             DTAT=TIME-TIMEXP
             IF(IRUN.Ge.13690.AND.IRUN.LE.16836)THEN
               CALL TOFFSIG(1,I,PTOT,COSZ,TQQ,ICOUNT,ICHARG,TOFF,TSIG)
             ENDIF
             IF(IRUN.Ge.17009.and.IRUN.LE.19149)THEN
               CALL TOFFSIG(2,I,PTOT,COSZ,TQQ,ICOUNT,ICHARG,TOFF,TSIG)
             ENDIF
             IF(IRUN.LT.0)THEN
              IF(IPERO.EQ.1)THEN
               CALL TOFFSIGMC018(I,PTOT,COSZ,TQQ,ICOUNT,
     +                                              ICHARG,TOFF,TSIG)
              ELSE IF(IPERO.EQ.2)THEN
               CALL TOFFSIGMC019(I,PTOT,COSZ,TQQ,ICOUNT,
     +                                              ICHARG,TOFF,TSIG)
              ELSE IF(IPERO.EQ.3)THEN
               CALL TOFFSIGMC020(I,PTOT,COSZ,TQQ,ICOUNT,
     +                                              ICHARG,TOFF,TSIG)
              ELSE
                PRINT *,'**THE INPUT PARAMTER HAVE SOME PROBLEM**'
              ENDIF
             ENDIF
             DTAT=DTAT-TOFF
             TOFCHI(I)=(DTAT/TSIG)**2
           ENDDO
       ENDIF
 101   CONTINUE
c
C*.....now get the dedx information...
c
       IF(ISUB7.GT.0)THEN
c
C*......dedx can be used only when quality .eq. 1 and ndedx .gt.10...
c
         NDEDX=ITRK(ISUB7+3)
         IOK=ITRK(ISUB7+4)
         IF(IOK.NE.1.OR.NDEDX.LE.IDEDXCH)GOTO 202
c
C*......dedx can be used only when momenta less than 0.8gev
c
         IF(PTOT.GT.0.8)GOTO 202
         IDGDDEDX=1
         DO I=1,3
            IF(I.EQ.1) XSP=TRK(ISUB7+18)
            IF(I.EQ.2) XSP=TRK(ISUB7+17)
            IF(I.EQ.3) XSP=TRK(ISUB7+19)
            IF(IRUN.GE.13690.AND.IRUN.LE.16836)THEN
              CALL DEDXCORP(1,I,PTOT,COSZ,OFFSET,RESOL)
            ENDIF
            IF(IRUN.GE.17009.AND.IRUN.LE.19149)THEN
              CALL DEDXCORP(2,I,PTOT,COSZ,OFFSET,RESOL)
            ENDIF
            IF(IRUN.LT.0)THEN
              CALL DEDXCORPMC(I,PTOT,COSZ,OFFSET,RESOL)
            ENDIF
          if(icharg.eq.1) then
            xxsp(i) = XSP
            xdedxoff(i) = OFFSET
            xdedxsig(i) = RESOL
          else
            yxsp(i) = XSP
            ydedxoff(i) = OFFSET
            ydedxsig(i) = RESOL 
          endif
            XSP=XSP-OFFSET
            DEDXCHI(I)=(XSP/RESOL)**2
         ENDDO
       ENDIF
 202   CONTINUE
c
C*....now combin the information of dedx and tof
c
       IDGDCOM=IDGDTOF+IDGDDEDX
       IF(IDGDCOM.EQ.0)RETURN
       IF(IDGDCOM.EQ.1.AND.IDGDTOF.EQ.1)THEN
          DO I=1,3
            COMCHI(I)=TOFCHI(I)
            PROBILITY(I)=PROB(COMCHI(I),IDGDCOM)
          ENDDO
       ENDIF
       IF(IDGDCOM.EQ.1.AND.IDGDDEDX.EQ.1)THEN
          DO I=1,3
            COMCHI(I)=DEDXCHI(I)
            PROBILITY(I)=PROB(COMCHI(I),IDGDCOM)
          ENDDO
       ENDIF
       IF(IDGDCOM.EQ.2)THEN
          DO I=1,3
             COMCHI(I)=DEDXCHI(I)+TOFCHI(I)
             PROBILITY(I)=PROB(COMCHI(I),IDGDCOM)
          ENDDO
       ENDIF
c
C*.......now calcute the xpik
c
C PENGHP ADD 2001/07/09,Dr. yuanye find the bug
c
        PROBTEMP=PROBILITY(1)+PROBILITY(2)
        IF(PROBTEMP.LE.0.00001)PROBTEMP=0.00001
C
        XPIK=PROBILITY(1)/PROBTEMP
C        XPIK=PROBILITY(1)/(PROBILITY(1)+PROBILITY(2))
c
C*.......now comparethe weight of all particles and get the id #
c
       IF(COMCHI(1).LE.COMCHI(2).AND.COMCHI(1).LE.COMCHI(3))
     &         IFLAG=1
       IF(COMCHI(2).LE.COMCHI(1).AND.COMCHI(2).LE.COMCHI(3))
     &         IFLAG=2
       IF(COMCHI(3).LE.COMCHI(1).AND.COMCHI(3).LE.COMCHI(2))
     &         IFLAG=3

       RETURN
       END

        Subroutine ncor

C--------------------------------------------------------------
C 
C   Subroutine Ncor.f
c
C   This code only handle neutral track detected by  barrel shower counter. 
C
C   It is to correct energy and error matrix (errors of phi, z, energy) 
C   for a neutral track.
C   
C   Users are suggested to call this little code BEFORE event selection 
c   and kinematic fit. 
C
C   Input:  none
C   Output: all changes are saved in SUBTYPE 5 of TRKLST.
C   
C   Pls pay attention that TRKLST has been renewed when events logged out
C
C   IMPORTANT:
C   Z correction(0.9587) is determined by 
C   J/psi-->rhopi channel for correct pi0
C   peak,while I also found it almost 
C   needn't Z correction for J/psi-->
C   phi eta channel for eta peak,Z 
C   correction size is determined by 
C   neutral track energy scale,so its
C   size should be adjusted by users 
C   according to concerning neutral 
C   resonance peak position,take their 
C   own risk!
C
C   reference:
C   <<SUMMARY on BESII NEUTRAL CORRECTION>>
C          BES Monthly Meeting, 7/Sep. 2000  
C
C       LU Feng  Sep. 10, 2000
c     
c     LU Feng only give the correction for the BES2 data RUN13500-16844,
c     The correction for the BES2 data RUN17209-19149 have been done by
c                                  WANG Jun, YUAN JianMing, and XU GuoFa
c                                                              May, 2001
c
c    Since the Z and PHI correction for the RUN13500-16844 only include 
c    the data for momentum between 0.4GeV to 1.4(1.5485)GeV, I added 4 
c    points between 0.2GeV to 0.4GeV.
c                          XU GuoFa      Sept. 2001
C---------------------------------------------------------------

      INCLUDE 'trklst.inc'
      INCLUDE 'evlst.inc'

       real dphi, dz, de, xecor 
       integer i, isub5

       if(nneu.le.0) return

        do 999 I=nchrg+1, nchrg+nneu
        ISUB5= TRKSUB(5,I)
        IF(ISUB5.le.0) goto 999
        if(itrk(isub5+20).ne.1) goto 999   ! treat BSC track only

C DATA neutral tracks correction: run13500-16844

       if(irun.gt.0) then
cXU
       if (irun.ge.13500.and.irun.le.16844) then
cXU        
         
cxu        xecor=0.2277*trk(isub5+14)**2+0.6765*trk(isub5+14)
cxu     *        +0.0514
        xecor=0.051334 + 0.67934*trk(isub5+14)
     +        +0.22480*trk(isub5+14)**2

        trk(isub5+14)=xecor        ! corrected Energy

cxu        de=0.2342*sqrt(xecor)-0.001779
        de=0.23359*sqrt(xecor)-0.0010063
        trk(isub5+15)= de          ! corrected E Res.

cxu        dphi=2.174-3.446*xecor+2.573*xecor**2
cxu     +       -0.6918*xecor**3      ! corrected phi Res. in degree
        dphi=4.9427-16.314*xecor+23.562*xecor**2
     +       -15.081*xecor**3+3.5289*xecor**4 ! corrected phi Res. in degree
        dphi=dphi*3.1415926/180.   ! in rad.
        trk(isub5+13)= dphi

cxu        dz =19.07-37.49*xecor+35.24*xecor**2
cxu     +      -11.24*xecor**3        ! corrected Z Res. in cm
        dz =26.748-79.007*xecor+112.96*xecor**2
     +      -71.807*xecor**3+16.778*xecor**4   ! corrected Z Res. in cm
        dz=dz/100.0                  ! in meter
        trk(isub5+9) = dz

C  Z correction Adjust by users for certain channel  
C        trk(isub5+8) = trk(isub5+8)*0.9587        

cXU---------------------  Begin line --------------
       else if (irun.ge.17209.and.irun.le.19149) then
        xecor=0.19679*trk(isub5+14)**2+0.71488*trk(isub5+14)
     *        +0.045854
        trk(isub5+14)=xecor        ! corrected Energy

        de=0.21642*sqrt(xecor)-0.012987
        trk(isub5+15)= de          ! corrected E Res.

        dphi=5.1738-17.407*xecor+26.095*xecor**2
     +       -17.597*xecor**3+4.3879*xecor**4 ! corrected phi Res. in degree
        dphi=dphi*3.1415926/180.   ! in rad.
        trk(isub5+13)= dphi

        dz =28.476-88.026*xecor+130.78*xecor**2
     +      -86.042*xecor**3+20.720*xecor**4  ! corrected Z Res. in cm
        dz=dz/100.0                  ! in meter
        trk(isub5+9) = dz        

c        trk(isub5+8) = trk(isub5+8)*0.9587        

      end if
cXU-----------  End line --------------------------

C MC neutral tracks correction: REAL DEAD Ver. is 022  
c Done by LU Feng, no change.

cxu      if(irun.lt.0) then
       else 

        xecor=0.9874*trk(isub5+14)+0.01222        
        trk(isub5+14)= xecor          ! corrected E 

        de=0.2144*sqrt(xecor)-0.01208
        trk(isub5+15)= de*0.9          ! corrected E Res.

        dphi=0.8113-0.3317*xecor+0.09885*xecor**2 ! phi in degree
        dphi=dphi*3.1415926/180./1.414214
        trk(isub5+13)= dphi*0.92

        dz =7.18-0.8454*xecor+0.3096*xecor**2 ! Z Res. in cm
        dz=dz/141.4214
        trk(isub5+9) = dz*0.9        

      end if

999   continue

      return
      end

C----------------------------------------------------
C
C  This file contains:
C
C   Subroutine SUPERFUG
C
C
C   SUPERFUG is used to apply dE/dx corrections to a 
C   charged track's momentum, and to correct the track
C   error matrix for dE/dx and multiple scattering, 
C   according to a specified mass hypothesis.
C
C  Input:
C     R*4   XMAS        Mass hypothesis (GeV/c**2);
C     R*4   TKPAR(6)    Vector of track parameters:
C                       phi, k (=1/Pxy), s (=tanlam), 
C                       xm, ym, zm;
C     I*4   ICHG        Charge;
C     R*4   BC          = 0.029979 * B field at 
C                       (xm,ym,zm);
C     R*4   PM(5)       Vector containing Px, Py, 
C                       Pz, Pxyz, Pxy;
C     R*4   SECLM(4)    Ith element = sec(lambda)**I;
C     R*4   ERROR(15)   Error matrix (taken from 
C                       TRK(I3+20) et seq.);
C     R*4   RM          = sqrt(xm**2 + ym**2);
C     I*4   MFIT        = Least-significant byte 
C                       of MFITWD;
C     I*4   MZFIT       = Next-to-least-significant
C                       byte of MFITWD;
C     I*4   IFIT(2)     R-phi layer maps = 
C                       ITRK(I3+35), ITRK(I3+36);
C     I*4   CD          CD CODE = ITRK(I3+40).
C
C Output:
C           TKPAR(6)    Corrected track parameters;
C           ERROR(15)   Corrected error matrix.
C
C   The following track parameters are corrected:
C            phi, k, xm, and ym.
C
C------------------------------------------------
C
C  Miniature set of COULOM-like constants:
C
C  U        = exponent in D. Hitlin formula
C  XMCS     = (0.0141 GeV)**2 for Multiple Scattering
C  NSCATR   = number of scatterers under consideration
C
C            In the following arrays, the scatterers
C               are numbered as follows:
C                  1. Beampipe
C                  2. Little Chamber
C                  3. Inner wall of Main DC
C                  4. Gas and wires of DC layers 2-5
C
C  RSCATR   = radius of mid-scatterer from beam axis
C  DPMIN    = d(momentum) for each scatterer (from 
C             Hitlin) for a minimum-ionizing particle
C  ALPHAT   = total alpha*t for each scatterer, 
C             determined from COULOM COMMON. These 
C             numbers are not necessarily consistent 
C             with the DPMIN values, but it's not 
C             worth worrying about.
C  RADL     = number of radiation lengths 
C             in each scatterer
C  A seperate subroutine at BES    
C             H.B.Lan,  Jan. 14,1994
C
C  B. Lowery Cosmetic fix to range error when 
C            INDEX1 = 940 just expand dimension 
C            of f1,f2 by 1.    May 18, 1994
C
C  as the energy loss correction and error matrix
C  correction are not correct for the low momentum
C  in the old telesis package,we use Mike Kelsey's 
C  BPFRAC subroutine to do energy loss correction in
C  IVERSION .ge.86,but ne.831.It is pointed out by
C  James Panetta& Li Xinhua
C  Huibin Lan  Nov. , 13,1994
c
c  Adopted BESII's RSCATR,DPMIN,ALPHAT,RADL instead 
C  of BESI's.(line114-118),dE/dX correction for 
C  charged tracks' momentum(LINE1237).  
c          LU Feng      20/Jan./2000
C
c  MDC error matrix of J/psi data from 13500-16844
C  had been re-scaled run by run.
C  reference:
C     <<STUDY ON BESII TELESIS>>
C            BES Annual Meeting, Jun. 2000, DaLian
C     <<BESII TELESIS ON CHARGED CHANNEL>>
C            BES Basic software Memo,on Web
c                         LU Feng      22/July/2000
C  Pull distribution corrections RUN by Run for Jpsi data
C  from run17209 to run19149
C           XU Guofa, YUAN Jianming
C                     Apr. 2001          
C------------------------------------------------------------------------------
      Subroutine SUPERFUG(xmas,
     > tkpar,ichg,bc,pm,seclm,error,rm,mfit,mzfit,ifit,cd,iversion)
C     Implicit None

cluf
      INCLUDE 'evlst.inc'
      External bpcorr2
      real bpcorr2,L1,L2,L3
cluf

      Real xmas, tkpar(6), bc, pm(5), seclm(4), error(15), rm
clhb
      real tkpar1,tkpar2,tkpar3,thta
      Integer ichg, mfit, mzfit, ifit(2), cd, iversion
      Real bumin,ptot0,beta0,frac0,ptot1,beta1,frac1,delth2
      Real dphidk,delphi,delxi,sigk,sigphi,sigxi
      Integer i,j,index0,index1,i1,i2,im
CBL   Real*8 f1(0:940), f2(0:940)
      Real*8 f1(0:941), f2(0:941)
      Real*8 scr1(0:10), scr2(0:10)
      Real*8 u, b, g
      Real*8 q0, q1, a1, a2, am
      Integer nscatr
      Real twopi, xmcs
      Real rscatr(4), dpmin(4), alphat(4), radl(4)
      Logical first
      Logical debug
      Logical super
      Data first / .true. /
      Data debug / .false. /
      Data twopi / 6.2831853 /
      Data u / 2.74d0 /
      Data xmcs / 1.99e-4 /
      Data nscatr / 4 /
C
C     Data for MARK3
c      Data rscatr /    0.077,    0.115,    0.145,    0.409 /
c      Data dpmin  / 0.441e-3, 0.490e-3, 0.129e-3, 0.155e-3 /
c      Data alphat /  1.78e-5,  1.95e-5,  0.22e-5,  0.68e-5 /
c      Data radl   /  4.03e-3,  7.10e-3,  0.53e-3,  0.00e-3 /
C
C     Data for BES  (see Chensj's note book)
cc      Data rscatr /    0.077,    0.121,    0.155,    0.375 /
cc      Data dpmin  / 0.911e-3, 0.963e-3, 0.742e-3, 0.166e-3 /
cc      Data alphat /  3.98e-5,  3.93e-5,  3.06e-5,  0.75e-5 /
C      Data radl   /  10.4e-3,  13.0e-3,  9.00e-3,  0.00e-3 /
cc      Data radl   / 22.47e-3,  13.0e-3,  9.00e-3,  0.00e-3 /

C-LUF  Data for BESII
      Data rscatr /0.0483   ,    0.0926,     0.155,    0.375 /
      Data dpmin  /0.4112e-3, 0.4258e-3,  0.742e-3, 0.166e-3 /
      Data alphat /1.78e-5  ,   1.95e-5,   3.06e-5,  0.75e-5 /
      Data radl   /5.36e-3  ,  10.32e-3, 11.071e-3,  0.00e-3 /

      super = .true.

  10  continue
C
clhb-------use bpfrac to do dedx energy loss correction-----
c-luf------no dedx energy loss corection,just save data-----
      tkpar1=tkpar(1)
      tkpar2=tkpar(2)
      tkpar3=tkpar(3)
      if(tkpar2.eq.0.)return
      psav=sqrt(1.+tkpar3**2)/tkpar2
      thta=acos(tkpar3/sqrt(1.+tkpar3**2))
clhb---------------------------------------------------------
      IF (.not. first) go to 80

      Call telever

C
C   Initialization on first call: perform numerical
C   integrations using trapezoid rule.
C   SCR1 and SCR2 are scratch arrays.
C   BUMIN is needed to convert DPMIN into the Ai.

      scr1(10) = 0.d0
      scr2(10) = 0.d0
      f1(0) = 0.d0
      f2(0) = 0.d0

      DO 70 i=1,940
        scr1(0) = scr1(10)
        scr2(0) = scr2(10)

        DO 60 j=1,10
          b = dble(float(10*i - 10 + j))/10000.d0
          g = 1.d0 / dsqrt(1.d0 - b*b)
          scr1(j) = b**u * g**3
          scr2(j) = b**(u-4.d0) * g
  60    continue

        f1(i) = f1(i-1) + (scr1(0)+scr1(10))/20000.d0
        f2(i) = f2(i-1) + (scr2(0)+scr2(10))/20000.d0

        DO 65 j=1,9
          f1(i) = f1(i) + scr1(j)/10000.d0
          f2(i) = f2(i) + scr2(j)/10000.d0
  65    continue
  70  continue
      bumin = 0.940**sngl(u)
      first = .false.

      write (6,75)
  75  format (/ ' > FUDGE initialized.' /)

C
C--------------------------------------------------------------------C
C
  80  continue
C
C   Correct the error matrix for multiple scattering in the
C   DC gas.
C
      if (iversion.le.7) goto 100
      Call SUPERGAS(xmas,
     > tkpar,ichg,bc,pm,seclm,error,rm,mfit,mzfit,ifit,cd)

      IF (.not. debug) go to 100
      write (6,90) tkpar, error
  90  format (' After GSCATR:' /
     >        '  TKPAR:',6F11.7 /
     >        '  ERROR:',F11.7 / 8X,2F11.7 / 8X,3F11.7
     >                         / 8X,4F11.7 / 8X,5F11.7 )
 100  continue
C
C   Prepare to correct for hard scatterers:
C
      ptot0 = pm(4)
      beta0 = ptot0 / sqrt(xmas**2+ptot0**2)
C
C   Loop over scatterers:
C
      DO 300 i=nscatr,1,-1

        IF (debug) then
          write (6,1100) i, ptot0, beta0
1100      format (' >>>>  Entering scatterer',I2,':' /
     >            '                  P0:',F10.6 /
     >            '               beta0:',F10.6 )
        endif

C
C   Make dE/dx correction:
C
        index0 = int(1000.*beta0)
        IF (index0 .ge. 940) then
          go to 200

        else
          frac0 = 1000.*beta0 - float(index0)

          q0 = f1(index0) + dble(frac0)*(f1(index0+1)-f1(index0))
          q1 = q0 + dble(dpmin(i)*bumin*seclm(1)/xmas)

          IF (debug) then
            write (6,1130) index0, frac0, q0, q1
1130        format ('              index0:',I10 /
     >              '               frac0:',F10.6 /
     >              '                  Q0:',F10.6 /
     >              '                  Q1:',F10.6)
          endif

          IF (q1 .ge. f1(940)) then
            go to 200

          else
C
C   Full calculation for beta < 0.94:
C
            i1 = index0
            i2 = 940
            a1 = f1(i1)
            a2 = f1(i2)

 150        continue

            im = (i1+i2)/2
            am = f1(im)

            IF (debug) then
              write (6,1150) i1, a1, im, am, i2, a2
1150          format (' i1 a1 im am i2 a2:',3(i6,f10.6))
            endif

            IF (q1 .gt. am) then
              i1 = im
              a1 = am
            else
              i2 = im
              a2 = am
            endif

            IF (i2-i1 .gt. 1) go to 150

            beta1 = (float(i1) + sngl((q1-a1)/(a2-a1)))/1000.
            ptot1 = xmas*beta1/sqrt(1.-beta1**2)

            IF (debug) then
              write (6,1170) ptot1, beta1
1170          format ('                  P1:',F10.6 /
     >                '               beta1:',F10.6)
            endif

            index1 = int(1000.*beta1)
            frac1 = 1000.*beta1 - float(index1)
            q0 = f2(index0) + dble(frac0)*(f2(index0+1)-f2(index0))
            q1 = f2(index1) + dble(frac1)*(f2(index1+1)-f2(index1))
            delth2 = xmcs*radl(i)*sngl(q1-q0)/dpmin(i)/bumin/xmas

            IF (debug) then
              write (6,1171) index1, frac1
1171          format ('              INDEX1:',I10 /
     >                '               FRAC1:',F10.6)
              write (6,1180) q0, q1, delth2
1180          format ('                  Q0:',F10.6 /
     >                '                  Q1:',F10.6 /
     >                '              DELTH2:',F10.6)
            endif

          endif
        endif
        go to 250

 200    continue
C
C  Ultra-relativistic particles:
C
        ptot1 = ptot0 + dpmin(i)*seclm(1)
        beta1 = ptot1 / sqrt(xmas**2+ptot1**2)
        delth2 = xmcs*radl(i)*seclm(1) / (beta1*ptot1)**2
C
C--------------------------------------------------------------------C
C
 250    continue
C
C  Correction in phi and xi:
C  [Notice that xi = XM*sin(phi) - YM*cos(phi).]
C
        dphidk = float(ichg)*rscatr(i)*bc
        delphi = dphidk*seclm(1)*(1./ptot1 - 1./ptot0)
        delxi = rscatr(i)*delphi/2.

        tkpar(4) = tkpar(4) + sin(tkpar(1))*delxi
        tkpar(5) = tkpar(5) - cos(tkpar(1))*delxi

        tkpar(1) = tkpar(1) + delphi
        IF (tkpar(1) .lt. 0.)    tkpar(1) = tkpar(1) + twopi
        IF (tkpar(1) .gt. twopi) tkpar(1) = tkpar(1) - twopi

        ptot0 = ptot1
        beta0 = beta1


        sigk = 2.*alphat(i)*seclm(1) / beta1**3 / ptot1**2
        sigphi = dphidk*sigk
        sigxi  = sigphi*rscatr(i)/2.
        if(iversion.le.7)goto 300
C
C  Correct error matrix for dE/dx losses.
C
C  d phi d phi
        error(1) = error(1) + sigphi**2

C  d phi dk
        error(2) = error(2) + sigk*sigphi

C  dk    dk
        error(3) = error(3) + sigk**2

C  d phi d xi
        error(7) = error(7) + sigphi*sigxi

C  dk    d xi
        error(8) = error(8) + sigk*sigxi

C  d xi  d xi
        error(10) = error(10) + sigxi**2

C
C--------------------------------------------------------------------C
C
C  Correct error matrix for multiple scattering.
C
C  d phi d phi
        error(1) = error(1) + delth2*seclm(2)

C  ds    ds
        error(6) = error(6) + delth2*seclm(4)

C  d phi d xi
        error(7) = error(7) + delth2*seclm(2)*rscatr(i)

C  d xi  d xi
        error(10) = error(10) + delth2*seclm(2)*rscatr(i)**2

C  ds    d eta
        error(13) = error(13) + delth2*seclm(4)*rscatr(i)

C  d eta d eta
        error(15) = error(15) + delth2*seclm(4)*rscatr(i)**2

 300  continue

cluf----------------------------------------------------begin
c-  re-scale MDC error matrix


c--for DATA          

             if(irun.gt.0) then

              if(irun.ge.13500.and.irun.le.13520) then
                L1=1.388
                L2=1.789
                L3=2.463
cxugf              end if
              else if(irun.ge.13521.and.irun.le.13540) then
                L1=1.338
                L2=1.571
                L3=2.449
c              end if
              else if(irun.ge.13541.and.irun.le.13555) then
                L1=1.306
                L2=1.553
                L3=2.013
c              end if

              else if(irun.ge.13556.and.irun.le.13580) then
                L1=1.275
                L2=1.524
                L3=1.921
c              end if

              else if(irun.ge.13581.and.irun.le.13605) then
                L1=1.293
                L2=1.545
                L3=1.922
c              end if

              else if(irun.ge.13606.and.irun.le.13625) then
                L1=1.360
                L2=1.616
                L3=2.045
c              end if

              else if(irun.ge.13626.and.irun.le.13655) then
                L1=1.33
                L2=1.57
                L3=2.077
c              end if

              else if(irun.ge.13656.and.irun.le.13690) then
                L1=1.316
                L2=1.613
                L3=2.092
c              end if

              else if(irun.ge.13691.and.irun.le.13710) then
                L1=1.277
                L2=1.500
                L3=1.754
c              end if


              else if(irun.ge.13711.and.irun.le.13740) then
                L1=1.191
                L2=1.300
                L3=1.508
c              end if

              else if(irun.ge.13741.and.irun.le.13790) then
                L1=1.216
                L2=1.315
                L3=1.559
c              end if


              else if(irun.ge.13791.and.irun.le.13855) then
                L1=1.346
                L2=1.612
                L3=1.834
c              end if

              else if(irun.ge.13856.and.irun.le.13865) then
                L1=1.298
                L2=1.446
                L3=1.693
c              end if

              else if(irun.ge.13866.and.irun.le.13940) then
                L1=1.252
                L2=1.347
                L3=1.565
c              end if

              else if(irun.ge.13941.and.irun.le.13950) then
                L1=1.233
                L2=1.458
                L3=1.597
c              end if

              else if(irun.ge.13951.and.irun.le.13975) then
                L1=1.282
                L2=1.462
                L3=1.710
c              end if

              else if(irun.ge.13976.and.irun.le.13985) then
                L1=1.310
                L2=1.539
                L3=1.714
c              end if

              else if(irun.ge.13986.and.irun.le.14015) then
                L1=1.295
                L2=1.45
                L3=1.71
c              end if

              else if(irun.ge.14016.and.irun.le.14030) then
                L1=1.353
                L2=1.581
                L3=1.718
c              end if

              else if(irun.ge.14031.and.irun.le.14055) then
                L1=1.33
                L2=1.547
                L3=1.726
c              end if

              else if(irun.ge.14056.and.irun.le.14080) then
                L1=1.324
                L2=1.475
                L3=1.694
c              end if

              else if(irun.ge.14081.and.irun.le.14095) then
                L1=1.345
                L2=1.534
                L3=1.663
c              end if

              else if(irun.ge.14096.and.irun.le.14140) then
                L1=1.276
                L2=1.452
                L3=1.688
c              end if

              else if(irun.ge.14141.and.irun.le.14145) then
                L1=1.387
                L2=1.727
                L3=1.926
c              end if

              else if(irun.ge.14146.and.irun.le.14150) then
                L1=1.356
                L2=1.744
                L3=2.142
c              end if

              else if(irun.ge.14151.and.irun.le.14155) then
                L1=1.284
                L2=1.527
                L3=1.680
c              end if

              else if(irun.ge.14156.and.irun.le.14160) then
                L1=1.242
                L2=1.460
                L3=1.56
c              end if

              else if(irun.ge.14161.and.irun.le.14200) then
                L1=1.27
                L2=1.427
                L3=1.644
c              end if

              else if(irun.ge.14201.and.irun.le.14220) then
                L1=1.28
                L2=1.385
                L3=1.583
c              end if

              else if(irun.ge.14221.and.irun.le.14275) then
                L1=1.246
                L2=1.320
                L3=1.557
c              end if

              else if(irun.ge.14276.and.irun.le.14280) then
                L1=1.13
                L2=1.261
                L3=1.526
c              end if

              else if(irun.ge.14281.and.irun.le.14295) then
                L1=1.25
                L2=1.38
                L3=1.59
c              end if

              else if(irun.ge.14296.and.irun.le.14300) then
                L1=1.232
                L2=1.343
                L3=1.521
c              end if

              else if(irun.ge.14301.and.irun.le.14310) then
                L1=1.264
                L2=1.384
                L3=1.548
c              end if

              else if(irun.ge.14311.and.irun.le.14320) then
                L1=1.25
                L2=1.321
                L3=1.579
c              end if

              else if(irun.ge.14321.and.irun.le.14325) then
                L1=1.17
                L2=1.334
                L3=1.379
c              end if

              else if(irun.ge.14326.and.irun.le.14330) then
                L1=1.194
                L2=1.312
                L3=1.558
c              end if

              else if(irun.ge.14331.and.irun.le.14345) then
                L1=1.321
                L2=1.462
                L3=1.688
c              end if

              else if(irun.ge.14346.and.irun.le.14360) then
                L1=1.285
                L2=1.332
                L3=1.579
c              end if

              else if(irun.ge.14361.and.irun.le.14380) then
                L1=1.214
                L2=1.295
                L3=1.547
c              end if

              else if(irun.ge.14381.and.irun.le.14425) then
                L1=1.261
                L2=1.357
                L3=1.621
c              end if

              else if(irun.ge.14426.and.irun.le.14440) then
                L1=1.223
                L2=1.292
                L3=1.571
c              end if

              else if(irun.ge.14441.and.irun.le.14495) then
                L1=1.233
                L2=1.327
                L3=1.595
c              end if

              else if(irun.ge.14496.and.irun.le.14550) then
                L1=1.258
                L2=1.341
                L3=1.54
c              end if

              else if(irun.ge.14551.and.irun.le.14565) then
                L1=1.185
                L2=1.247
                L3=1.491
c              end if

              else if(irun.ge.14566.and.irun.le.14580) then
                L1=1.238
                L2=1.297
                L3=1.532
c              end if

              else if(irun.ge.14581.and.irun.le.14590) then
                L1=1.229
                L2=1.306
                L3=1.606
c              end if

              else if(irun.ge.14591.and.irun.le.14600) then
                L1=1.212
                L2=1.274
                L3=1.466
c              end if

              else if(irun.ge.14601.and.irun.le.14610) then
                L1=1.224
                L2=1.352
                L3=1.537
c              end if

              else if(irun.ge.14611.and.irun.le.14625) then
                L1=1.201
                L2=1.262
                L3=1.535
c              end if

              else if(irun.ge.14626.and.irun.le.14650) then
                L1=1.239
                L2=1.320
                L3=1.572
c              end if

              else if(irun.ge.14651.and.irun.le.14655) then
                L1=1.215
                L2=1.311
                L3=1.442
c              end if

              else if(irun.ge.14656.and.irun.le.14675) then
                L1=1.247
                L2=1.294
                L3=1.581
c              end if

              else if(irun.ge.14676.and.irun.le.14705) then
                L1=1.243
                L2=1.254
                L3=1.546
c              end if

              else if(irun.ge.14706.and.irun.le.14725) then
                L1=1.207
                L2=1.312
                L3=1.498
c              end if

              else if(irun.ge.14726.and.irun.le.14750) then
                L1=1.205
                L2=1.288
                L3=1.492
c              end if

              else if(irun.ge.14751.and.irun.le.14795) then
                L1=1.236
                L2=1.314
                L3=1.527
c              end if

              else if(irun.ge.14796.and.irun.le.14800) then
                L1=1.164
                L2=1.192
                L3=1.473
c              end if

              else if(irun.ge.14801.and.irun.le.14815) then
                L1=1.232
                L2=1.310
                L3=1.558
c              end if

              else if(irun.ge.14816.and.irun.le.14830) then
                L1=1.234
                L2=1.31
                L3=1.528
c              end if

              else if(irun.ge.14831.and.irun.le.14860) then
                L1=1.234
                L2=1.318
                L3=1.552
c              end if

              else if(irun.ge.14861.and.irun.le.14870) then
                L1=1.25
                L2=1.277
                L3=1.591
c              end if

              else if(irun.ge.14871.and.irun.le.14875) then
                L1=1.222
                L2=1.36
                L3=1.452
c              end if

              else if(irun.ge.14876.and.irun.le.14880) then
                L1=1.231
                L2=1.251
                L3=1.496
c              end if

              else if(irun.ge.14881.and.irun.le.14885) then
                L1=1.198
                L2=1.275
                L3=1.48
c              end if

              else if(irun.ge.14886.and.irun.le.14900) then
                L1=1.186
                L2=1.241
                L3=1.514
c              end if

              else if(irun.ge.14901.and.irun.le.14915) then
                L1=1.232
                L2=1.272
                L3=1.487
c              end if

              else if(irun.ge.14916.and.irun.le.14925) then
                L1=1.207
                L2=1.322
                L3=1.533
c              end if

              else if(irun.ge.14926.and.irun.le.14955) then
                L1=1.219
                L2=1.312
                L3=1.562
c              end if

              else if(irun.ge.14956.and.irun.le.15000) then
                L1=1.224
                L2=1.318
                L3=1.563
c              end if

              else if(irun.ge.15001.and.irun.le.15020) then
                L1=1.242
                L2=1.311
                L3=1.538
c              end if

              else if(irun.ge.15021.and.irun.le.15025) then
                L1=1.245
                L2=1.177
                L3=1.528
c              end if

              else if(irun.ge.15026.and.irun.le.15040) then
                L1=1.225
                L2=1.151
                L3=1.393
c              end if

              else if(irun.ge.15041.and.irun.le.15045) then
                L1=1.319
                L2=1.244
                L3=1.352
c              end if

              else if(irun.ge.15046.and.irun.le.15060) then
                L1=1.199
                L2=1.2
                L3=1.449
c              end if

              else if(irun.ge.15061.and.irun.le.15080) then
                L1=1.232
                L2=1.293
                L3=1.601
c              end if

cxugf              else if(irun.ge.15021.and.irun.le.15065) then
cxugf                L1=L1*1.031
cxugf                L2=L2*1.062
cxugf                L3=L3*1.023
cxugf              end if



              else if(irun.ge.15081.and.irun.le.15095) then
                L1=1.263
                L2=1.335
                L3=1.515
c              end if

              else if(irun.ge.15096.and.irun.le.15105) then
                L1=1.141
                L2=1.270
                L3=1.513
c              end if

              else if(irun.ge.15106.and.irun.le.15115) then
                L1=1.218
                L2=1.304
                L3=1.503
c              end if

              else if(irun.ge.15116.and.irun.le.15125) then
                L1=1.197
                L2=1.285
                L3=1.497
c              end if

              else if(irun.ge.15126.and.irun.le.15165) then
                L1=1.222
                L2=1.318
                L3=1.508
c              end if

              else if(irun.ge.15166.and.irun.le.15170) then
                L1=1.18
                L2=1.206
                L3=1.394
c              end if

              else if(irun.ge.15171.and.irun.le.15195) then
                L1=1.25
                L2=1.335
                L3=1.574
c              end if

              else if(irun.ge.15196.and.irun.le.15205) then
                L1=1.227
                L2=1.28
                L3=1.577
c              end if

              else if(irun.ge.15206.and.irun.le.15255) then
                L1=1.23
                L2=1.331
                L3=1.585
c              end if

              else if(irun.ge.15256.and.irun.le.15290) then
                L1=1.222
                L2=1.304
                L3=1.514
c              end if

              else if(irun.ge.15291.and.irun.le.15295) then
                L1=1.166
                L2=1.328
                L3=1.541
c              end if

              else if(irun.ge.15296.and.irun.le.15460) then
                L1=1.226
                L2=1.305
                L3=1.534
c              end if

              else if(irun.ge.15461.and.irun.le.15540) then
                L1=1.23
                L2=1.291
                L3=1.496
c              end if

              else if(irun.ge.15541.and.irun.le.15570) then
                L1=1.218
                L2=1.321
                L3=1.533
c              end if

              else if(irun.ge.15571.and.irun.le.15640) then
                L1=1.212
                L2=1.29
                L3=1.505
c              end if

              else if(irun.ge.15641.and.irun.le.15685) then
                L1=1.236
                L2=1.362
                L3=1.558
c              end if

              else if(irun.ge.15686.and.irun.le.15700) then
                L1=1.196
                L2=1.282
                L3=1.526
c              end if

              else if(irun.ge.15701.and.irun.le.15705) then
                L1=1.169
                L2=1.355
                L3=1.41
c              end if

              else if(irun.ge.15706.and.irun.le.15780) then
                L1=1.243
                L2=1.328
                L3=1.576
c              end if

              else if(irun.ge.15781.and.irun.le.15795) then
                L1=1.275
                L2=1.417
                L3=1.689
c              end if

              else if(irun.ge.15796.and.irun.le.15810) then
                L1=1.292
                L2=1.553
                L3=1.75
c              end if

              else if(irun.ge.15811.and.irun.le.15830) then
                L1=1.241
                L2=1.362
                L3=1.549
c              end if

              else if(irun.ge.15831.and.irun.le.15860) then
                L1=1.208
                L2=1.308
                L3=1.542
c              end if

              else if(irun.ge.15861.and.irun.le.15965) then
                L1=1.231
                L2=1.328
                L3=1.563
c              end if

              else if(irun.ge.15966.and.irun.le.15980) then
                L1=1.255
                L2=1.373
                L3=1.616
c              end if

              else if(irun.ge.15981.and.irun.le.16045) then
                L1=1.214
                L2=1.313
                L3=1.512
c              end if

              else if(irun.ge.16046.and.irun.le.16050) then
                L1=1.189
                L2=1.246
                L3=1.513
c              end if

              else if(irun.ge.16051.and.irun.le.16095) then
                L1=1.202
                L2=1.33
                L3=1.525
c              end if

              else if(irun.ge.16096.and.irun.le.16220) then
                L1=1.227
                L2=1.312
                L3=1.544
c              end if

              else if(irun.ge.16221.and.irun.le.16240) then
                L1=1.273
                L2=1.426
                L3=1.787
c              end if

              else if(irun.ge.16241.and.irun.le.16245) then
                L1=1.405
                L2=1.622
                L3=1.92
c              end if

              else if(irun.ge.16246.and.irun.le.16255) then
                L1=1.464
                L2=1.766
                L3=2.362
c              end if

              else if(irun.ge.16256.and.irun.le.16260) then
                L1=1.244
                L2=1.439
                L3=1.658
c              end if

              else if(irun.ge.16261.and.irun.le.16320) then
                L1=1.261
                L2=1.411
                L3=1.605
c              end if


              else if(irun.ge.16321.and.irun.le.16335) then
                L1=1.245
                L2=1.349
                L3=1.545
c              end if


              else if(irun.ge.16336.and.irun.le.16375) then
                L1=1.262
                L2=1.414
                L3=1.598
c              end if


              else if(irun.ge.16376.and.irun.le.16400) then
                L1=1.252
                L2=1.365
                L3=1.618
c              end if

              else if(irun.ge.16401.and.irun.le.16405) then
                L1=1.223
                L2=1.231
                L3=1.603
c              end if

              else if(irun.ge.16406.and.irun.le.16415) then
                L1=1.222
                L2=1.401
                L3=1.654
c              end if

              else if(irun.ge.16416.and.irun.le.16425) then
                L1=1.264
                L2=1.468
                L3=1.744
c              end if

              else if(irun.ge.16426.and.irun.le.16430) then
                L1=1.283
                L2=1.477
                L3=1.774
c              end if

              else if(irun.ge.16431.and.irun.le.16535) then
                L1=1.263
                L2=1.415
                L3=1.632
c              end if

              else if(irun.ge.16536.and.irun.le.16575) then
                L1=1.275
                L2=1.408
                L3=1.617
c              end if

              else if(irun.ge.16576.and.irun.le.16600) then
                L1=1.226
                L2=1.366
                L3=1.561
c              end if

              else if(irun.ge.16601.and.irun.le.16640) then
                L1=1.235
                L2=1.411
                L3=1.6
c              end if

              else if(irun.ge.16641.and.irun.le.16660) then
                L1=1.242
                L2=1.38
                L3=1.583
c              end if

              else if(irun.ge.16661.and.irun.le.16675) then
                L1=1.218
                L2=1.442
                L3=1.621
c              end if

              else if(irun.ge.16676.and.irun.le.16735) then
                L1=1.261
                L2=1.415
                L3=1.652
c              end if

              else if(irun.ge.16736.and.irun.le.16750) then
                L1=1.285
                L2=1.471
                L3=1.638
c              end if

              else if(irun.ge.16751.and.irun.le.16790) then
                L1=1.266
                L2=1.409
                L3=1.598
c              end if

              else if(irun.ge.16791.and.irun.le.16810) then
                L1=1.226
                L2=1.4
                L3=1.571
c              end if

              else if(irun.ge.16811.and.irun.le.16844) then
                L1=1.255
                L2=1.374
                L3=1.606
c              end if

c---XUGF, YUANJM ------
              else if(irun.ge.17209.and.irun.le.17216) then
                L1=1.258
                L2=1.351
                L3=1.475
              else if(irun.ge.17217.and.irun.le.17228) then
                L1=1.295
                L2=1.390
                L3=1.591
              else if(irun.ge.17229.and.irun.le.17251) then
                L1=1.298
                L2=1.399
                L3=1.595
              else if(irun.ge.17252.and.irun.le.17254) then
                L1=1.284
                L2=1.334
                L3=1.484
              else if(irun.ge.17255.and.irun.le.17275) then
                L1=1.270
                L2=1.396
                L3=1.519
              else if(irun.ge.17276.and.irun.le.17290) then
                L1=1.271
                L2=1.377
                L3=1.573
              else if(irun.ge.17291.and.irun.le.17298) then
                L1=1.342
                L2=1.495
                L3=1.719
              else if(irun.ge.17299.and.irun.le.17303) then
                L1=1.292
                L2=1.457
                L3=1.666
              else if(irun.ge.17304.and.irun.le.17306) then
                L1=1.215
                L2=1.362
                L3=1.500
              else if(irun.ge.17307.and.irun.le.17315) then
                L1=1.248
                L2=1.310
                L3=1.539
              else if(irun.ge.17316.and.irun.le.17318) then
                L1=1.214
                L2=1.350
                L3=1.539
              else if(irun.ge.17319.and.irun.le.17327) then
                L1=1.228
                L2=1.309
                L3=1.517
              else if(irun.ge.17328.and.irun.le.17331) then
                L1=1.254
                L2=1.349
                L3=1.519
              else if(irun.ne.17332) then
                L1=1.239
                L2=1.307
                L3=1.516
              else if(irun.ge.17333.and.irun.le.17338) then
                L1=1.247
                L2=1.319
                L3=1.513
              else if(irun.ge.17339.and.irun.le.17362) then
                L1=1.252
                L2=1.332
                L3=1.532
              else if(irun.ge.17363.and.irun.le.17379) then
                L1=1.258
                L2=1.345
                L3=1.534
              else if(irun.ge.17380.and.irun.le.17389) then
                L1=1.278
                L2=1.337
                L3=1.551
              else if(irun.ge.17390.and.irun.le.17401) then
                L1=1.296
                L2=1.430
                L3=1.706
              else if(irun.ge.17402.and.irun.le.17406) then
                L1=1.0
                L2=1.0
                L3=1.0
              else if(irun.ge.17407.and.irun.le.17412) then
                L1=1.258
                L2=1.331
                L3=1.543
              else if(irun.ge.17413.and.irun.le.17422) then
                L1=1.208
                L2=1.274
                L3=1.419
              else if(irun.ge.17423.and.irun.le.17442) then
                L1=1.287
                L2=1.354
                L3=1.507
              else if(irun.ge.17443.and.irun.le.17449) then
                L1=1.253
                L2=1.367
                L3=1.555
              else if(irun.ge.17450.and.irun.le.17451) then
                L1=1.234
                L2=1.332
                L3=1.532
              else if(irun.ge.17452.and.irun.le.17469) then
                L1=1.270
                L2=1.370
                L3=1.554
              else if(irun.ge.17470.and.irun.le.17472) then
                L1=1.332
                L2=1.447
                L3=1.578
              else if(irun.ge.17473.and.irun.le.17480) then
                L1=1.239
                L2=1.326
                L3=1.508
              else if(irun.ge.17481.and.irun.le.17502) then
                L1=1.243
                L2=1.331
                L3=1.497
              else if(irun.ge.17503.and.irun.le.17528) then
                L1=1.245
                L2=1.308
                L3=1.493
              else if(irun.ge.17529.and.irun.le.17533) then
                L1=1.222
                L2=1.283
                L3=1.498
              else if(irun.ge.17534.and.irun.le.17559) then
                L1=1.282
                L2=1.344
                L3=1.518
              else if(irun.ge.17560.and.irun.le.17576) then
                L1=1.241
                L2=1.306
                L3=1.490
              else if(irun.ge.17577.and.irun.le.17591) then
                L1=1.242
                L2=1.310
                L3=1.513
              else if(irun.ge.17592.and.irun.le.17604) then
                L1=1.237
                L2=1.318
                L3=1.489
              else if(irun.ge.17605.and.irun.le.17613) then
                L1=1.227
                L2=1.287
                L3=1.479
              else if(irun.ge.17614.and.irun.le.17627) then
                L1=1.228
                L2=1.301
                L3=1.493
              else if(irun.ge.17628.and.irun.le.17670) then
                L1=1.247
                L2=1.313
                L3=1.327
              else if(irun.ge.17671.and.irun.le.17696) then
                L1=1.270
                L2=1.334
                L3=1.527
              else if(irun.ge.17697.and.irun.le.17718) then
                L1=1.287
                L2=1.336
                L3=1.492
              else if(irun.ge.17719.and.irun.le.17729) then
                L1=1.251
                L2=1.330
                L3=1.482
              else if(irun.ge.17730.and.irun.le.17736) then
                L1=1.285
                L2=1.294
                L3=1.446
              else if(irun.ge.17737.and.irun.le.17742) then
                L1=1.287
                L2=1.309
                L3=1.478
              else if(irun.ge.17743.and.irun.le.17754) then
                L1=1.255
                L2=1.299
                L3=1.468
              else if(irun.ge.17755.and.irun.le.17757) then
                L1=1.227
                L2=1.281
                L3=1.437
              else if(irun.ge.17758.and.irun.le.17773) then
                L1=1.235
                L2=1.317
                L3=1.510
              else if(irun.ge.17774.and.irun.le.17790) then
                L1=1.248
                L2=1.311
                L3=1.500
              else if(irun.ge.17791.and.irun.le.17800) then
                L1=1.247
                L2=1.322
                L3=1.524
              else if(irun.ge.17801.and.irun.le.17822) then
                L1=1.249
                L2=1.320
                L3=1.502
              else if(irun.ge.17823.and.irun.le.17825) then
                L1=1.217
                L2=1.289
                L3=1.474
              else if(irun.ge.17826.and.irun.le.17847) then
                L1=1.237
                L2=1.300
                L3=1.492
              else if(irun.ge.17848.and.irun.le.17851) then
                L1=1.244
                L2=1.311
                L3=1.457
              else if(irun.ge.17852.and.irun.le.17865) then
                L1=1.293
                L2=1.335
                L3=1.521
              else if(irun.ge.17866.and.irun.le.17871) then
                L1=1.281
                L2=1.254
                L3=1.504
              else if(irun.ge.17872.and.irun.le.17888) then
                L1=1.285
                L2=1.352
                L3=1.501
              else if(irun.ge.17889.and.irun.le.17895) then
                L1=1.274
                L2=1.328
                L3=1.500
              else if(irun.ge.17896.and.irun.le.17899) then
                L1=1.257
                L2=1.346
                L3=1.533
              else if(irun.ge.17900.and.irun.le.17906) then
                L1=1.271
                L2=1.338
                L3=1.495
              else if(irun.ge.17907.and.irun.le.17935) then
                L1=1.278
                L2=1.348
                L3=1.517
              else if(irun.ge.17936.and.irun.le.17962) then
                L1=1.254
                L2=1.319
                L3=1.466
              else if(irun.ge.17963.and.irun.le.17966) then
                L1=1.287
                L2=1.330
                L3=1.515
              else if(irun.ge.17967.and.irun.le.18005) then
                L1=1.310
                L2=1.406
                L3=1.582
              else if(irun.ge.18006.and.irun.le.18016) then
                L1=1.306
                L2=1.372
                L3=1.528
              else if(irun.ge.18017.and.irun.le.18037) then
                L1=1.322
                L2=1.398
                L3=1.562
              else if(irun.ge.18038.and.irun.le.18048) then
                L1=1.313
                L2=1.379
                L3=1.570
              else if(irun.ge.18049.and.irun.le.18066) then
                L1=1.295
                L2=1.378
                L3=1.572
              else if(irun.ge.18067.and.irun.le.18085) then
                L1=1.304
                L2=1.355
                L3=1.558
              else if(irun.eq.18086) then
                L1=1.322
                L2=1.346
                L3=1.503
              else if(irun.ge.18087.and.irun.le.18093) then
                L1=1.412
                L2=1.501
                L3=1.806
              else if(irun.ge.18094.and.irun.le.18096) then
                L1=1.455
                L2=1.939
                L3=2.463
              else if(irun.ge.18097.and.irun.le.18122) then
                L1=1.324
                L2=1.464
                L3=1.711
              else if(irun.ge.18123.and.irun.le.18133) then
                L1=1.305
                L2=1.365
                L3=1.545
              else if(irun.ge.18134.and.irun.le.18156) then
                L1=1.314
                L2=1.365
                L3=1.558
              else if(irun.ge.18157.and.irun.le.18182) then
                L1=1.265
                L2=1.322
                L3=1.508
              else if(irun.ge.18183.and.irun.le.18197) then
                L1=1.287
                L2=1.346
                L3=1.520
              else if(irun.ge.18198.and.irun.le.18221) then
                L1=1.266
                L2=1.339
                L3=1.524
              else if(irun.ge.18222.and.irun.le.18245) then
                L1=1.262
                L2=1.309
                L3=1.494
              else if(irun.ge.18246.and.irun.le.18264) then
                L1=1.280
                L2=1.373
                L3=1.505
              else if(irun.ge.18265.and.irun.le.18289) then
                L1=1.296
                L2=1.388
                L3=1.546
              else if(irun.ge.18290.and.irun.le.18296) then
                L1=1.0
                L2=1.0
                L3=1.0
              else if(irun.ge.18297.and.irun.le.18310) then
                L1=1.267
                L2=1.354
                L3=1.543
              else if(irun.ge.18311.and.irun.le.18326) then
                L1=1.272
                L2=1.354
                L3=1.532
              else if(irun.ge.18327.and.irun.le.18354) then
                L1=1.302
                L2=1.378
                L3=1.549
              else if(irun.ge.18355.and.irun.le.18389) then
                L1=1.280
                L2=1.346
                L3=1.517
              else if(irun.ge.18390.and.irun.le.18393) then
                L1=1.275
                L2=1.386
                L3=1.486
              else if(irun.ge.18394.and.irun.le.18411) then
                L1=1.277
                L2=1.356
                L3=1.538
              else if(irun.ge.18412.and.irun.le.18441) then
                L1=1.306
                L2=1.394
                L3=1.548
              else if(irun.ge.18442.and.irun.le.18443) then
                L1=1.244
                L2=1.297
                L3=1.398
              else if(irun.ge.18444.and.irun.le.18452) then
                L1=1.258
                L2=1.353
                L3=1.498
              else if(irun.ge.18453.and.irun.le.18463) then
                L1=1.265
                L2=1.325
                L3=1.489
              else if(irun.ge.18464.and.irun.le.18483) then
                L1=1.269
                L2=1.332
                L3=1.480
              else if(irun.ge.18484.and.irun.le.18486) then
                L1=1.275
                L2=1.341
                L3=1.509
              else if(irun.eq.18487) then
                L1=1.245
                L2=1.361
                L3=1.662
              else if(irun.ge.18488.and.irun.le.18506) then
                L1=1.306
                L2=1.345
                L3=1.547
              else if(irun.ge.18507.and.irun.le.18518) then
                L1=1.296
                L2=1.381
                L3=1.562
              else if(irun.ge.18519.and.irun.le.18522) then
                L1=1.302
                L2=1.383
                L3=1.567
              else if(irun.ge.18523.and.irun.le.18545) then
                L1=1.296
                L2=1.377
                L3=1.540
              else if(irun.ge.18546.and.irun.le.18591) then
                L1=1.314
                L2=1.391
                L3=1.590
              else if(irun.ge.18592.and.irun.le.18597) then
                L1=1.276
                L2=1.332
                L3=1.511
              else if(irun.ge.18598.and.irun.le.18604) then
                L1=1.264
                L2=1.339
                L3=1.558
              else if(irun.ge.18605.and.irun.le.18633) then
                L1=1.283
                L2=1.360
                L3=1.544
              else if(irun.ge.18634.and.irun.le.18641) then
                L1=1.346
                L2=1.467
                L3=1.696
              else if(irun.ge.18642.and.irun.le.18648) then
                L1=1.309
                L2=1.572
                L3=1.609
              else if(irun.ge.18649.and.irun.le.18678) then
                L1=1.275
                L2=1.351
                L3=1.554
              else if(irun.eq.18679) then
                L1=1.276
                L2=1.284
                L3=1.520
              else if(irun.ge.18680.and.irun.le.18701) then
                L1=1.288
                L2=1.369
                L3=1.539
              else if(irun.eq.18702) then
                L1=1.226
                L2=1.329
                L3=1.412
              else if(irun.ge.18703.and.irun.le.18731) then
                L1=1.228
                L2=1.329
                L3=1.412
              else if(irun.ge.18732.and.irun.le.18746) then
                L1=1.262
                L2=1.329
                L3=1.494
              else if(irun.ge.18747.and.irun.le.18771) then
                L1=1.268
                L2=1.333
                L3=1.577
              else if(irun.ge.18772.and.irun.le.18777) then
                L1=1.283
                L2=1.358
                L3=1.607
              else if(irun.ge.18778.and.irun.le.18779) then
                L1=1.231
                L2=1.306
                L3=1.486
              else if(irun.ge.18780.and.irun.le.18794) then
                L1=1.269
                L2=1.365
                L3=1.573
              else if(irun.ge.18795.and.irun.le.18823) then
                L1=1.263
                L2=1.333
                L3=1.497
              else if(irun.ge.18824.and.irun.le.18825) then
                L1=1.206
                L2=1.222
                L3=1.453
              else if(irun.ge.18826.and.irun.le.18827) then
                L1=1.253
                L2=1.357
                L3=1.542
              else if(irun.ge.18828.and.irun.le.18841) then
                L1=1.286
                L2=1.364
                L3=1.666
              else if(irun.ge.18842.and.irun.le.18846) then
                L1=1.248
                L2=1.317
                L3=1.486
              else if(irun.ge.18847.and.irun.le.18866) then
                L1=1.280
                L2=1.355
                L3=1.513
              else if(irun.ge.18867.and.irun.le.18885) then
                L1=1.273
                L2=1.361
                L3=1.546
              else if(irun.ge.18886.and.irun.le.18891) then
                L1=1.264
                L2=1.368
                L3=1.528
              else if(irun.ge.18892.and.irun.le.18906) then
                L1=1.291
                L2=1.382
                L3=1.523
              else if(irun.ge.18907.and.irun.le.18912) then
                L1=1.255
                L2=1.325
                L3=1.483
              else if(irun.ge.18913.and.irun.le.18931) then
                L1=1.323
                L2=1.415
                L3=1.615
              else if(irun.ge.18932.and.irun.le.18956) then
                L1=1.305
                L2=1.396
                L3=1.541
              else if(irun.ge.18957.and.irun.le.18962) then
                L1=1.287
                L2=1.392
                L3=1.512
              else if(irun.ge.18963.and.irun.le.18980) then
                L1=1.294
                L2=1.366
                L3=1.537
              else if(irun.ge.18981.and.irun.le.18992) then
                L1=1.298
                L2=1.377
                L3=1.503
              else if(irun.ge.18993.and.irun.le.19006) then
                L1=1.278
                L2=1.366
                L3=1.523
              else if(irun.ge.19007.and.irun.le.19025) then
                L1=1.279
                L2=1.356
                L3=1.513
              else if(irun.ge.19026.and.irun.le.19052) then
                L1=1.258
                L2=1.331
                L3=1.513
              else if(irun.ge.19053.and.irun.le.19073) then
                L1=1.278
                L2=1.349
                L3=1.534
              else if(irun.ge.19074.and.irun.le.19093) then
                L1=1.270
                L2=1.344
                L3=1.507
              else if(irun.ge.19094.and.irun.le.19117) then
                L1=1.251
                L2=1.325
                L3=1.509
              else if(irun.ge.19118.and.irun.le.19135) then
                L1=1.271
                L2=1.335
                L3=1.477
              else if(irun.ge.19136.and.irun.le.19149) then
                L1=1.266
                L2=1.354
                L3=1.520
              else
                L1=1.000
                L2=1.000
                L3=1.000
              end if

              if(irun.ge.15021.and.irun.le.15065) then
                L1=L1*1.031
                L2=L2*1.062
                L3=L3*1.023
              end if

c--- xugf,yuanjm -----
c-for MC
             else
cxugf               if(irun.lt.0) then
               L1=1.0028
               L2=1.2235
               L3=1.3344
             end if

             error(1)=error(1)*L1*L1
             error(2)=error(2)*L1*L2
             error(3)=error(3)*L2*L2
             error(4)=error(4)*L1*L3
             error(5)=error(5)*L2*L3
             error(6)=error(6)*L3*L3
cluf-------------------------------------------------end

      if(iversion.eq.86.and.iversion.ne.831)then

clhb----------------mike kelsey's dedx correction-----------------------
        idp=4
        if(xmas.le.0.01)idp=2
        if(abs(xmas-0.10566).le.0.005)idp=3
        if(abs(xmas-0.49365).le.0.005)idp=5
        if(abs(xmas-0.93827).le.0.005)idp=6
        bp=bpfrac(idp,psav,thta)
        if(bp.eq.0.)bp=1.
        tkpar(2)=tkpar2/bp
        tkpar(3)=tkpar3
        tkpar(1)=tkpar1
         return
clhb-------------------------------------------------------------------
        endif
c      tkpar(2) = seclm(1) / ptot0

cluf----------------BESII dedx correction-----------------------begin
      if(iversion.gt.100.and.iversion.ne.831)then
        idp=4
        if(abs(xmas-0.000511).le.0.0003) idp=2
        if(abs(xmas-0.10566).le.0.005) idp=3
        if(abs(xmas-0.49365).le.0.005) idp=5
        if(abs(xmas-0.93827).le.0.005) idp=6

c--dE/dX correction for 1/Pxy
        bp=bpcorr2(idp,psav,thta)/psav
        if(bp.eq.0.) bp=1.
        tkpar(2)=tkpar2/bp
        tkpar(3)=tkpar3
        tkpar(1)=tkpar1
         return
        endif
cluf---------------------------------------------------------------end
      return
      end
